[![codecov](https://codecov.io/gh/dynarejulia/FastLapackInterface.jl/branch/main/graph/badge.svg?token=3VH7VTUQNR)](https://codecov.io/gh/dynarejulia/FastLapackInterface.jl)
[![](https://img.shields.io/badge/docs-latest-blue.svg)](https://dynarejulia.github.io/FastLapackInterface.jl/dev/)

``FastLapackInterface`` separates workspace allocation and actual
running for some Lapack algorithms:
 
 - Bunch-Kaufman decomposition
 - Cholesky decomposition
 - Eigen decomposition
 - LSE decomposition
 - LU factorization
 - QR factorization
 - Schur factorization
 - SVD decomposition
 
The API follows the Base julia `LAPACK` definitions and should thus be very transparent.
There is also a unified interface which returns the right `Workspace` to be used with a given
`LAPACK` function.
e.g.
```julia
A = [1.2 2.3
     6.2 3.3]
ws = Workspace(LAPACK.getrf!, A)
decompose!(ws, A)
```
A similar API exists for the above decompositions. For more information and examples please see the [documentation](https://dynarejulia.github.io/FastLapackInterface.jl/dev/).

## Compatibility with MKL
- this package works also with MKL
- OpenBlas and MKL don't compute the required workspace size of some
  functions the same way. 

## Package version
-   v1.x: works only with Julia >= 1.10.7

using Test
using FastLapackInterface
using LinearAlgebra.LAPACK

@testset "BunchKaufmanWs" begin
    n = 10
    for T in (Float32, Float64, ComplexF32, ComplexF64)
        @testset "$(T) sytrf!" begin
            A = rand(T, n, n)
            A = (A .+ transpose(A)) ./ 2
            ws = BunchKaufmanWs(copy(A))
            
            A1, ipiv1, inf1 = LAPACK.sytrf!(ws, 'U', copy(A)) 
            A2, ipiv2, inf2 = LAPACK.sytrf!('U', copy(A))
            @test A1 == A2
            @test ipiv1 == ipiv2

            ws = Workspace(LAPACK.sytrf!, copy(A))
            A1, ipiv1, inf1 = decompose!(ws, Symmetric(copy(A)))
            @test A1 == A2
            @test ipiv1 == ipiv2
            
            A1, ipiv1, inf1 = decompose!(ws, 'U', copy(A))
            @test A1 == A2
            @test ipiv1 == ipiv2
            for div in (-1,1)
                @test_throws FastLapackInterface.WorkspaceSizeError decompose!(ws, Symmetric(rand(T, n+div, n+div)); resize=false)
                decompose!(ws, Symmetric(rand(T, n+div, n+div)))
                @test length(ws.ipiv) == n+div
            end
        end
        @testset "$(T) sytrf_rook!" begin
            A = rand(T, n, n)
            A = (A .+ transpose(A))./2
            ws = BunchKaufmanWs(copy(A))
            
            A1, ipiv1, inf1 = LAPACK.sytrf_rook!(ws, 'U', copy(A)) 
            A2, ipiv2, inf2 = LAPACK.sytrf_rook!('U', copy(A))
            @test A1 == A2
            @test ipiv1 == ipiv2
            
            ws = Workspace(LAPACK.sytrf!, copy(A))
            A1, ipiv1, inf1 = decompose!(ws,  Symmetric(copy(A)); rook=true)
            @test A1 == A2
            @test ipiv1 == ipiv2
            
            A1, ipiv1, inf1 = decompose!(ws, 'U', copy(A); rook=true)
            @test A1 == A2
            @test ipiv1 == ipiv2
        end
    end
    for T in (ComplexF32, ComplexF64)
        @testset "$(T) hetrf!" begin
            A = rand(T, n, n)
            A = (A .+ A')./2
            ws = BunchKaufmanWs(copy(A))
            
            A1, ipiv1, inf1 = LAPACK.hetrf!(ws, 'U', copy(A)) 
            A2, ipiv2, inf2 = LAPACK.hetrf!('U', copy(A))
            @test A1 == A2
            @test ipiv1 == ipiv2

            ws = Workspace(LAPACK.hetrf!, copy(A))
            A1, ipiv1, inf1 = decompose!(ws, Hermitian(copy(A)))
            @test A1 == A2
            @test ipiv1 == ipiv2
            
            A1, ipiv1, inf1 = decompose!(ws, 'U', copy(A))
            @test A1 == A2
            @test ipiv1 == ipiv2
        end
        @testset "$(T) hetrf_rook!" begin
            A = rand(T, n, n)
            A = (A .+ A')./2
            ws = BunchKaufmanWs(copy(A))
            
            A1, ipiv1, inf1 = LAPACK.hetrf_rook!(ws, 'U', copy(A)) 
            A2, ipiv2, inf2 = LAPACK.hetrf_rook!('U', copy(A))
            @test A1 == A2
            @test ipiv1 == ipiv2
            
            ws = Workspace(LAPACK.hetrf!, copy(A))
            A1, ipiv1, inf1 = decompose!(ws,  Hermitian(copy(A)), rook=true)
            @test A1 == A2
            @test ipiv1 == ipiv2
            A1, ipiv1, inf1 = decompose!(ws, 'U', copy(A); rook=true)
            @test A1 == A2
            @test ipiv1 == ipiv2
        end
    end
end

struct SingularException <: Exception end

struct DggesException <: Exception
    error_nbr::Int
end

Base.showerror(io::IO, e::DggesException) = print(io, "dgges error ", e.error_nbr)

struct WorkspaceSizeError <: Exception
    nws::Int
    n::Int
end
function Base.showerror(io::IO, e::WorkspaceSizeError)
    print(io,
        "Workspace has the wrong size: expected $(e.n), got $(e.nws).\nUse resize!(ws, A).")
end

using LinearAlgebra.LAPACK: chkuplo
import LinearAlgebra.LAPACK: sytrf!, sytrf_rook!, hetrf!, hetrf_rook!

"""
    BunchKaufmanWs

Workspace for [`LinearAlgebra.BunchKaufman`](https://docs.julialang.org/en/v1/stdlib/LinearAlgebra/#LinearAlgebra.BunchKaufman)
factorization using the [`LAPACK.sytrf!`](@ref) or [`LAPACK.sytrf_rook!`](@ref) functions for symmetric matrices, and [`LAPACK.hetrf!`](@ref) or [`LAPACK.hetrf_rook!`](@ref) functions for hermitian matrices (e.g. with `ComplexF64` or `ComplexF32` elements).

# Examples
```jldoctest
julia> A = [1.2 7.8
            7.8 3.3]
2×2 Matrix{Float64}:
 1.2  7.8
 7.8  3.3

julia> ws = BunchKaufmanWs(A)
BunchKaufmanWs{Float64}
  work: 128-element Vector{Float64}
  ipiv: 2-element Vector{Int64}


julia> A, ipiv, info = LAPACK.sytrf!(ws, 'U', A)
([1.2 7.8; 7.8 3.3], [-1, -1], 0)

julia> t = LinearAlgebra.BunchKaufman(A, ipiv,'U', true, false, info)
BunchKaufman{Float64, Matrix{Float64}, Vector{Int64}}
D factor:
2×2 Tridiagonal{Float64, Vector{Float64}}:
 1.2  7.8
 7.8  3.3
U factor:
2×2 UnitUpperTriangular{Float64, Matrix{Float64}}:
 1.0  0.0
  ⋅   1.0
permutation:
2-element Vector{Int64}:
 1
 2

julia> A = [1.2 7.8
            7.8 3.3]
2×2 Matrix{Float64}:
 1.2  7.8
 7.8  3.3

julia> ws = BunchKaufmanWs(A)
BunchKaufmanWs{Float64}
  work: 128-element Vector{Float64}
  ipiv: 2-element Vector{Int64}


julia> A, ipiv, info = LAPACK.sytrf_rook!(ws, 'U', A)
([1.2 7.8; 7.8 3.3], [-1, -2], 0)

julia> t = LinearAlgebra.BunchKaufman(A, ipiv,'U', true, true, info)
BunchKaufman{Float64, Matrix{Float64}, Vector{Int64}}
D factor:
2×2 Tridiagonal{Float64, Vector{Float64}}:
 1.2  7.8
 7.8  3.3
U factor:
2×2 UnitUpperTriangular{Float64, Matrix{Float64}}:
 1.0  0.0
  ⋅   1.0
permutation:
2-element Vector{Int64}:
 1
 2
```
"""
struct BunchKaufmanWs{T} <: Workspace
    work::Vector{T}
    ipiv::Vector{BlasInt}
end

for (sytrfs, elty) in (((:dsytrf_, :dsytrf_rook_), :Float64),
    ((:ssytrf_, :ssytrf_rook_), :Float32),
    ((:zsytrf_, :zsytrf_rook_, :zhetrf_, :zhetrf_rook_), :ComplexF64),
    ((:csytrf_, :csytrf_rook_, :chetrf_, :chetrf_rook_), :ComplexF32))
    @eval begin
        function Base.resize!(ws::BunchKaufmanWs, A::AbstractMatrix{$elty}; work = true)
            chkstride1(A)
            n = checksquare(A)
            if n == 0
                return ws
            end
            resize!(ws.ipiv, n)
            if work
                info = Ref{BlasInt}()
                ccall((@blasfunc($(sytrfs[1])), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                        Ptr{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{BlasInt}, Clong),
                    'U', n, A, stride(A, 2), ws.ipiv, ws.work, -1, info, 1)
                chkargsok(info[])
                resize!(ws.work, BlasInt(real(ws.work[1])))
            end
            return ws
        end
        function BunchKaufmanWs(A::AbstractMatrix{$elty})
            return resize!(BunchKaufmanWs(Vector{$elty}(undef, 1), BlasInt[]), A)
        end
    end
    for (sytrf, fn) in zip(sytrfs, (:sytrf!, :sytrf_rook!, :hetrf!, :hetrf_rook!))
        @eval function $fn(ws::BunchKaufmanWs{$elty}, uplo::AbstractChar,
                A::AbstractMatrix{$elty}; resize = true)
            chkstride1(A)
            n = checksquare(A)
            if n == 0
                return A, ws.ipiv, zero(BlasInt)
            end
            chkuplo(uplo)
            nws = length(ws.ipiv)
            if n != nws
                if resize
                    resize!(ws, A, work = nws < n)
                else
                    throw(WorkspaceSizeError(nws, n))
                end
            end
            info = Ref{BlasInt}()
            ccall((@blasfunc($sytrf), liblapack), Cvoid,
                (Ref{UInt8}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                    Ptr{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{BlasInt}, Clong),
                uplo, n, A, stride(A, 2), ws.ipiv, ws.work, length(ws.work), info, 1)
            chkargsok(info[])
            return A, ws.ipiv, info[]
        end
    end
end

"""
    sytrf!(ws, uplo, A; resize=true) -> (A, ws.ipiv, info)

Computes the Bunch-Kaufman factorization of a symmetric matrix `A`,
using previously allocated workspace `ws`.
If the workspace was too small and `resize==true` it will automatically resized.
If `uplo = U`, the upper half of `A` is stored. If `uplo = L`, the lower
half is stored.

Returns `A`, overwritten by the factorization, a pivot vector `ws.ipiv`, and
the error code `info` which is a non-negative integer. If `info` is positive
the matrix is singular and the diagonal part of the factorization is exactly
zero at position `info`.
"""
sytrf!(ws::BunchKaufmanWs, uplo::AbstractChar, A::AbstractMatrix; kwargs...)

"""
    sytrf_rook!(ws, uplo, A; resize=true) -> (A, ws.ipiv, info)

Similar to [`sytrf!`](@ref) but using the bounded ("rook") diagonal pivoting method.
"""
sytrf_rook!(ws::BunchKaufmanWs, uplo::AbstractChar, A::AbstractMatrix; kwargs...)

"""
    hetrf!(ws, uplo, A; resize=true) -> (A, ws.ipiv, info)

Similar as [`sytrf!`](@ref) but for Hermitian matrices.
"""
hetrf!(ws::BunchKaufmanWs, uplo::AbstractChar, A::AbstractMatrix; kwargs...)

"""
    hetrf_rook!(ws, uplo, A; resize=true) -> (A, ws.ipiv, info)

Similar to [`hetrf!`](@ref) but using the bounded ("rook") diagonal pivoting method.
"""
hetrf_rook!(ws::BunchKaufmanWs, uplo::AbstractChar, A::AbstractMatrix; kwargs...)

import LinearAlgebra.LAPACK: gglse!

"""
    LSEWs

Workspace for the least squares solving function [`LAPACK.geqrf!`](@ref).

# Examples
```jldoctest
julia> A = [1.2 2.3 6.2
            6.2 3.3 8.8
            9.1 2.1 5.5]
3×3 Matrix{Float64}:
 1.2  2.3  6.2
 6.2  3.3  8.8
 9.1  2.1  5.5

julia> B = [2.7 3.1 7.7
            4.1 8.1 1.8]
2×3 Matrix{Float64}:
 2.7  3.1  7.7
 4.1  8.1  1.8

julia> c = [0.2, 7.2, 2.9]
3-element Vector{Float64}:
 0.2
 7.2
 2.9

julia> d = [3.9, 2.1]
2-element Vector{Float64}:
 3.9
 2.1

julia> ws = LSEWs(A, B)
LSEWs{Float64}
  work: 101-element Vector{Float64}
  X: 3-element Vector{Float64}

julia> LAPACK.gglse!(ws, A, c, B, d)
([0.19723156207005318, 0.0683561362406917, 0.40981438442398854], 13.750943845251626)
```
"""
struct LSEWs{T} <: Workspace
    work::Vector{T}
    X::Vector{T}
end

LSEWs(A::AbstractMatrix) = LSEWs(A, A)
function LSEWs(A::AbstractMatrix, B::AbstractMatrix)
    resize!(LSEWs(Vector{eltype(A)}(undef, 1), Vector{eltype(A)}(undef, size(A, 2))), A, B)
end
for (gglse, elty) in ((:dgglse_, :Float64),
    (:sgglse_, :Float32),
    (:zgglse_, :ComplexF64),
    (:cgglse_, :ComplexF32))
    @eval begin
        function Base.resize!(ws::LSEWs, A::AbstractMatrix{$elty},
                B::AbstractMatrix{$elty}; work = true, blocksize = 32)
            require_one_based_indexing(A)
            chkstride1(A)
            m, n = size(A)
            p = size(B, 1)
            resize!(ws.X, n)
            if work
                resize!(ws.work, p + min(m, n) + max(m, n) * blocksize)
            end
            return ws
        end

        function gglse!(
                ws::LSEWs{$elty}, A::AbstractMatrix{$elty}, c::AbstractVector{$elty},
                B::AbstractMatrix{$elty}, d::AbstractVector{$elty}; resize = true, blocksize = 32)
            require_one_based_indexing(A, c, B, d)
            chkstride1(A, c, B, d)
            m, n = size(A)
            p = size(B, 1)
            if size(B, 2) != n
                throw(DimensionMismatch("B has second dimension $(size(B,2)), needs $n"))
            end
            if length(c) != m
                throw(DimensionMismatch("c has length $(length(c)), needs $m"))
            end
            if length(d) != p
                throw(DimensionMismatch("d has length $(length(d)), needs $p"))
            end
            if n > m + p
                throw(DimensionMismatch("Rows of A + rows of B needs to be larger than columns of A and B."))
            end
            nws = length(ws.X)
            if nws != n
                if resize
                    resize!(ws.X, n)
                    worksize = p + min(m, n) + max(m, n) * blocksize
                    if length(ws.work) < worksize
                        resize!(ws.work, worksize)
                    end
                else
                    throw(WorkspaceSizeError(nws, n))
                end
            end

            info = Ref{BlasInt}()
            ccall((@blasfunc($gglse), liblapack), Cvoid,
                (Ref{BlasInt}, Ref{BlasInt}, Ref{BlasInt}, Ptr{$elty},
                    Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                    Ptr{$elty}, Ptr{$elty}, Ptr{$elty}, Ref{BlasInt},
                    Ptr{BlasInt}),
                m, n, p, A, max(1, stride(A, 2)), B, max(1, stride(B, 2)), c, d, ws.X,
                ws.work, length(ws.work), info)
            chklapackerror(info[])
            ws.X, dot(view(c, (n - p + 1):m), view(c, (n - p + 1):m))
        end
    end
end

"""
    gglse!(ws, A, c, B, d) -> (ws.X,res)

Solves the equation `A * x = c` where `x` is subject to the equality
constraint `B * x = d`. Uses the formula `||c - A*x||^2 = 0` to solve.
Uses preallocated [`LSEWs`](@ref) to store `X` and work buffers. 
Returns `ws.X` and the residual sum-of-squares.
"""
gglse!(
    ws::LSEWs, A::AbstractMatrix, c::AbstractVector, B::AbstractMatrix, d::AbstractVector)

import LinearAlgebra.LAPACK: gees!, gges!
## Schur and generalized Schur decomposition with reordering

# SELECT functions
"""
   enum SCHURORDER lp rp id ed

# Keywords
    - `lp`: Left plane (real(eigenvalue) < criterium)
    - `rp`: Right plane (real(eigenvalue) >= criterium)
    - `id`: Interior of disk (abs(eigenvalue)^2 < criterium) 
    - `ed`: Exterior of disk (abs(eigenvalue)^2 >= criterium) 

# Note
    - the left half-plane is obtained with criterium = 0
    - the unit disk is obtained with criterium = 1
    - because of numerical error in computing repeated eigenvalues, you need to adapt
      criterium depending whether you want to include or not 0 is the left half-plane or
      1 in the unit disk
    - criterium is passed as optional parameter to `gees` and `gges` functions
"""
@enum SCHURORDER lp rp id ed

# store the criterium for preset selection functions

const SCHUR_CRITERIUM = Ref{Float64}()

# preset selection functions
# gees
function lpselect(wr_::Ptr, wi_::Ptr)::Cint
    wr = unsafe_load(wr_)
    wi = unsafe_load(wi_)
    return (wr < SCHUR_CRITERIUM[])
end

function rpselect(wr_::Ptr, wi_::Ptr)::Cint
    wr = unsafe_load(wr_)
    wi = unsafe_load(wi_)
    return (wr > SCHUR_CRITERIUM[])
end

function idselect(wr_::Ptr, wi_::Ptr)::Cint
    wr = unsafe_load(wr_)
    wi = unsafe_load(wi_)
    return (wr^2 + wi^2 < SCHUR_CRITERIUM[])
end

function edselect(wr_::Ptr, wi_::Ptr)::Cint
    wr = unsafe_load(wr_)
    wi = unsafe_load(wi_)
    return (wr^2 + wi^2 >= SCHUR_CRITERIUM[])
end

function selectorder2(so::SCHURORDER, criterium)
    global SCHUR_CRITERIUM[] = criterium
    if so == lp
        return @cfunction(lpselect, Cint,
            (Ptr{Cdouble}, Ptr{Cdouble}))
    elseif so == rp
        return @cfunction(rpselect, Cint,
            (Ptr{Cdouble}, Ptr{Cdouble}))
    elseif so == id
        return @cfunction(idselect, Cint,
            (Ptr{Cdouble}, Ptr{Cdouble}))
    elseif so == ed
        return @cfunction(edselect, Cint,
            (Ptr{Cdouble}, Ptr{Cdouble}))
    else
        error("Unknown SCHURDORDER keyword: $so")
    end
end

#gges

function lpselect(αr_::Ptr, αi_::Ptr, β_::Ptr)::Cint
    αr = unsafe_load(αr_)
    αi = unsafe_load(αi_)
    β = unsafe_load(β_)
    return (αr < SCHUR_CRITERIUM[] * β)
end

function rpselect(αr_::Ptr, αi_::Ptr, β_::Ptr)::Cint
    αr = unsafe_load(αr_)
    αi = unsafe_load(αi_)
    β = unsafe_load(β_)
    return (αr >= SCHUR_CRITERIUM[] * β)
end

function idselect(αr_::Ptr, αi_::Ptr, β_::Ptr)::Cint
    αr = unsafe_load(αr_)
    αi = unsafe_load(αi_)
    β = unsafe_load(β_)
    return (αr^2 + αi^2 < SCHUR_CRITERIUM[] * β^2)
end

function edselect(αr_::Ptr, αi_::Ptr, β_::Ptr)::Cint
    αr = unsafe_load(αr_)
    αi = unsafe_load(αi_)
    β = unsafe_load(β_)
    return (αr^2 + αi^2 >= SCHUR_CRITERIUM[] * β^2)
end

function selectorder3(so::SCHURORDER, criterium)
    global SCHUR_CRITERIUM[] = criterium
    if so == lp
        return @cfunction(lpselect, Cint,
            (Ptr{Cdouble}, Ptr{Cdouble}, Ptr{Cdouble}))
    elseif so == rp
        return @cfunction(rpselect, Cint,
            (Ptr{Cdouble}, Ptr{Cdouble}, Ptr{Cdouble}))
    elseif so == id
        return @cfunction(idselect, Cint,
            (Ptr{Cdouble}, Ptr{Cdouble}, Ptr{Cdouble}))
    elseif so == ed
        return @cfunction(edselect, Cint,
            (Ptr{Cdouble}, Ptr{Cdouble}, Ptr{Cdouble}))
    else
        error("Unknown SCHURDORDER keyword: $so")
    end
end

# prepares user provided Julia selection functions cfunction
# gees
function schurselect(f::Function, wr_::Ptr, wi_::Ptr)
    wr = unsafe_load(wr_)
    wi = unsafe_load(wi_)
    return convert(Cint, f(wr, wi) ? 1 : 0)
end

# gges
function schurselect(f::Function, αr_::Ptr, αi_::Ptr, β_::Ptr)
    αr = unsafe_load(αr_)
    αi = unsafe_load(αi_)
    β = unsafe_load(β_)
    return convert(Cint, f(αr, αi, β) ? 1 : 0)
end

"""
    SchurWs

Workspace to be used with the [`LinearAlgebra.Schur`](https://docs.julialang.org/en/v1/stdlib/LinearAlgebra/#LinearAlgebra.GeneralizedSchur) representation
of the Schur decomposition which uses the [`LAPACK.gees!`](@ref) function.

# Examples
```jldoctest
julia> A = [1.2 2.3
            6.2 3.3]
2×2 Matrix{Float64}:
 1.2  2.3
 6.2  3.3

julia> ws = SchurWs(A)
SchurWs{Float64}
  work: 68-element Vector{Float64}
  wr: 2-element Vector{Float64}
  wi: 2-element Vector{Float64}
  vs: 2×2 Matrix{Float64}
  sdim: Base.RefValue{Int64}
  bwork: 2-element Vector{Int64}
  eigen_values: 2-element Vector{ComplexF64}

julia> t = Schur(LAPACK.gees!(ws, 'V', A)...)
Schur{Float64, Matrix{Float64}, Vector{Float64}}
T factor:
2×2 Matrix{Float64}:
 -1.6695  -3.9
  0.0      6.1695
Z factor:
2×2 Matrix{Float64}:
 -0.625424  -0.780285
  0.780285  -0.625424
eigenvalues:
2-element Vector{Float64}:
 -1.6695025194532018
  6.169502519453203

julia> Matrix(t)
2×2 Matrix{Float64}:
 1.2  2.3
 6.2  3.3
```
"""
mutable struct SchurWs{T <: AbstractFloat} <: Workspace
    work::Vector{T}
    wr::Vector{T}
    wi::Vector{T}
    vs::Matrix{T}
    sdim::Ref{BlasInt}
    bwork::Vector{BlasInt}
    eigen_values::Vector{Complex{T}}
end

Base.length(ws::SchurWs) = length(ws.wr)

for (gees, elty) in ((:dgees_, :Float64),
    (:sgees_, :Float32))
    @eval begin
        function Base.resize!(ws::SchurWs, A::AbstractMatrix{$elty}; work = true)
            require_one_based_indexing(A)
            chkstride1(A)
            n = checksquare(A)
            resize!(ws.wr, n)
            resize!(ws.wi, n)
            ws.vs = zeros($elty, n, n)
            resize!(ws.bwork, n)
            resize!(ws.eigen_values, n)
            if work
                info = Ref{BlasInt}()
                ccall((@blasfunc($gees), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{UInt8}, Ptr{Cvoid}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{Cvoid}, Ptr{$elty},
                        Ptr{$elty}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                        Ref{BlasInt}, Ptr{Cvoid}, Ptr{BlasInt}, Clong, Clong),
                    'V', 'N', C_NULL, n,
                    A, max(1, stride(A, 2)), C_NULL, ws.wr,
                    ws.wi, ws.vs, max(size(ws.vs, 1), 1), ws.work,
                    -1, C_NULL, info, 1, 1)

                chklapackerror(info[])

                resize!(ws.work, BlasInt(real(ws.work[1])))
            end
            return ws
        end

        SchurWs(A::AbstractMatrix{$elty}) = resize!(
            SchurWs(Vector{$elty}(undef, 1), $elty[], $elty[], Matrix{$elty}(undef, 0, 0),
                Ref{BlasInt}(), BlasInt[], Complex{$elty}[]),
            A)

        function gees!(ws::SchurWs{$elty}, jobvs::AbstractChar,
                A::AbstractMatrix{$elty};
                select::Union{Nothing, Function, SCHURORDER} = nothing,
                criterium::Number = 0.0,
                resize = true)
            require_one_based_indexing(A)
            chkstride1(A)
            n = checksquare(A)
            nws = length(ws)
            if n != nws
                if resize
                    resize!(ws, A; work = n > nws)
                else
                    throw(WorkspaceSizeError(nws, n))
                end
            end
            info = Ref{BlasInt}()
            ldvs = max(size(ws.vs, 1), 1)
            lwork = length(ws.work)
            if select isa Function
                if Sys.ARCH == :aarch64
                    throw(ArgumentError("gees: using a select function is not possible on aarch64 architecture"))
                end
                sfunc(wr, wi) = schurselect(select, wr, wi)
                sel_func = @cfunction($(Expr(:$, :sfunc)), Cint,
                    (Ptr{Cdouble}, Ptr{Cdouble}))
                ccall((@blasfunc($gees), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{UInt8}, Ptr{Cvoid}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{BlasInt}, Ptr{$elty},
                        Ptr{$elty}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                        Ref{BlasInt}, Ptr{BlasInt}, Ptr{BlasInt}),
                    jobvs, 'S', sel_func, n,
                    A, max(1, stride(A, 2)), ws.sdim, ws.wr,
                    ws.wi, ws.vs, ldvs, ws.work,
                    lwork, ws.bwork, info)
            elseif select isa SCHURORDER
                sel_func = selectorder2(select, criterium)
                ccall((@blasfunc($gees), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{UInt8}, Ptr{Cvoid}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{BlasInt}, Ptr{$elty},
                        Ptr{$elty}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                        Ref{BlasInt}, Ptr{BlasInt}, Ptr{BlasInt}),
                    jobvs, 'S', sel_func, n,
                    A, max(1, stride(A, 2)), ws.sdim, ws.wr,
                    ws.wi, ws.vs, ldvs, ws.work,
                    lwork, ws.bwork, info)
            else
                ccall((@blasfunc($gees), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{UInt8}, Ptr{Cvoid}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{BlasInt}, Ptr{$elty},
                        Ptr{$elty}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                        Ref{BlasInt}, Ptr{Cvoid}, Ptr{BlasInt}),
                    jobvs, 'N', C_NULL, n,
                    A, max(1, stride(A, 2)), Ref{BlasInt}(), ws.wr,
                    ws.wi, ws.vs, ldvs, ws.work,
                    lwork, C_NULL, info)
            end

            chklapackerror(info[])

            if iszero(ws.wi)
                return A, ws.vs, ws.wr
            else
                @inbounds for i in axes(A, 1)
                    ws.eigen_values[i] = complex(ws.wr[i], ws.wi[i])
                end
                return A, ws.vs, ws.eigen_values
            end
        end
    end
end

"""
    gees!(ws, jobvs, A; select=nothing, criterium=0.0, resize=true) -> (A, vs, ws.eigen_values)

Computes the eigenvalues (`jobvs = N`) or the eigenvalues and Schur
vectors (`jobvs = V`) of matrix `A`, using the preallocated [`SchurWs`](@ref) worspace `ws`. If `ws` is not of the appropriate size and `resize==true` it will be resized for `A`. 
`A` is overwritten by its Schur form, and `ws.eigen_values` is overwritten with the eigenvalues.

It is possible to select the eigenvalues appearing in the top left corner of the Schur form:
- by setting the `select` option to one of 
    - `lp`: Left plane (real(eigenvalue) < criterium)
    - `rp`: Right plane (real(eigenvalue) >= criterium)
    - `id`: Interior of disk (abs(eigenvalue)^2 < criterium) 
    - `ed`: Exterior of disk (abs(eigenvalue)^2 >= criterium)
  and setting `criterium`.
- by setting `select` equal to a function used to sort the eigenvalues during the decomponsition. In this case, the `criterium` keyword isn't used. The function should have the signature `f(wr::T, wi::T) -> Bool`, where `wr` and `wi` are the real and imaginary parts of the eigenvalue, and `T == eltype(A)`. This is not available on aarch64 architecture.

Returns `A`, `vs` containing the Schur vectors, and `ws.eigen_values`.

See also FastLapackInterface.SCHURORDER
"""
gees!(ws::SchurWs, jobvs::AbstractChar, A::AbstractMatrix; kwargs...)

"""
    GeneralizedSchurWs

Workspace to be used with the [`LinearAlgebra.GeneralizedSchur`](https://docs.julialang.org/en/v1/stdlib/LinearAlgebra/#LinearAlgebra.GeneralizedSchur)
representation of the Generalized Schur decomposition which uses the [`LAPACK.gges!`](@ref) function.

# Examples
```jldoctest
julia> A = [1.2 2.3
            6.2 3.3]
2×2 Matrix{Float64}:
 1.2  2.3
 6.2  3.3

julia> B = [8.2 0.3
            1.7 4.3]
2×2 Matrix{Float64}:
 8.2  0.3
 1.7  4.3

julia> ws = GeneralizedSchurWs(A)
GeneralizedSchurWs{Float64}
  work: 90-element Vector{Float64}
  αr: 2-element Vector{Float64}
  αi: 2-element Vector{Float64}
  β: 2-element Vector{Float64}
  vsl: 2×2 Matrix{Float64}
  vsr: 2×2 Matrix{Float64}
  sdim: Base.RefValue{Int64}
  bwork: 2-element Vector{Int64}
  eigen_values: 2-element Vector{ComplexF64}
  
julia> t = GeneralizedSchur(LAPACK.gges!(ws, 'V','V', A, B)...)
GeneralizedSchur{Float64, Matrix{Float64}, Vector{ComplexF64}, Vector{Float64}}
S factor:
2×2 Matrix{Float64}:
 -1.43796  1.63843
  0.0      7.16295
T factor:
2×2 Matrix{Float64}:
 5.06887  -4.00221
 0.0       6.85558
Q factor:
2×2 Matrix{Float64}:
 -0.857329  0.514769
  0.514769  0.857329
Z factor:
2×2 Matrix{Float64}:
 -0.560266  0.828313
  0.828313  0.560266
α:
2-element Vector{ComplexF64}:
 -1.4379554610733563 + 0.0im
   7.162947865097022 + 0.0im
β:
2-element Vector{Float64}:
 5.068865029631368
 6.855578082442485
```
"""
mutable struct GeneralizedSchurWs{T} <: Workspace
    work::Vector{T}
    αr::Vector{T}
    αi::Vector{T}
    β::Vector{T}
    vsl::Matrix{T}
    vsr::Matrix{T}
    sdim::Ref{BlasInt}
    bwork::Vector{BlasInt}
    eigen_values::Vector{Complex{T}}
end

Base.length(ws::GeneralizedSchurWs) = length(ws.αr)

# look into matlab function
for (gges, elty) in ((:dgges_, :Float64),
    (:sgges_, :Float32))
    @eval begin
        function Base.resize!(ws::GeneralizedSchurWs, A::AbstractMatrix{$elty}; work = true)
            chkstride1(A)
            n = checksquare(A)
            resize!(ws.αr, n)
            resize!(ws.αi, n)
            resize!(ws.β, n)
            resize!(ws.bwork, n)
            resize!(ws.eigen_values, n)
            ws.vsl = zeros($elty, n, n)
            ws.vsr = zeros($elty, n, n)
            if work
                info = Ref{BlasInt}()
                ccall((@blasfunc($gges), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{UInt8}, Ref{UInt8}, Ptr{Cvoid},
                        Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                        Ref{BlasInt}, Ptr{Cvoid}, Ptr{$elty}, Ptr{$elty},
                        Ptr{$elty}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                        Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{Cvoid},
                        Ref{BlasInt}, Clong, Clong, Clong),
                    'V', 'V', 'N', C_NULL,
                    n, A, max(1, stride(A, 2)), A,
                    max(1, stride(A, 2)), C_NULL, ws.αr, ws.αi,
                    ws.β, ws.vsl, n, ws.vsr,
                    n, ws.work, -1, C_NULL,
                    info, 1, 1, 1)

                chklapackerror(info[])
                resize!(ws.work, BlasInt(real(ws.work[1])))
            end
            return ws
        end
        GeneralizedSchurWs(A::AbstractMatrix{$elty}) = resize!(
            GeneralizedSchurWs(Vector{$elty}(undef, 1), $elty[], $elty[], $elty[],
                Matrix{$elty}(undef, 0, 0), Matrix{$elty}(undef, 0, 0),
                Ref{BlasInt}(), BlasInt[], Complex{$elty}[]),
            A)

        function gges!(ws::GeneralizedSchurWs, jobvsl::AbstractChar,
                jobvsr::AbstractChar,
                A::AbstractMatrix{$elty}, B::AbstractMatrix{$elty};
                select::Union{Nothing, Function, SCHURORDER} = nothing,
                criterium::Number = 0,
                resize = true)
            chkstride1(A, B)
            n = checksquare(A)
            m = checksquare(B)
            if n != m
                throw(DimensionMismatch("dimensions of A, ($n,$n), and B, ($m,$m), must match"))
            end
            nws = length(ws)
            if n != nws
                if resize
                    resize!(ws, A; work = n > nws)
                else
                    throw(WorkspaceSizeError(nws, n))
                end
            end

            info = Ref{BlasInt}()
            ldvsl = size(ws.vsl, 1)
            ldvsr = size(ws.vsr, 1)
            if select isa Function
                if Sys.ARCH == :aarch64
                    throw(ArgumentError("gges: using a select function is not possible on aarch64 architecture"))
                end
                sfunc(αr, αi, β) = schurselect(select, αr, αi, β)
                sel_func = @cfunction($(Expr(:$, :sfunc)), Cint,
                    (Ptr{Cdouble}, Ptr{Cdouble}, Ptr{Cdouble}))
                ccall((@blasfunc($gges), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{UInt8}, Ref{UInt8}, Ptr{Cvoid},
                        Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                        Ref{BlasInt}, Ref{BlasInt}, Ptr{$elty}, Ptr{$elty},
                        Ptr{$elty}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                        Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{Cvoid},
                        Ref{BlasInt}, Clong, Clong, Clong),
                    jobvsl, jobvsr, 'S', sel_func,
                    n, A, max(1, stride(A, 2)), B,
                    max(1, stride(B, 2)), ws.sdim, ws.αr, ws.αi,
                    ws.β, ws.vsl, ldvsl, ws.vsr,
                    ldvsr, ws.work, length(ws.work), ws.bwork,
                    info, 1, 1, 1)
            elseif select isa SCHURORDER
                sel_func = selectorder3(select, criterium)
                ccall((@blasfunc($gges), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{UInt8}, Ref{UInt8}, Ptr{Cvoid},
                        Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                        Ref{BlasInt}, Ref{BlasInt}, Ptr{$elty}, Ptr{$elty},
                        Ptr{$elty}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                        Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{Cvoid},
                        Ref{BlasInt}, Clong, Clong, Clong),
                    jobvsl, jobvsr, 'S', sel_func,
                    n, A, max(1, stride(A, 2)), B,
                    max(1, stride(B, 2)), ws.sdim, ws.αr, ws.αi,
                    ws.β, ws.vsl, ldvsl, ws.vsr,
                    ldvsr, ws.work, length(ws.work), ws.bwork,
                    info, 1, 1, 1)
            else
                ccall((@blasfunc($gges), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{UInt8}, Ref{UInt8}, Ptr{Cvoid},
                        Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                        Ref{BlasInt}, Ref{BlasInt}, Ptr{$elty}, Ptr{$elty},
                        Ptr{$elty}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                        Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{Cvoid},
                        Ref{BlasInt}, Clong, Clong, Clong),
                    jobvsl, jobvsr, 'N', C_NULL,
                    n, A, max(1, stride(A, 2)), B,
                    max(1, stride(B, 2)), Ref{BlasInt}(), ws.αr, ws.αi,
                    ws.β, ws.vsl, ldvsl, ws.vsr,
                    ldvsr, ws.work, length(ws.work), C_NULL,
                    info, 1, 1, 1)
            end
            chklapackerror(info[])
            @inbounds for i in axes(A, 1)
                ws.eigen_values[i] = complex(ws.αr[i], ws.αi[i]) / ws.β[i]
            end
            return A, B, complex.(ws.αr, ws.αi), ws.β, ws.vsl, ws.vsr
        end
    end
end

"""
    gges!(ws, jobvsl, jobvsr, A, B; select=nothing, criterium = 0, resize=true) -> (A, B, ws.α, ws.β, ws.vsl, ws.vsr)

Computes the generalized eigenvalues, generalized Schur form, left Schur
vectors (`jobsvl = V`), or right Schur vectors (`jobvsr = V`) of `A` and
`B`, using preallocated [`GeneralizedSchurWs`](@ref) workspace `ws`.
If `ws` is not of the right size, and `resize==true` it will be resized appropriately.

It is possible to select the eigenvalues appearing in the top left corner of the Schur form:
- by setting the `select` option to one of 
    - `lp`: Left plane (real(eigenvalue) < criterium)
    - `rp`: Right plane (real(eigenvalue) >= criterium)
    - `id`: Interior of disk (abs(eigenvalue)^2 < criterium) 
    - `ed`: Exterior of disk (abs(eigenvalue)^2 >= criterium)
  and setting `criterium`.
- by setting `select` equal to a function used to sort the eigenvalues during the decomposition. In this case, the `criterium` keyword isn't used. The function should have the signature `f(αr::T, αi::T, β::T) -> Bool` where `T == eltype(A)`. An eigenvalue `(αr[j]+αi[j])/β[j]` is selected if `f(αr[j],αi[j],β[j])` is true, i.e. if either one of a complex conjugate pair of eigenvalues is selected, then both complex eigenvalues are selected. This is not available on aarch64 architecture.

The generalized eigenvalues components are returned in `ws.α` and `ws.β` where `ws.α` is a complex vector and `ẁs.β`, a real vector.
The generalized eigenvalues (`ws.α./ws.β`) are returned in `ws.eigen_values`, a complex vector. 
The left Schur vectors are returned in `ws.vsl` and the right Schur vectors are returned in `ws.vsr`.

See also FastLapackInterface.SCHURORDER
"""
gges!(
    ws::GeneralizedSchurWs, jobvsl::AbstractChar, jobvsr::AbstractChar, A::AbstractMatrix,
    B::AbstractMatrix; kwargs...)

using Test
using FastLapackInterface
using LinearAlgebra.LAPACK

@testset "EigenWs" begin
    n = 10
    @testset "Real, square" begin
        A0 = randn(n, n)
        ws = EigenWs(copy(A0); lvecs = true, sense = true)

        A1, WR1, WI1, VL1, VR1, ilo1, ihi1, scale1, abnrm1, rconde1, rcondv1 =
            LAPACK.geevx!('P', 'V', 'V', 'V', copy(A0))
        A2, WR2, WI2, VL2, VR2, ilo2, ihi2, scale2, abnrm2, rconde2, rcondv2 =
            LAPACK.geevx!(ws, 'P', 'V', 'V', 'V', copy(A0))

        @test isapprox(A1, A2)
        @test isapprox(WR1, WR2)
        @test isapprox(WI1, WI2)
        @test isapprox(VL1, VL2)
        @test isapprox(VR1, VR2)
        @test isapprox(ilo1, ilo2)
        @test isapprox(ihi1, ihi2)
        @test isapprox(scale1, scale2)
        @test isapprox(abnrm1, abnrm2)
        @test isapprox(rcondv1, rcondv2; atol = 1e-16)

        # using Workspace, factorize!
        ws = Workspace(LAPACK.geevx!, copy(A0); lvecs = true, sense = true)
        A2, WR2, WI2, VL2, VR2, ilo2, ihi2, scale2, abnrm2, rconde2, rcondv2 =
            factorize!(ws, 'P', 'V', 'V', 'V', copy(A0))
        @test isapprox(A1, A2)
        @test isapprox(WR1, WR2)
        @test isapprox(WI1, WI2)
        @test isapprox(VL1, VL2)
        @test isapprox(VR1, VR2)
        @test isapprox(ilo1, ilo2)
        @test isapprox(ihi1, ihi2)
        @test isapprox(scale1, scale2)
        @test isapprox(abnrm1, abnrm2)
        @test isapprox(rcondv1, rcondv2; atol = 1e-16)
        
        ws = Workspace(LAPACK.geevx!, copy(A0); lvecs=false, rvecs=false, sense=false)
        @test size(ws.VL, 1) == 0
        @test_throws ArgumentError factorize!(ws, 'P', 'V', 'N', 'N', copy(A0); resize=false)
        factorize!(ws, 'P', 'V', 'N', 'N', copy(A0))
        @test size(ws.VL, 1) != 0
        @test_throws ArgumentError factorize!(ws, 'P', 'V', 'V', 'N', copy(A0); resize=false)
        factorize!(ws, 'P', 'V', 'V', 'N', copy(A0))
        @test size(ws.VR, 1) != 0
        @test_throws ArgumentError factorize!(ws, 'P', 'V', 'V', 'E', copy(A0); resize=false)
        factorize!(ws, 'P', 'V', 'V', 'E', copy(A0))
        @test size(ws.iwork, 1) != 0
        for div in (-1, 1)            
            @test_throws FastLapackInterface.WorkspaceSizeError factorize!(ws, 'P', 'N', 'N', 'N',rand(n+div, n+div); resize=false)
            factorize!(ws, 'P', 'N', 'N', 'N',rand(n+div, n+div))
            @test length(ws.W) == n+div
        end
        show(devnull, "text/plain", ws)
    end

    @testset "Complex, square" begin
        A0 = randn(ComplexF64, n, n)
        ws = EigenWs(copy(A0); lvecs = true, sense = true)

        A1, W1, VL1, VR1, ilo1, ihi1, scale1, abnrm1, rconde1, rcondv1 = LAPACK.geevx!('N',
                                                                                       'V',
                                                                                       'V',
                                                                                       'V',
                                                                                       copy(A0))
        A2, W2, VL2, VR2, ilo2, ihi2, scale2, abnrm2, rconde2, rcondv2 = LAPACK.geevx!(ws,
                                                                                       'N',
                                                                                       'V',
                                                                                       'V',
                                                                                       'V',
                                                                                       copy(A0))

        @test isapprox(A1, A2)
        @test isapprox(W1, W2)
        @test isapprox(VL1, VL2)
        @test isapprox(VR1, VR2)
        @test isapprox(ilo1, ilo2)
        @test isapprox(ihi1, ihi2)
        @test isapprox(scale1, scale2)
        @test isapprox(abnrm1, abnrm2)
        # using Workspace, factorize!
        ws = Workspace(LAPACK.geevx!, copy(A0); lvecs = true, sense = true)
        A2, W2, VL2, VR2, ilo2, ihi2, scale2, abnrm2, rconde2, rcondv2 = factorize!(ws, 'N',
                                                                                    'V',
                                                                                    'V',
                                                                                    'V',
                                                                                    copy(A0))
        @test isapprox(A1, A2)
        @test isapprox(W1, W2)
        @test isapprox(VL1, VL2)
        @test isapprox(VR1, VR2)
        @test isapprox(ilo1, ilo2)
        @test isapprox(ihi1, ihi2)
        @test isapprox(scale1, scale2)
        @test isapprox(abnrm1, abnrm2)
        show(devnull, "text/plain", ws)
    end
end

@testset "HermitianEigenWs" begin
    n = 3
    @testset "Real, square" begin
        A0 = randn(n, n)
        A0 = (A0 + A0')/2
        ws = HermitianEigenWs(copy(A0); vecs = true)

        w1, Z1 = LAPACK.syevr!('V', 'A', 'U', copy(A0), 0.0, 0.0, 0, 0, 1e-6)
        w2, Z2 = LAPACK.syevr!(ws, 'V', 'A', 'U', copy(A0), 0.0, 0.0, 0, 0, 1e-6)
        @test isapprox(w1, w2)
        @test isapprox(Z2, Z2)
        # using Workspace, factorize!
        ws = Workspace(LAPACK.syevr!, copy(A0); vecs = true)
        w2, Z2 = factorize!(ws, 'V', 'A', 'U', copy(A0), 0.0, 0.0, 0, 0, 1e-6)
        @test isapprox(w1, w2)
        @test isapprox(Z2, Z2)
        show(devnull, "text/plain", ws)
        
        ws = Workspace(LAPACK.syevr!, copy(A0); vecs = false)
        for div in (-1, 1)            
            @test_throws FastLapackInterface.WorkspaceSizeError factorize!(ws, 'N', 'A', 'U', randn(n+div, n+div), 0.0, 0.0, 0, 0, 1e-6; resize=false)
            @test_throws FastLapackInterface.WorkspaceSizeError factorize!(ws, 'V', 'A', 'U', randn(n+div, n+div), 0.0, 0.0, 0, 0, 1e-6; resize=false)
            w2, Z2 = factorize!(ws, 'V', 'A', 'U', randn(n+div, n+div), 0.0, 0.0, 0, 0, 1e-6)
            @test length(ws.w) == n+div
            @test size(ws.Z, 1) == n+div
        end
        w2, Z2 = factorize!(ws, 'V', 'A', 'U', copy(A0), 0.0, 0.0, 0, 0, 1e-16)
        @test length(w2) == n
        @test sum(abs.(Matrix(Eigen(w2, Z2)) .- A0)) < 1e-12
        
    end

    @testset "Complex, square" begin
        A0 = randn(ComplexF64, n, n)
        A0 = (A0 + A0') / 2
        ws = HermitianEigenWs(copy(A0); vecs = true)

        w1, Z1 = LAPACK.syevr!('V', 'A', 'U', copy(A0), 0.0, 0.0, 0, 0, 1e-6)
        w2, Z2 = LAPACK.syevr!(ws, 'V', 'A', 'U', copy(A0), 0.0, 0.0, 0, 0, 1e-6)
        @test isapprox(w1, w2)
        @test isapprox(Z2, Z2)
        # using Workspace, factorize!
        ws = Workspace(LAPACK.syevr!, copy(A0); vecs = true)
        w2, Z2 = factorize!(ws, 'V', 'A', 'U', copy(A0), 0.0, 0.0, 0, 0, 1e-6)
        @test isapprox(w1, w2)
        @test isapprox(Z2, Z2)
    end
end
@testset "GeneralizedEigenWs" begin
    n = 10
    @testset "Real, square" begin
        A0 = randn(n, n)
        B0 = randn(n, n)
        ws = GeneralizedEigenWs(copy(A0); lvecs = true, rvecs = true)

        αr1, αi1, β1, vl1, vr1 = LAPACK.ggev!('V', 'V', copy(A0), copy(B0))
        αr2, αi2, β2, vl2, vr2 = LAPACK.ggev!(ws, 'V', 'V', copy(A0), copy(B0))
        @test isapprox(αr1, αr2)
        @test isapprox(αi1, αi2)
        @test isapprox(β1, β2)
        @test isapprox(vl1, vl2)
        @test isapprox(vr1, vr2)
        # using Workspace, factorize!
        ws = Workspace(LAPACK.ggev!, copy(A0); lvecs = true, rvecs = true)
        αr2, αi2, β2, vl2, vr2 = LAPACK.ggev!(ws, 'V', 'V', copy(A0), copy(B0))
        @test isapprox(αr1, αr2)
        @test isapprox(αi1, αi2)
        @test isapprox(β1, β2)
        @test isapprox(vl1, vl2)
        @test isapprox(vr1, vr2)
        show(devnull, "text/plain", ws)
        
        ws = Workspace(LAPACK.ggev!, copy(A0))
        @test size(ws.vl, 1) == 0
        @test size(ws.vr, 1) == 0
        @test_throws ArgumentError LAPACK.ggev!(ws, 'N', 'V', copy(A0), copy(B0); resize=false)
        LAPACK.ggev!(ws, 'N', 'V', copy(A0), copy(B0))
        @test size(ws.vr, 1) == n
        @test_throws ArgumentError LAPACK.ggev!(ws, 'V', 'V', copy(A0), copy(B0); resize=false)
        LAPACK.ggev!(ws, 'V', 'V', copy(A0), copy(B0))
        @test size(ws.vl, 1) == n

        for div in (-1,1)
            @test_throws FastLapackInterface.WorkspaceSizeError LAPACK.ggev!(ws, 'V', 'V', randn(n+div,n+div), randn(n+div, n+div), resize=false)
            LAPACK.ggev!(ws, 'V', 'V', randn(n+div,n+div), randn(n+div, n+div))
            @test size(ws.vl, 1) == n+div
            @test size(ws.vr, 1) == n+div
        end
    end

    @testset "Complex, square" begin
        A0 = randn(ComplexF64, n, n)
        B0 = randn(ComplexF64, n, n)
        ws = GeneralizedEigenWs(copy(A0); lvecs = true, rvecs = true)

        αr1, β1, vl1, vr1 = LAPACK.ggev!('V', 'V', copy(A0), copy(B0))
        αr2, β2, vl2, vr2 = LAPACK.ggev!(ws, 'V', 'V', copy(A0), copy(B0))
        @test isapprox(αr1, αr2)
        @test isapprox(β1, β2)
        @test isapprox(vl1, vl2)
        @test isapprox(vr1, vr2)
        # using Workspace, factorize!
        ws = Workspace(LAPACK.ggev!, copy(A0); lvecs = true, rvecs = true)
        αr2, β2, vl2, vr2 = LAPACK.ggev!(ws, 'V', 'V', copy(A0), copy(B0))
        @test isapprox(αr1, αr2)
        @test isapprox(β1, β2)
        @test isapprox(vl1, vl2)
        @test isapprox(vr1, vr2)
        show(devnull, "text/plain", ws)
    end
end

# Workspaces for Eigenvalue decomposition
using LinearAlgebra.LAPACK: chkfinite, chklapackerror
if VERSION >= v"1.11"
    using LinearAlgebra.LAPACK: @chkvalidparam
else
    macro chkvalidparam(position::Int, param, validvalues)
        :(chkvalidparam($position, $(string(param)), $(esc(param)), $validvalues))
    end
    function chkvalidparam(position::Int, var::String, val, validvals)
        # mimic `repr` for chars without explicitly calling it
        # This is because `repr` introduces dynamic dispatch
        _repr(c::AbstractChar) = "'$c'"
        _repr(c) = c
        if val ∉ validvals
            throw(ArgumentError(
                lazy"argument #$position: $var must be one of $validvals, but $(_repr(val)) was passed"))
        end
        return val
    end
end
import LinearAlgebra.LAPACK: gesdd!, gesvd!, ggsvd3!

"""
    SVDsddWs

creates a workspace for [`LinearAlgebra.SVD`](https://docs.julialang.org/en/v1/stdlib/LinearAlgebra/#LinearAlgebra.SVD)
factorization using the [`LAPACK.gesdd!`](@ref) function.
"""
mutable struct SVDsddWs{T, MT <: AbstractMatrix{T}, RT <: AbstractFloat} <: Workspace
    U::MT
    VT::MT
    work::Vector{T}
    S::Vector{RT}
    rwork::Vector{RT} # Can be rwork if T <: Complex or WI if T <: Float64
    iwork::Vector{BlasInt}
end

# (GE) general matrices ingular value decomposition
for (gesdd, elty, relty) in ((:dgesdd_, :Float64, :Float64),
    (:sgesdd_, :Float32, :Float32),
    (:zgesdd_, :ComplexF64, :Float64),
    (:cgesdd_, :ComplexF32, :Float32))
    @eval begin
        function Base.resize!(
                ws::SVDsddWs, A::AbstractMatrix{$elty}; job::AbstractChar = 'A')
            require_one_based_indexing(A)
            chkstride1(A)
            if VERSION >= v"1.11"
                @chkvalidparam 2 job ('A', 'S', 'O', 'N')
            end
            m, n = size(A)
            minmn = min(m, n)
            if job == 'A'
                ws.U = similar(A, $elty, (m, m))
                ws.VT = similar(A, $elty, (n, n))
            elseif job == 'S'
                ws.U = similar(A, $elty, (m, minmn))
                ws.VT = similar(A, $elty, (minmn, n))
            elseif job == 'O'
                ws.U = similar(A, $elty, (m, m >= n ? 0 : m))
                ws.VT = similar(A, $elty, (n, m >= n ? n : 0))
            else
                ws.U = similar(A, $elty, (m, 0))
                ws.VT = similar(A, $elty, (n, 0))
            end
            ws.work = Vector{$elty}(undef, 1)
            lwork = BlasInt(-1)
            ws.S = similar(A, $relty, minmn)
            cmplx = eltype(A) <: Complex
            if cmplx
                ws.rwork = Vector{$relty}(undef,
                    job == 'N' ? 7 * minmn :
                    minmn * max(5 * minmn + 7, 2 * max(m, n) + 2 * minmn + 1))
            end
            ws.iwork = Vector{BlasInt}(undef, 8 * minmn)
            info = Ref{BlasInt}()
            if cmplx
                ccall((@blasfunc($gesdd), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt}, Ptr{$elty},
                        Ref{BlasInt}, Ptr{$relty}, Ptr{$elty}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                        Ptr{$relty}, Ptr{BlasInt}, Ref{BlasInt}, Clong),
                    job, m, n, A, max(1, stride(A, 2)), ws.S, ws.U,
                    max(1, stride(ws.U, 2)), ws.VT, max(1, stride(ws.VT, 2)),
                    ws.work, lwork, ws.rwork, ws.iwork, info, 1)
            else
                ccall((@blasfunc($gesdd), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt}, Ptr{$elty},
                        Ref{BlasInt}, Ptr{$elty}, Ptr{$elty}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                        Ptr{BlasInt}, Ref{BlasInt}, Clong),
                    job, m, n, A, max(1, stride(A, 2)), ws.S, ws.U,
                    max(1, stride(ws.U, 2)), ws.VT, max(1, stride(ws.VT, 2)),
                    ws.work, lwork, ws.iwork, info, 1)
            end
            chklapackerror(info[])
            # Work around issue with truncated Float32 representation of lwork in
            # sgesdd by using nextfloat. See
            # http://icl.cs.utk.edu/lapack-forum/viewtopic.php?f=13&t=4587&p=11036&hilit=sgesdd#p11036
            # and
            # https://github.com/scipy/scipy/issues/5401
            lwork = round(BlasInt, nextfloat(real(ws.work[1])))
            resize!(ws.work, lwork)
            return ws
        end

        SVDsddWs(A::AbstractMatrix{$elty}; kwargs...) = Base.resize!(
            SVDsddWs(similar(A, 0, 0), similar(A, 0, 0), Vector{$elty}(undef, 1),
                Vector{$relty}(undef, 0), Vector{$relty}(undef, 0), Vector{BlasInt}(
                    undef, 0)),
            A;
            kwargs...)
        #    SUBROUTINE DGESDD( JOBZ, M, N, A, LDA, S, U, LDU, VT, LDVT, WORK,
        #                   LWORK, IWORK, INFO )
        #*     .. Scalar Arguments ..
        #      CHARACTER          JOBZ
        #      INTEGER            INFO, LDA, LDU, LDVT, LWORK, M, N
        #*     ..
        #*     .. Array Arguments ..
        #      INTEGER            IWORK( * )
        #      DOUBLE PRECISION   A( LDA, * ), S( * ), U( LDU, * ),
        #                        VT( LDVT, * ), WORK( * )
        function gesdd!(
                ws::SVDsddWs, job::AbstractChar, A::AbstractMatrix{$elty}; resize = true)
            require_one_based_indexing(A)
            chkstride1(A)
            if VERSION >= v"1.11"
                @chkvalidparam 1 job ('A', 'S', 'O', 'N')
            end
            m, n = size(A)
            minmn = min(m, n)
            if job == 'A'
                if size(ws.U) != (m, n) || size(ws.VT) != (n, n)
                    if resize
                        resize!(ws, A, job = job)
                    else
                        throw(ArgumentError("Workspace has wrong size, use resize!(ws, A)."))
                    end
                end
            elseif job == 'S'
                if size(ws.U) != (m, minmn) || size(ws.VT) != (minmn, n)
                    if resize
                        resize!(ws, A, job = job)
                    else
                        throw(ArgumentError("Workspace has wrong size, use resize!(ws, A, job = 'S')."))
                    end
                end
            elseif job == 'O'
                if m >= n
                    if size(ws.U, 1) != m || size(ws.VT) != (n, n)
                        if resize
                            resize!(ws, A, job = job)
                        else
                            throw(ArgumentError("Workspace has wrong size, use resize!(ws, A, job = 'O')."))
                        end
                    end
                else
                    if size(ws.U) != (m, m) || size(ws.VT, 1) != n
                        if resize
                            resize!(ws, A, job = job)
                        else
                            throw(ArgumentError("Workspace has wrong size, use resize!(ws, A, job = 'O')."))
                        end
                    end
                end
            end
            cmplx = eltype(A) <: Complex
            info = Ref{BlasInt}()
            if cmplx
                ccall((@blasfunc($gesdd), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt}, Ptr{$elty},
                        Ref{BlasInt}, Ptr{$relty}, Ptr{$elty}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                        Ptr{$relty}, Ptr{BlasInt}, Ref{BlasInt}, Clong),
                    job, m, n, A, max(1, stride(A, 2)), ws.S, ws.U,
                    max(1, stride(ws.U, 2)), ws.VT, max(1, stride(ws.VT, 2)),
                    ws.work, length(ws.work), ws.rwork, ws.iwork, info, 1)
            else
                ccall((@blasfunc($gesdd), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt}, Ptr{$elty},
                        Ref{BlasInt}, Ptr{$elty}, Ptr{$elty}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                        Ptr{BlasInt}, Ref{BlasInt}, Clong),
                    job, m, n, A,
                    max(1, stride(A, 2)), ws.S, ws.U, max(1, stride(ws.U, 2)),
                    ws.VT, max(1, stride(ws.VT, 2)), ws.work, length(ws.work),
                    ws.iwork, info, 1)
            end
            chklapackerror(info[])
            if job == 'O'
                if m >= n
                    return (A, ws.S, ws.VT)
                else
                    return (ws.U, ws.S, A)
                end
            end
            return (ws.U, ws.S, ws.VT)
        end
    end
end

"""
    SVDsddWs(A; job = 'A')

creates a workspace for [`LinearAlgebra.SVD`](https://docs.julialang.org/en/v1/stdlib/LinearAlgebra/#LinearAlgebra.SVD)
factorization using the [`LAPACK.gesdd!`](@ref) function.

# Arguments
- `A::AbstractMatrix`: the matrix to be decomposed. Only the shape of the matrix matters for building the workspace. The actual ellements value does not.
- `job::AbstractChar`: one of `A`, `N`, `O` or `S`. Default = 'A'. See [gesdd!](@ref).

# Examples
```jldoctest
julia> A = [1.2 2.3
            6.2 3.3]
2×2 Matrix{Float64}:
 1.2  2.3
 6.2  3.3

julia> ws = FastLapackInterface.SVDsddWs(A, job = 'A')
SVDsddWs{Float64, Matrix{Float64}, Float64}
  U: 2×2 Matrix{Float64}
  VT: 2×2 Matrix{Float64}
  work: 134-element Vector{Float64}
  S: 2-element Vector{Float64}
  rwork: 0-element Vector{Float64}
  iwork: 16-element Vector{Int64}

julia> t = FastLapackInterface.gesdd!(ws, 'A', A);

julia> LinearAlgebra.SVD(t[1], t[2], t[3])
SVD{Float64, Float64, Matrix{Float64}, Vector{Float64}}
U factor:
2×2 Matrix{Float64}:
 -0.302437  -0.953169
 -0.953169   0.302437
singular values:
2-element Vector{Float64}:
 7.355199814161389
 1.400369841777625
Vt factor:
2×2 Matrix{Float64}:
 -0.852808  -0.522224
  0.522224  -0.852808
```
"""
SVDsddWs(::AbstractMatrix; job::AbstractChar)

"""
    gesdd!(ws, job, A; resize = true) -> (U, S, VT)

Finds the singular value decomposition of `A`, `A = U * S * V'`,
using a divide and conquer approachusing a preallocated [`SVDsddWs`](@ref).
If `job : A`, all the columns of `U` and
the rows of `V'` are computed. If `job = N`, no columns of `U` or rows of `V'`
are computed. If `job = O`, `A` is overwritten with the columns of (thin) `U`
and the rows of (thin) `V'`. If `job = S`, the columns of (thin) `U` and the
rows of (thin) `V'` are computed and returned separately. The value of `job` must be the same in `SVDsddWs` and in 'gesdd!`.
If `ws` does not have the appropriate size for `A` and the work to be done,
if `resize=true`, it will be automatically resized accordingly. 
"""
gesdd!(ws::SVDsddWs, job::AbstractChar, A::AbstractMatrix)

"""
    SVDsvdWs

Workspace for [`LinearAlgebra.SVD`](https://docs.julialang.org/en/v1/stdlib/LinearAlgebra/#LinearAlgebra.SVD)
factorization using the [`LAPACK.gesvd!`](@ref) function.
"""
mutable struct SVDsvdWs{T, MT <: AbstractMatrix{T}, RT <: AbstractFloat} <: Workspace
    U::MT
    VT::MT
    work::Vector{T}
    S::Vector{RT}
    rwork::Vector{RT} # Can be rwork if T <: Complex or WI if T <: Float64
end

# (GE) general matrices ingular value decomposition
for (gesvd, elty, relty) in ((:dgesvd_, :Float64, :Float64),
    (:sgesvd_, :Float32, :Float32),
    (:zgesvd_, :ComplexF64, :Float64),
    (:cgesvd_, :ComplexF32, :Float32))
    @eval begin
        function Base.resize!(ws::SVDsvdWs, A::AbstractMatrix{$elty};
                jobu::AbstractChar = 'A', jobvt::AbstractChar = 'A')
            require_one_based_indexing(A)
            chkstride1(A)
            if VERSION >= v"1.11"
                @chkvalidparam 2 jobu ('A', 'S', 'O', 'N')
                @chkvalidparam 3 jobvt ('A', 'S', 'O', 'N')
            end
            m, n = size(A)
            minmn = min(m, n)
            (jobu == jobvt == 'O') &&
                throw(ArgumentError("jobu and jobvt cannot both be O"))
            ws.S = similar(A, $relty, minmn)
            ws.U = similar(
                A, $elty, jobu == 'A' ? (m, m) : (jobu == 'S' ? (m, minmn) : (m, 0)))
            ws.VT = similar(
                A, $elty, jobvt == 'A' ? (n, n) : (jobvt == 'S' ? (minmn, n) : (n, 0)))
            cmplx = eltype(A) <: Complex
            if cmplx
                ws.rwork = Vector{$relty}(undef, 5minmn)
            end
            lwork = BlasInt(-1)
            info = Ref{BlasInt}()
            if cmplx
                ccall((@blasfunc($gesvd), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{$relty}, Ptr{$elty},
                        Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                        Ref{BlasInt}, Ptr{$relty}, Ref{BlasInt}, Clong, Clong),
                    jobu, jobvt, m, n, A, max(1, stride(A, 2)), ws.S, ws.U,
                    max(1, stride(ws.U, 2)), ws.VT, max(1, stride(ws.VT, 2)),
                    ws.work, lwork, ws.rwork, info, 1, 1)
            else
                ccall((@blasfunc($gesvd), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ptr{$elty},
                        Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                        Ref{BlasInt}, Ref{BlasInt}, Clong, Clong),
                    jobu, jobvt, m, n, A, max(1, stride(A, 2)), ws.S, ws.U,
                    max(1, stride(ws.U, 2)), ws.VT, max(1, stride(ws.VT, 2)),
                    ws.work, lwork, info, 1, 1)
            end
            chklapackerror(info[])
            # Work around issue with truncated Float32 representation of lwork in
            # sgesdd by using nextfloat. See
            # http://icl.cs.utk.edu/lapack-forum/viewtopic.php?f=13&t=4587&p=11036&hilit=sgesdd#p11036
            # and
            # https://github.com/scipy/scipy/issues/5401
            lwork = round(BlasInt, nextfloat(real(ws.work[1])))
            Base.resize!(ws.work, lwork)
            return ws
        end
        SVDsvdWs(A::AbstractMatrix{$elty}; kwargs...) = Base.resize!(
            SVDsvdWs(similar(A, 0, 0), similar(A, 0, 0), Vector{$elty}(undef, 1),
                Vector{$relty}(undef, 0), Vector{$relty}(undef, 0)),
            A;
            kwargs...)

        # SUBROUTINE DGESVD( JOBU, JOBVT, M, N, A, LDA, S, U, LDU, VT, LDVT, WORK, LWORK, INFO )
        # *     .. Scalar Arguments ..
        #       CHARACTER          JOBU, JOBVT
        #       INTEGER            INFO, LDA, LDU, LDVT, LWORK, M, N
        # *     .. Array Arguments ..
        #       DOUBLE PRECISION   A( LDA, * ), S( * ), U( LDU, * ),
        #                          VT( LDVT, * ), WORK( * )
        function gesvd!(ws::SVDsvdWs, jobu::AbstractChar,
                jobvt::AbstractChar, A::AbstractMatrix{$elty}; resize = true)
            require_one_based_indexing(A)
            chkstride1(A)
            if VERSION >= v"1.11"
                @chkvalidparam 2 jobu ('A', 'S', 'O', 'N')
                @chkvalidparam 3 jobvt ('A', 'S', 'O', 'N')
            end
            (jobu == jobvt == 'O') &&
                throw(ArgumentError("jobu and jobvt cannot both be O"))
            m, n = size(A)
            minmn = min(m, n)
            if jobu == 'A' && size(ws.U) != (m, n)
                if resize
                    resize!(ws, A, jobu = jobu, jobvt = jobvt)
                else
                    throw(ArgumentError("Workspace has wrong size, use resize!()."))
                end
            elseif jobu == 'S' && size(ws.U) != (m, minmn)
                if resize
                    resize!(ws, A, jobu = jobu, jobvt = jobvt)
                else
                    throw(ArgumentError("Workspace has wrong size, use resize!()."))
                end
            elseif jobu == 'O'
                if m >= n
                    if size(ws.U, 1) != m
                        if resize
                            resize!(ws, A, jobu = jobu, jobvt = jobvt)
                        else
                            throw(ArgumentError("Workspace has wrong size, use resize!()."))
                        end
                    end
                else
                    if size(ws.U) != (m, m)
                        if resize
                            resize!(ws, A, jobu = jobu, jobvt = jobvt)
                        else
                            throw(ArgumentError("Workspace has wrong size, use resize!()."))
                        end
                    end
                end
            end
            if jobvt == 'A' && size(ws.VT) != (n, n)
                if resize
                    resize!(ws, A, jobu = jobu, jobvt = jobvt)
                else
                    throw(ArgumentError("Workspace has wrong size, use resize!()."))
                end
            elseif jobvt == 'S' && size(ws.VT) != (minmn, n)
                if resize
                    resize!(ws, A, jobu = jobu, jobvt = jobvt)
                else
                    throw(ArgumentError("Workspace has wrong size, use resize!()."))
                end
            elseif jobvt == 'O'
                if m >= n
                    if size(ws.VT) != (n, n)
                        if resize
                            resize!(ws, A, jobu = jobu, jobvt = jobvt)
                        else
                            throw(ArgumentError("Workspace has wrong size, use resize!()."))
                        end
                    end
                else
                    if size(ws.VT, 1) != n
                        if resize
                            resize!(ws, A, jobu = jobu, jobvt = jobvt)
                        else
                            throw(ArgumentError("Workspace has wrong size, use resize!()."))
                        end
                    end
                end
            end
            cmplx = eltype(A) <: Complex
            info = Ref{BlasInt}()
            if cmplx
                ccall((@blasfunc($gesvd), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{$relty}, Ptr{$elty},
                        Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                        Ref{BlasInt}, Ptr{$relty}, Ref{BlasInt}, Clong, Clong),
                    jobu, jobvt, m, n, A, max(1, stride(A, 2)), ws.S, ws.U,
                    max(1, stride(ws.U, 2)), ws.VT, max(1, stride(ws.VT, 2)),
                    ws.work, length(ws.work), ws.rwork, info, 1, 1)
            else
                ccall((@blasfunc($gesvd), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ptr{$elty},
                        Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                        Ref{BlasInt}, Ref{BlasInt}, Clong, Clong),
                    jobu, jobvt, m, n, A, max(1, stride(A, 2)), ws.S, ws.U,
                    max(1, stride(ws.U, 2)), ws.VT, max(1, stride(ws.VT, 2)),
                    ws.work, length(ws.work), info, 1, 1)
            end
            chklapackerror(info[])
            if jobu == 'O'
                return (A, ws.S, ws.VT)
            elseif jobvt == 'O'
                return (ws.U, ws.S, A)
            else
                return (ws.U, ws.S, ws.VT)
            end
        end
    end
end

"""
    SVDsvdWs(A; jobu = 'A', jobvt = 'A') 

creates a workspace for [`LinearAlgebra.SVD`](https://docs.julialang.org/en/v1/stdlib/LinearAlgebra/#LinearAlgebra.SVD)
factorization using the [`LAPACK.gesvd!`](@ref) function.

# Arguments
- `A::AbstractMatrix`: the matrix to be decomposed. Only the shape of the matrix matters for building the workspace. The actual ellements value does not.
- `jobu::AbstractChar`: one of `A`, `N`, `O` or `S`. Default = 'A'. See [gesvd!](@ref).
- `jobvt::AbstractChar`: one of `A`, `N`, `O` or `S`. Default = 'A'. See [gesvd!](@ref).

# Examples
```jldoctest
julia> A = [1.2 2.3
            6.2 3.3]
2×2 Matrix{Float64}:
 1.2  2.3
 6.2  3.3

julia> ws = SVDsvdWs(A, jobu = 'A', jobvt = 'A')
SVDsvdWs{Float64, Matrix{Float64}, Float64}
  U: 2×2 Matrix{Float64}
  VT: 2×2 Matrix{Float64}
  work: 134-element Vector{Float64}
  S: 2-element Vector{Float64}
  rwork: 0-element Vector{Float64}

julia> t = FastLapackInterface.gesvd!(ws, 'A', 'A', A);

julia> SVD(t[1], t[2], t[3])
SVD{Float64, Float64, Matrix{Float64}, Vector{Float64}}
U factor:
2×2 Matrix{Float64}:
 -0.302437  -0.953169
 -0.953169   0.302437
singular values:
2-element Vector{Float64}:
 7.355199814161389
 1.400369841777625
Vt factor:
2×2 Matrix{Float64}:
 -0.852808  -0.522224
  0.522224  -0.852808
```
"""
SVDsvdWs(A::AbstractMatrix; jobu = 'A', jobvt = 'A')

"""
    gesvd!(ws, jobu, jobvt, A; resize = true) -> (U, S, VT)

Finds the singular value decomposition of `A`, `A = U * S * V'`
using a preallocated [`SVDsvdWs`](@ref).
If `jobu = A`, all the columns of `U` are computed. If `jobvt = A` all the rows
of `V'` are computed. If `jobu = N`, no columns of `U` are computed. If
`jobvt = N` no rows of `V'` are computed. If `jobu = O`, `A` is overwritten with
the columns of (thin) `U`. If `jobvt = O`, `A` is overwritten with the rows
of (thin) `V'`. If `jobu = S`, the columns of (thin) `U` are computed
and returned separately. If `jobvt = S` the rows of (thin) `V'` are
computed and returned separately. `jobu` and `jobvt` can't both be `O`. The value of `jobu` and `jobvt` must be the same in `SVDsvdWs` and in `gesvd!`

Returns `U`, `S`, and `Vt`, where `S` are the singular values of `A`.
If `ws` does not have the appropriate size for `A` and the work to be done,
if `resize=true`, it will be automatically resized accordingly. 
"""
gesvd!(ws::SVDsvdWs, jobu::AbstractChar, jobvt::AbstractChar, A::AbstractMatrix)

"""
    GeneralizedSVDWs

Workspace for [`LinearAlgebra.SVD`](https://docs.julialang.org/en/v1/stdlib/LinearAlgebra/#LinearAlgebra.GeneralizedSVD)
factorization using the [`LAPACK.ggsvd3!`](@ref) function.
"""
mutable struct GeneralizedSVDWs{T, MT <: AbstractMatrix{T}, RT <: AbstractFloat} <:
               Workspace
    alpha::Vector{RT}
    beta::Vector{RT}
    U::MT
    V::MT
    Q::MT
    work::Vector{T}
    rwork::Vector{RT} # Can be rwork if T <: Complex or WI if T <: Float64
    iwork::Vector{BlasInt}
    # add R
end

# (GE) general matrices generalized singular value decomposition
for (ggsvd3, elty, relty) in ((:dggsvd3_, :Float64, :Float64),
    (:sggsvd3_, :Float32, :Float32),
    (:zggsvd3_, :ComplexF64, :Float64),
    (:cggsvd3_, :ComplexF32, :Float32))
    @eval begin
        function Base.resize!(ws::GeneralizedSVDWs, A::AbstractMatrix{$elty},
                B::AbstractMatrix{$elty}; jobu::AbstractChar = 'U',
                jobv::AbstractChar = 'V', jobq::AbstractChar = 'Q')
            require_one_based_indexing(A, B)
            chkstride1(A, B)
            if VERSION >= v"1.11"
                @chkvalidparam 1 jobu ('U', 'N')
                @chkvalidparam 2 jobv ('V', 'N')
                @chkvalidparam 3 jobq ('Q', 'N')
            end
            m, n = size(A)
            if size(B, 2) != n
                throw(DimensionMismatch(lazy"B has second dimension $(size(B,2)) but needs $n"))
            end
            p = size(B, 1)
            k = Ref{BlasInt}()
            l = Ref{BlasInt}()
            lda = max(1, stride(A, 2))
            ldb = max(1, stride(B, 2))
            ws.alpha = similar(A, $relty, n)
            ws.beta = similar(A, $relty, n)
            ldu = max(1, m)
            ws.U = jobu == 'U' ? similar(A, $elty, ldu, m) : similar(A, $elty, 0, 0)
            ldv = max(1, p)
            ws.V = jobv == 'V' ? similar(A, $elty, ldv, p) : similar(A, $elty, 0, 0)
            ldq = max(1, n)
            ws.Q = jobq == 'Q' ? similar(A, $elty, ldq, n) : similar(A, $elty, 0, 0)
            ws.work = Vector{$elty}(undef, 1)
            lwork = BlasInt(-1)
            cmplx = eltype(A) <: Complex
            ws.iwork = Vector{BlasInt}(undef, n)
            info = Ref{BlasInt}()
            if cmplx
                ws.rwork = Vector{$relty}(undef, 2n)
                ccall((@blasfunc($ggsvd3), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{UInt8}, Ref{UInt8}, Ref{BlasInt},
                        Ref{BlasInt}, Ref{BlasInt}, Ref{BlasInt}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                        Ptr{$relty}, Ptr{$relty}, Ptr{$elty}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{$relty}, Ptr{BlasInt},
                        Ref{BlasInt}, Clong, Clong, Clong),
                    jobu, jobv, jobq, m,
                    n, p, k, l,
                    A, lda, B, ldb,
                    ws.alpha, ws.beta, ws.U, ldu,
                    ws.V, ldv, ws.Q, ldq,
                    ws.work, lwork, ws.rwork, ws.iwork,
                    info, 1, 1, 1)
            else
                ccall((@blasfunc($ggsvd3), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{UInt8}, Ref{UInt8}, Ref{BlasInt},
                        Ref{BlasInt}, Ref{BlasInt}, Ref{BlasInt}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                        Ptr{$elty}, Ptr{$elty}, Ptr{$elty}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{BlasInt}, Ref{BlasInt},
                        Clong, Clong, Clong),
                    jobu, jobv, jobq, m,
                    n, p, k, l,
                    A, lda, B, ldb,
                    ws.alpha, ws.beta, ws.U, ldu,
                    ws.V, ldv, ws.Q, ldq,
                    ws.work, lwork, ws.iwork, info,
                    1, 1, 1)
            end
            lwork = BlasInt(ws.work[1])
            resize!(ws.work, lwork)
            return ws
        end
        GeneralizedSVDWs(A::AbstractMatrix{$elty}, B::AbstractMatrix{$elty}; kwargs...) = Base.resize!(
            GeneralizedSVDWs(Vector{$relty}(undef, 0), Vector{$relty}(undef, 0),
                similar(A, 0, 0), similar(A, 0, 0), similar(A, 0, 0),
                Vector{$elty}(undef, 0), Vector{$relty}(undef, 0), Vector{BlasInt}(
                    undef, 0)),
            A,
            B;
            kwargs...)
        #       SUBROUTINE ZGGSVD( JOBU, JOBV, JOBQ, M, N, P, K, L, A, LDA, B,
        #      $                   LDB, ALPHA, BETA, U, LDU, V, LDV, Q, LDQ, WORK,
        #      $                   RWORK, IWORK, INFO )
        # *     .. Scalar Arguments ..
        #       CHARACTER          JOBQ, JOBU, JOBV
        #       INTEGER            INFO, K, L, LDA, LDB, LDQ, LDU, LDV, M, N, P
        # *     ..
        # *     .. Array Arguments ..
        #       INTEGER            IWORK( * )
        #       DOUBLE PRECISION   ALPHA( * ), BETA( * ), RWORK( * )
        #       COMPLEX*16         A( LDA, * ), B( LDB, * ), Q( LDQ, * ),
        #      $                   U( LDU, * ), V( LDV, * ), WORK( * )
        function ggsvd3!(ws::GeneralizedSVDWs, jobu::AbstractChar, jobv::AbstractChar,
                jobq::AbstractChar, A::AbstractMatrix{$elty}, B::AbstractMatrix{$elty},
                resize = true)
            require_one_based_indexing(A, B)
            chkstride1(A, B)
            if VERSION >= v"1.11"
                @chkvalidparam 2 jobu ('U', 'N')
                @chkvalidparam 3 jobv ('V', 'N')
                @chkvalidparam 4 jobq ('Q', 'N')
            end
            m, n = size(A)
            if size(B, 2) != n
                throw(DimensionMismatch(lazy"B has second dimension $(size(B,2)) but needs $n"))
            end
            p = size(B, 1)
            k = Ref{BlasInt}()
            l = Ref{BlasInt}()
            lda = max(1, stride(A, 2))
            ldb = max(1, stride(B, 2))
            ldu = max(1, m)
            ldv = max(1, p)
            ldq = max(1, n)
            if jobu == 'U' && size(ws.U) != (ldu, m)
                if resize
                    resize!(ws, A, jobu = jobu, jobv = jobv, jobq = jobq)
                else
                    throw(ArgumentError("Workspace has wrong size, use resize!()."))
                end
            end
            if jobv == 'V' && size(ws.V) != (ldv, p)
                if resize
                    resize!(ws, A, jobu = jobu, jobv = jobv, jobq = jobq)
                else
                    throw(ArgumentError("Workspace has wrong size, use resize!()."))
                end
            end
            if jobq == 'Q' && size(ws.Q) != (ldq, n)
                if resize
                    resize!(ws, A, jobu = jobu, jobv = jobv, jobq = jobq)
                else
                    throw(ArgumentError("Workspace has wrong size, use resize!()."))
                end
            end
            cmplx = eltype(A) <: Complex
            info = Ref{BlasInt}()
            if cmplx
                ccall((@blasfunc($ggsvd3), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{UInt8}, Ref{UInt8}, Ref{BlasInt},
                        Ref{BlasInt}, Ref{BlasInt}, Ref{BlasInt}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                        Ptr{$relty}, Ptr{$relty}, Ptr{$elty}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{$relty}, Ptr{BlasInt},
                        Ptr{BlasInt}, Clong, Clong, Clong),
                    jobu, jobv, jobq, m,
                    n, p, k, l,
                    A, lda, B, ldb,
                    ws.alpha, ws.beta, ws.U, ldu,
                    ws.V, ldv, ws.Q, ldq,
                    ws.work, length(ws.work), ws.rwork, ws.iwork,
                    info, 1, 1, 1)
            else
                ccall((@blasfunc($ggsvd3), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{UInt8}, Ref{UInt8}, Ref{BlasInt},
                        Ref{BlasInt}, Ref{BlasInt}, Ref{BlasInt}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                        Ptr{$relty}, Ptr{$relty}, Ptr{$elty}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{BlasInt},
                        Ptr{BlasInt}, Clong, Clong, Clong),
                    jobu, jobv, jobq, m,
                    n, p, k, l,
                    A, lda, B, ldb,
                    ws.alpha, ws.beta, ws.U, ldu,
                    ws.V, ldv, ws.Q, ldq,
                    ws.work, length(ws.work), ws.iwork,
                    info, 1, 1, 1)
            end
            chklapackerror(info[])
            if m - k[] - l[] >= 0
                R = triu(A[1:(k[] + l[]), (n - k[] - l[] + 1):n])
            else
                R = triu([A[1:m, (n - k[] - l[] + 1):n];
                          B[(m - k[] + 1):l[], (n - k[] - l[] + 1):n]])
            end
            return ws.U, ws.V, ws.Q, ws.alpha, ws.beta, k[], l[], R
        end
    end
end

"""
    GeneralizedSVDWs(A::AbstractMatrix; jobu = 'U', jobv = 'V', jobq = 'Q')

creates a workspace for [`LinearAlgebra.SVD`](https://docs.julialang.org/en/v1/stdlib/LinearAlgebra/#LinearAlgebra.SVD)
factorization using the [`LAPACK.ggsvd3!`](@ref) function.

# Arguments
- `A::AbstractMatrix`: the matrix to be decomposed. Only the shape of the matrix matters for building the workspace. The actual ellements value does not.
- `jobu::AbstractChar`: one of `U` or `N`. Default = 'U'. See [ggsvd3!](@ref).
- `jobv::AbstractChar`: one of `V` or `N`. Default = 'V'. See [ggsvd3!](@ref).
- `jobq::AbstractChar`: one of `Q` or `N`. Default = 'Q'. See [ggsvd3!](@ref).

# Arguments

# Examples
```jldoctest
julia> A = [1.2 2.3
            6.2 3.3]
2×2 Matrix{Float64}:
 1.2  2.3
 6.2  3.3

julia> B = [2.2 3.3
            5.2 4.3]
2×2 Matrix{Float64}:
 2.2  3.3
 5.2  4.3

julia> ws = GeneralizedSVDWs(A, B)
GeneralizedSVDWs{Float64, Matrix{Float64}, Float64}
  alpha: 2-element Vector{Float64}
  beta: 2-element Vector{Float64}
  U: 2×2 Matrix{Float64}
  V: 2×2 Matrix{Float64}
  Q: 2×2 Matrix{Float64}
  work: 102-element Vector{Float64}
  rwork: 0-element Vector{Float64}
  iwork: 2-element Vector{Int64}


julia> t = FastLapackInterface.ggsvd3!(ws, 'U', 'V', 'Q', A, B);

julia> GeneralizedSVD(t...)
GeneralizedSVD{Float64, Matrix{Float64}, Float64, Vector{Float64}}
U factor:
2×2 Matrix{Float64}:
 -0.309806  0.9508
  0.9508    0.309806
V factor:
2×2 Matrix{Float64}:
 -0.653816  0.756653
  0.756653  0.653816
Q factor:
2×2 Matrix{Float64}:
  0.723532  0.690291
 -0.690291  0.723532
D1 factor:
2×2 Matrix{Float64}:
 0.911256  0.0
 0.0       0.517359
D2 factor:
2×2 Matrix{Float64}:
 0.411841  0.0
 0.0       0.855768
R0 factor:
2×2 Matrix{Float64}:
 2.54834  6.10941
 0.0      8.57328
```
"""
GeneralizedSVDWs(A::AbstractMatrix; jobu::AbstractChar = 'U',
    jobv::AbstractChar = 'V', jobq::AbstractChar = 'Q')

"""
    ggsvd3!(ws, jobu, jobv, jobq, A, B; resize = true) -> (U, V, Q, alpha, beta, k, l, R)

Finds the generalized singular value decomposition of `A` and `B`, `U'*A*Q = D1*R`
and `V'*B*Q = D2*R`, using a preallocated [`GeneralizedSVDWs`](@ref).
`D1` has `alpha` on its diagonal and `D2` has `beta` on its
diagonal. If `jobu = U`, the orthogonal/unitary matrix `U` is computed. If
`jobv = V` the orthogonal/unitary matrix `V` is computed. If `jobq = Q`,
the orthogonal/unitary matrix `Q` is computed. If `jobu`, `jobv`, or `jobq` is
`N`, that matrix is not computed. The value of `jobu`, `jobv` and `jobq` must be the same in `GeneralizedSVDWs` and `ggsvd3!`. This function requires LAPACK 3.6.0.
If `ws` does not have the appropriate size for `A`, `B`, and the work to be done,
if `resize=true`, it will be automatically resized accordingly. 
"""
ggsvd3!(ws::GeneralizedSVDWs, jobu::AbstractChar, jobv::AbstractChar, jobq::AbstractChar,
    A::AbstractMatrix, B::AbstractMatrix; resize = true)

# Workspaces for Eigenvalue decomposition
using LinearAlgebra.LAPACK: chkfinite
import LinearAlgebra.LAPACK: geevx!, syevr!, ggev!

"""
    EigenWs

Workspace for [`LinearAlgebra.Eigen`](https://docs.julialang.org/en/v1/stdlib/LinearAlgebra/#LinearAlgebra.Eigen)
factorization using the [`LAPACK.geevx!`](@ref) function.

# Examples
```jldoctest
julia> A = [1.2 2.3
            6.2 3.3]
2×2 Matrix{Float64}:
 1.2  2.3
 6.2  3.3

julia> ws = EigenWs(A, rvecs=true)
EigenWs{Float64, Matrix{Float64}, Float64}
  work: 260-element Vector{Float64}
  rwork: 2-element Vector{Float64}
  VL: 0×2 Matrix{Float64}
  VR: 2×2 Matrix{Float64}
  W: 2-element Vector{Float64}
  scale: 2-element Vector{Float64}
  iwork: 0-element Vector{Int64}
  rconde: 0-element Vector{Float64}
  rcondv: 0-element Vector{Float64}


julia> t = LAPACK.geevx!(ws, 'N', 'N', 'V', 'N', A);

julia> LinearAlgebra.Eigen(t[2], t[5])
Eigen{Float64, Float64, Matrix{Float64}, Vector{Float64}}
values:
2-element Vector{Float64}:
 -1.6695025194532018
  6.169502519453203
vectors:
2×2 Matrix{Float64}:
 -0.625424  -0.420019
  0.780285  -0.907515
```
"""
mutable struct EigenWs{T, MT <: AbstractMatrix{T}, RT <: AbstractFloat} <: Workspace
    work::Vector{T}
    rwork::Vector{RT} # Can be rwork if T <: Complex or WI if T <: Float64
    VL::MT
    VR::MT
    W::Vector{T} # Can be W or WR
    scale::Vector{RT}
    iwork::Vector{BlasInt}
    rconde::Vector{RT}
    rcondv::Vector{RT}
end

for (geevx, elty, relty) in ((:dgeevx_, :Float64, :Float64),
    (:sgeevx_, :Float32, :Float32),
    (:zgeevx_, :ComplexF64, :Float64),
    (:cgeevx_, :ComplexF32, :Float32))
    @eval begin
        function Base.resize!(ws::EigenWs, A::AbstractMatrix{$elty};
                lvecs = false, rvecs = true, sense = false)
            chkstride1(A)
            n = checksquare(A)
            chkfinite(A) # balancing routines don't support NaNs and Infs

            if sense
                lvecs = true
                rvecs = true
                S = 'B'
            else
                S = 'N'
            end

            jobvl = lvecs ? 'V' : 'N'
            jobvr = rvecs ? 'V' : 'N'

            ws.VL = zeros($elty, (lvecs ? n : 0, n))
            ws.VR = zeros($elty, (rvecs ? n : 0, n))
            cmplx = eltype(A) <: Complex
            resize!(ws.W, n)
            resize!(ws.rwork, cmplx ? 2n : n)

            info = Ref{BlasInt}()

            ilo = Ref{BlasInt}()
            ihi = Ref{BlasInt}()
            resize!(ws.scale, n)
            abnrm = Ref{$relty}()

            resize!(ws.rconde, sense ? n : 0)
            resize!(ws.rcondv, sense ? n : 0)

            resize!(ws.iwork, sense ? 2n - 1 : 0)

            if cmplx
                ccall((@blasfunc($geevx), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{UInt8}, Ref{UInt8}, Ref{UInt8},
                        Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                        Ptr{BlasInt}, Ptr{BlasInt}, Ptr{$relty}, Ptr{$relty},
                        Ptr{$relty}, Ptr{$relty}, Ptr{$elty}, Ref{BlasInt},
                        Ptr{$relty}, Ptr{BlasInt}, Clong, Clong, Clong, Clong),
                    'N', jobvl, jobvr, S,
                    n, A, max(1, stride(A, 2)), ws.W,
                    ws.VL, n, ws.VR, n,
                    ilo, ihi, ws.scale, abnrm,
                    ws.rconde, ws.rcondv, ws.work, -1,
                    ws.rwork, info, 1, 1, 1, 1)

            else
                ccall((@blasfunc($geevx), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{UInt8}, Ref{UInt8}, Ref{UInt8},
                        Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                        Ptr{$elty}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                        Ref{BlasInt}, Ptr{BlasInt}, Ptr{BlasInt}, Ptr{$elty},
                        Ptr{$elty}, Ptr{$elty}, Ptr{$elty}, Ptr{$elty},
                        Ref{BlasInt}, Ptr{BlasInt}, Ptr{BlasInt},
                        Clong, Clong, Clong, Clong),
                    'N', jobvl, jobvr, S,
                    n, A, max(1, stride(A, 2)), ws.W,
                    ws.rwork, ws.VL, n, ws.VR,
                    n, ilo, ihi, ws.scale,
                    abnrm, ws.rconde, ws.rcondv, ws.work,
                    -1, ws.iwork, info,
                    1, 1, 1, 1)
            end
            chklapackerror(info[])
            resize!(ws.work, BlasInt(real(ws.work[1])))
            return ws
        end
        EigenWs(A::AbstractMatrix{$elty}; kwargs...) = resize!(
            EigenWs(Vector{$elty}(undef, 1), $relty[], similar(A, 0, 0),
                similar(A, 0, 0), $elty[], $relty[], BlasInt[], $relty[], $relty[]),
            A;
            kwargs...)

        function geevx!(ws::EigenWs, balanc::AbstractChar, jobvl::AbstractChar,
                jobvr::AbstractChar, sense::AbstractChar, A::AbstractMatrix{$elty}; resize = true)
            n = checksquare(A)
            chkfinite(A) # balancing routines don't support NaNs and Infs
            if balanc ∉ ('N', 'P', 'S', 'B')
                throw(ArgumentError("balanc must be 'N', 'P', 'S', or 'B', but $balanc was passed"))
            end
            if sense ∉ ('N', 'E', 'V', 'B')
                throw(ArgumentError("sense must be 'N', 'E', 'V' or 'B', but $sense was passed"))
            end
            # work, rwork, VL, VR, W, scale, iwork, rconde, rcondv = ws
            if sense ∈ ('E', 'B')
                if jobvl != 'V' || jobvr != 'V'
                    throw(ArgumentError("If sense = $sense it is required that jobvl = 'V' (is $jobvl) and jobvr = 'V' (is $jobvr)."))
                elseif size(ws.iwork, 1) == 0
                    if resize
                        resize!(ws, A, sense = true)
                    else
                        throw(ArgumentError("Workspace was created without support for sense,\n use resize!(ws, A, sense=true)."))
                    end
                end
            end

            if jobvl == 'V' && size(ws.VL, 1) == 0
                if resize
                    resize!(ws, A, lvecs = true, rvecs = size(ws.VR, 1) != 0,
                        sense = size(ws.iwork, 1) != 0)
                else
                    throw(ArgumentError("Workspace was created without support for left eigenvectors,\n use resize!(ws, A, lvecs=true)."))
                end
            end
            if jobvr == 'V' && size(ws.VR, 1) == 0
                if resize
                    resize!(ws, A, rvecs = true, lvecs = size(ws.VL, 1) != 0,
                        sense = size(ws.iwork, 1) != 0)
                else
                    throw(ArgumentError("Workspace was created without support for right eigenvectors,\nor use resize!(ws, A, rvecs=true)."))
                end
            end

            ldvl = size(ws.VL, 1)
            ldvr = size(ws.VR, 1)
            nws = length(ws.W)
            if n != nws
                if resize
                    resize!(ws, A, rvecs = ldvr != 0, lvecs = ldvl != 0,
                        sense = size(ws.iwork, 1) != 0)
                else
                    throw(WorkspaceSizeError(nws, n))
                end
            end

            abnrm = Ref{$relty}()
            ilo = Ref{BlasInt}()
            ihi = Ref{BlasInt}()
            info = Ref{BlasInt}()
            if eltype(A) <: Complex
                ccall((@blasfunc($geevx), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{UInt8}, Ref{UInt8}, Ref{UInt8},
                        Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                        Ref{BlasInt}, Ref{BlasInt}, Ptr{$relty}, Ptr{$relty},
                        Ptr{$relty}, Ptr{$relty}, Ptr{$elty}, Ref{BlasInt},
                        Ptr{$relty}, Ref{BlasInt}, Clong, Clong, Clong, Clong),
                    balanc, jobvl, jobvr, sense,
                    n, A, max(1, stride(A, 2)), ws.W,
                    ws.VL, max(1, ldvl), ws.VR, max(1, ldvr),
                    ilo, ihi, ws.scale, abnrm,
                    ws.rconde, ws.rcondv, ws.work, length(ws.work),
                    ws.rwork, info, 1, 1, 1, 1)
                chklapackerror(info[])
                return A, ws.W, ws.VL, ws.VR, ilo[], ihi[], ws.scale, abnrm[], ws.rconde,
                ws.rcondv
            else
                ccall((@blasfunc($geevx), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{UInt8}, Ref{UInt8}, Ref{UInt8},
                        Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                        Ptr{$elty}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                        Ref{BlasInt}, Ref{BlasInt}, Ref{BlasInt}, Ptr{$elty},
                        Ptr{$elty}, Ptr{$elty}, Ptr{$elty}, Ptr{$elty},
                        Ref{BlasInt}, Ref{BlasInt}, Ref{BlasInt},
                        Clong, Clong, Clong, Clong),
                    balanc, jobvl, jobvr, sense,
                    n, A, max(1, stride(A, 2)), ws.W,
                    ws.rwork, ws.VL, max(1, ldvl), ws.VR,
                    max(1, ldvr), ilo, ihi, ws.scale,
                    abnrm, ws.rconde, ws.rcondv, ws.work,
                    length(ws.work), ws.iwork, info,
                    1, 1, 1, 1)
                chklapackerror(info[])
                return A, ws.W, ws.rwork, ws.VL, ws.VR, ilo[], ihi[], ws.scale, abnrm[],
                ws.rconde, ws.rcondv
            end
        end
    end
end

"""
    geevx!(ws, balanc, jobvl, jobvr, sense, A; resize=true) -> (A, ws.W, [ws.rwork,] ws.VL, ws.VR, ilo, ihi, ws.scale, abnrm, ws.rconde, ws.rcondv)

Finds the eigensystem of `A` with matrix balancing using a preallocated [`EigenWs`](@ref).
If `jobvl = N`, the left eigenvectors of `A` aren't computed. If `jobvr = N`, the right
eigenvectors of `A` aren't computed. If `jobvl = V` or `jobvr = V`, the
corresponding eigenvectors are computed. If `balanc = N`, no balancing is
performed. If `balanc = P`, `A` is permuted but not scaled. If
`balanc = S`, `A` is scaled but not permuted. If `balanc = B`, `A` is
permuted and scaled. If `sense = N`, no reciprocal condition numbers are
computed. If `sense = E`, reciprocal condition numbers are computed for
the eigenvalues only. If `sense = V`, reciprocal condition numbers are
computed for the right eigenvectors only. If `sense = B`, reciprocal
condition numbers are computed for the right eigenvectors and the
eigenvectors. If `sense = E,B`, the right and left eigenvectors must be
computed. `ws.rwork` is only returned in the `Real` case.
If `ws` does not have the appropriate size for `A` and the work to be done,
if `resize=true`, it will be automatically resized accordingly. 
"""
geevx!(ws::EigenWs, balanc::AbstractChar, jobvl::AbstractChar,
    jobvr::AbstractChar, sense::AbstractChar, A::AbstractMatrix; resize = true)

"""
    HermitianEigenWs

Workspace to be used with Hermitian diagonalization using the [`LAPACK.syevr!`](@ref) function.
Supports both `Real` and `Complex` Hermitian matrices.
# Examples
```jldoctest
julia> A = [1.2 2.3
            6.2 3.3]
2×2 Matrix{Float64}:
 1.2  2.3
 6.2  3.3

julia> ws = HermitianEigenWs(A, vecs=true)
HermitianEigenWs{Float64, Matrix{Float64}, Float64}
  work: 66-element Vector{Float64}
  rwork: 0-element Vector{Float64}
  iwork: 20-element Vector{Int64}
  w: 2-element Vector{Float64}
  Z: 2×2 Matrix{Float64}
  isuppz: 4-element Vector{Int64}


julia> LinearAlgebra.Eigen(LAPACK.syevr!(ws, 'V', 'A', 'U', A, 0.0, 0.0, 0, 0, 1e-6)...)
Eigen{Float64, Float64, Matrix{Float64}, Vector{Float64}}
values:
2-element Vector{Float64}:
 -0.2783393759541063
  4.778339375954106
vectors:
2×2 Matrix{Float64}:
 -0.841217  0.540698
  0.540698  0.841217
```
"""
mutable struct HermitianEigenWs{T, MT <: AbstractMatrix{T}, RT <: AbstractFloat} <:
               Workspace
    work::Vector{T}
    rwork::Vector{RT}
    iwork::Vector{BlasInt}
    w::Vector{RT}
    Z::MT
    isuppz::Vector{BlasInt}
end

for (syevr, elty, relty) in ((:zheevr_, :ComplexF64, :Float64),
    (:cheevr_, :ComplexF32, :Float32),
    (:dsyevr_, :Float64, :Float64),
    (:ssyevr_, :Float32, :Float32))
    @eval begin
        function Base.resize!(
                ws::HermitianEigenWs, A::AbstractMatrix{$elty}; vecs = false, work = true)
            chkstride1(A)
            n = checksquare(A)
            resize!(ws.w, n)
            if vecs
                ldz = n
                ws.Z = similar(A, ldz, n)
            else
                ldz = 1
                ws.Z = similar(A, 0, 0)
            end
            resize!(ws.isuppz, 2n)

            if work
                info = Ref{BlasInt}()
                jobz = vecs ? 'V' : 'N'
                cmplx = eltype(A) <: Complex
                if cmplx
                    ccall((@blasfunc($syevr), liblapack), Cvoid,
                        (Ref{UInt8}, Ref{UInt8}, Ref{UInt8}, Ref{BlasInt},
                            Ptr{$elty}, Ref{BlasInt}, Ref{$elty}, Ref{$elty},
                            Ref{BlasInt}, Ref{BlasInt}, Ref{$elty}, Ptr{BlasInt},
                            Ptr{$relty}, Ptr{$elty}, Ref{BlasInt}, Ptr{BlasInt},
                            Ptr{$elty}, Ref{BlasInt}, Ptr{$relty}, Ref{BlasInt},
                            Ptr{BlasInt}, Ref{BlasInt}, Ptr{BlasInt},
                            Clong, Clong, Clong),
                        jobz, 'A', 'U', n,
                        A, max(1, stride(A, 2)), 0, 0,
                        0, 0, 1e-6, Ref{BlasInt}(),
                        ws.w, ws.Z, ldz, ws.isuppz,
                        ws.work, -1, ws.rwork, -1,
                        ws.iwork, -1, info,
                        1, 1, 1)
                    chklapackerror(info[])
                    resize!(ws.rwork, BlasInt(real(ws.rwork[1])))
                else
                    ccall((@blasfunc($syevr), liblapack), Cvoid,
                        (Ref{UInt8}, Ref{UInt8}, Ref{UInt8}, Ref{BlasInt},
                            Ptr{$elty}, Ref{BlasInt}, Ref{$elty}, Ref{$elty},
                            Ref{BlasInt}, Ref{BlasInt}, Ref{$elty}, Ptr{BlasInt},
                            Ptr{$elty}, Ptr{$elty}, Ref{BlasInt}, Ptr{BlasInt},
                            Ptr{$elty}, Ref{BlasInt}, Ptr{BlasInt}, Ref{BlasInt},
                            Ptr{BlasInt}, Clong, Clong, Clong),
                        jobz, 'A', 'U', n,
                        A, max(1, stride(A, 2)), 0, 0,
                        0, 0, 1e-6, Ref{BlasInt}(),
                        ws.w, ws.Z, ldz, ws.isuppz,
                        ws.work, -1, ws.iwork, -1,
                        info, 1, 1, 1)
                    chklapackerror(info[])
                end
                resize!(ws.work, BlasInt(real(ws.work[1])))
                resize!(ws.iwork, BlasInt(real(ws.iwork[1])))
            end
            return ws
        end
        function HermitianEigenWs(A::AbstractMatrix{$elty}; kwargs...)
            return resize!(
                HermitianEigenWs(Vector{$elty}(undef, 1),
                    Vector{$relty}(undef, eltype(A) <: Complex ? 1 : 0),
                    Vector{BlasInt}(undef, 1), $relty[], similar(A, 0, 0), BlasInt[]),
                A;
                kwargs...)
        end

        function syevr!(ws::HermitianEigenWs, jobz::AbstractChar, range::AbstractChar,
                uplo::AbstractChar, A::AbstractMatrix{$elty},
                vl::AbstractFloat, vu::AbstractFloat, il::Integer, iu::Integer,
                abstol::AbstractFloat; resize = true)
            if range == 'I' && !(1 <= il <= iu <= n)
                throw(ArgumentError("illegal choice of eigenvalue indices (il = $il, iu=$iu), which must be between 1 and n = $n"))
            end
            if range == 'V' && vl >= vu
                throw(ArgumentError("lower boundary, $vl, must be less than upper boundary, $vu"))
            end

            chkstride1(A)
            n = checksquare(A)
            nws = length(ws.w)
            if nws != n
                if resize
                    resize!(ws, A, vecs = size(ws.Z, 1) > 1 || jobz == 'V', work = n > nws)
                else
                    throw(WorkspaceSizeError(nws, n))
                end
            end

            # If WS was created without support for vectors
            if jobz == 'N'
                ldz = 1
            elseif jobz == 'V'
                ldz = n
                nws = size(ws.Z, 1)
                if nws != ldz
                    if resize
                        ws.Z = similar(ws.Z, ldz, ldz)
                    else
                        throw(ArgumentError("Workspace does not support eigenvectors.\nUse resize!(ws, A, vecs=true)."))
                    end
                end
            end

            m = Ref{BlasInt}()
            info = Ref{BlasInt}()
            if eltype(A) <: Complex
                ccall((@blasfunc($syevr), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{UInt8}, Ref{UInt8}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ref{$elty}, Ref{$elty},
                        Ref{BlasInt}, Ref{BlasInt}, Ref{$elty}, Ptr{BlasInt},
                        Ptr{$relty}, Ptr{$elty}, Ref{BlasInt}, Ptr{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{$relty}, Ref{BlasInt},
                        Ref{BlasInt}, Ref{BlasInt}, Ref{BlasInt},
                        Clong, Clong, Clong),
                    jobz, range, uplo, n,
                    A, max(1, stride(A, 2)), vl, vu,
                    il, iu, abstol, m,
                    ws.w, ws.Z, ldz, ws.isuppz,
                    ws.work, length(ws.work), ws.rwork, length(ws.rwork),
                    ws.iwork, length(ws.iwork), info,
                    1, 1, 1)
            else
                ccall((@blasfunc($syevr), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{UInt8}, Ref{UInt8}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ref{$elty}, Ref{$elty},
                        Ref{BlasInt}, Ref{BlasInt}, Ref{$elty}, Ref{BlasInt},
                        Ptr{$elty}, Ptr{$elty}, Ref{BlasInt}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{BlasInt}, Ref{BlasInt},
                        Ref{BlasInt}, Clong, Clong, Clong),
                    jobz, range, uplo, n,
                    A, max(1, stride(A, 2)), vl, vu,
                    il, iu, abstol, m,
                    ws.w, ws.Z, ldz, ws.isuppz,
                    ws.work, length(ws.work), ws.iwork, length(ws.iwork),
                    info, 1, 1, 1)
            end
            chklapackerror(info[])
            if range == 'A'
                return ws.w, ws.Z
            elseif range == 'I'
                return ws.w[1:(iu - il + 1)], ws.Z[1:ldz, 1:(jobz == 'V' ? iu - il + 1 : 0)]
            else
                return ws.w[1:m[]], ws.Z[1:ldz, 1:(jobz == 'V' ? m[] : 0)]
            end
        end
    end
end

"""
    syevr!(ws, jobz, range, uplo, A, vl, vu, il, iu, abstol; resize=true) -> (ws.W, ws.Z)

Finds the eigenvalues (`jobz = N`) or eigenvalues and eigenvectors
(`jobz = V`) of a symmetric matrix `A` using a preallocated [`HermitianEigenWs`](@ref).
If the workspace is not appropriate for `A` and `resize==true` it will be automatically
resized.
If `uplo = U`, the upper triangle of `A` is used. If `uplo = L`, the lower triangle of `A` is used.
If `range = A`, all the eigenvalues are found. If `range = V`, the
eigenvalues in the half-open interval `(vl, vu]` are found.
If `range = I`, the eigenvalues with indices between `il` and `iu` are
found. `abstol` can be set as a tolerance for convergence.

The eigenvalues are returned as `ws.W` and the eigenvectors in `ws.Z`.
"""
syevr!(ws::HermitianEigenWs, jobz::AbstractChar, range::AbstractChar,
    uplo::AbstractChar, A::AbstractMatrix,
    vl::AbstractFloat, vu::AbstractFloat, il::Integer, iu::Integer,
    abstol::AbstractFloat; resize = true)

"""
    GeneralizedEigenWs

Workspace that can be used for [`LinearAlgebra.GeneralizedEigen`](https://docs.julialang.org/en/v1/stdlib/LinearAlgebra/#LinearAlgebra.GeneralizedEigen)
factorization using [`LAPACK.ggev!`](@ref).
Supports `Real` and `Complex` matrices.

# Examples
```jldoctest
julia> A = [1.2 2.3
            6.2 3.3]
2×2 Matrix{Float64}:
 1.2  2.3
 6.2  3.3

julia> B = [8.2 1.7
            5.9 2.1]
2×2 Matrix{Float64}:
 8.2  1.7
 5.9  2.1

julia> ws = GeneralizedEigenWs(A, rvecs=true)
GeneralizedEigenWs{Float64, Matrix{Float64}, Float64}
  work: 78-element Vector{Float64}
  vl: 0×2 Matrix{Float64}
  vr: 2×2 Matrix{Float64}
  αr: 2-element Vector{Float64}
  αi: 2-element Vector{Float64}
  β: 2-element Vector{Float64}


julia> αr, αi, β, _, vr = LAPACK.ggev!(ws, 'N', 'V', A, B);

julia> LinearAlgebra.GeneralizedEigen(αr ./ β, vr)
GeneralizedEigen{Float64, Float64, Matrix{Float64}, Vector{Float64}}
values:
2-element Vector{Float64}:
 -0.8754932558185097
  1.6362721153456299
vectors:
2×2 Matrix{Float64}:
 -0.452121  -0.0394242
  1.0        1.0
```
"""
mutable struct GeneralizedEigenWs{T, MT <: AbstractMatrix{T}, RT <: AbstractFloat} <:
               Workspace
    work::Vector{T}
    vl::MT
    vr::MT
    αr::Vector{T}
    αi::Vector{RT}
    β::Vector{T}
end

for (ggev, elty, relty) in ((:dggev_, :Float64, :Float64),
    (:sggev_, :Float32, :Float32),
    (:zggev_, :ComplexF64, :Float64),
    (:cggev_, :ComplexF32, :Float32))
    @eval begin
        function Base.resize!(ws::GeneralizedEigenWs, A::AbstractMatrix{$elty};
                lvecs = false, rvecs = false, work = true)
            require_one_based_indexing(A)
            chkstride1(A)
            n = checksquare(A)
            lda = max(1, stride(A, 2))
            ldb = lda
            resize!(ws.αr, n)
            cmplx = eltype(A) <: Complex
            if cmplx && work
                resize!(ws.αi, 8n)
            else
                resize!(ws.αi, n)
            end
            resize!(ws.β, n)

            jobvl = lvecs ? 'V' : 'N'
            jobvr = rvecs ? 'V' : 'N'
            ldvl = lvecs ? n : 1
            ldvr = rvecs ? n : 1
            ws.vl = zeros($elty, lvecs ? n : 0, n)
            ws.vr = zeros($elty, rvecs ? n : 0, n)
            if work
                info = Ref{BlasInt}()
                if cmplx
                    ccall((@blasfunc($ggev), liblapack), Cvoid,
                        (Ref{UInt8}, Ref{UInt8}, Ref{BlasInt}, Ptr{$elty},
                            Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                            Ptr{$elty}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                            Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$relty},
                            Ptr{BlasInt}, Clong, Clong),
                        jobvl, jobvr, n, A,
                        lda, A, ldb, ws.αr,
                        ws.β, ws.vl, ldvl, ws.vr,
                        ldvr, ws.work, -1, ws.αi,
                        info, 1, 1)
                else
                    ccall((@blasfunc($ggev), liblapack), Cvoid,
                        (Ref{UInt8}, Ref{UInt8}, Ref{BlasInt}, Ptr{$elty},
                            Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                            Ptr{$elty}, Ptr{$elty}, Ptr{$elty}, Ref{BlasInt},
                            Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                            Ptr{BlasInt}, Clong, Clong),
                        jobvl, jobvr, n, A,
                        lda, A, ldb, ws.αr,
                        ws.αi, ws.β, ws.vl, ldvl,
                        ws.vr, ldvr, ws.work, -1,
                        info, 1, 1)
                end
                chklapackerror(info[])
                resize!(ws.work, BlasInt(ws.work[1]))
            end
            return ws
        end
        function GeneralizedEigenWs(A::AbstractMatrix{$elty}; kwargs...)
            return resize!(
                GeneralizedEigenWs(Vector{$elty}(undef, 1), similar(A, 0, 0),
                    similar(A, 0, 0), $elty[], $relty[], $elty[]),
                A;
                kwargs...)
        end

        function ggev!(ws::GeneralizedEigenWs, jobvl::AbstractChar, jobvr::AbstractChar,
                A::AbstractMatrix{$elty}, B::AbstractMatrix{$elty}; resize = true)
            require_one_based_indexing(A, B)
            chkstride1(A, B)
            n = checksquare(A)
            m = checksquare(B)
            if n != m
                throw(DimensionMismatch("A has dimensions $(size(A)), and B has dimensions $(size(B)), but A and B must have the same size"))
            end
            lda = max(1, stride(A, 2))
            ldb = max(1, stride(B, 2))

            nws = length(ws.β)
            if nws != n
                if resize
                    resize!(ws, A, lvecs = size(ws.vl, 1) > 0 || jobvl == 'V',
                        rvecs = size(ws.vr, 1) > 0 || jobvl == 'V', work = n > nws)
                else
                    throw(WorkspaceSizeError(nws, n))
                end
            end

            ldvl = size(ws.vl, 1)
            ldvr = size(ws.vr, 1)

            for (job, v, str1, str2) in (
                (jobvl, :vl, "left", "lvecs"), (jobvr, :vr, "right", "rvecs"))
                ldv = size(getfield(ws, v), 1)
                if job == 'V'
                    if ldv != n
                        if resize
                            setfield!(ws, v, similar(A, n, n))
                        else
                            throw(ArgumentError("Workspace was created without support for $str1 eigenvectors or too small,\n use resize!(ws, A, $str2=true)."))
                        end
                    end
                end
            end

            ldvl = size(ws.vl, 1)
            ldvr = size(ws.vr, 1)

            info = Ref{BlasInt}()
            if eltype(A) <: Complex
                ccall((@blasfunc($ggev), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{UInt8}, Ref{BlasInt}, Ptr{$elty},
                        Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                        Ptr{$elty}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                        Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$relty},
                        Ptr{BlasInt}, Clong, Clong),
                    jobvl, jobvr, n, A,
                    lda, B, ldb, ws.αr,
                    ws.β, ws.vl, max(ldvl, 1), ws.vr,
                    max(ldvl, 1), ws.work, length(ws.work), ws.αi,
                    info, 1, 1)
                chklapackerror(info[])
                return ws.αr, ws.β, ws.vl, ws.vr

            else
                ccall((@blasfunc($ggev), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{UInt8}, Ref{BlasInt}, Ptr{$elty},
                        Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                        Ptr{$elty}, Ptr{$elty}, Ptr{$elty}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                        Ptr{BlasInt}, Clong, Clong),
                    jobvl, jobvr, n, A,
                    lda, B, ldb, ws.αr,
                    ws.αi, ws.β, ws.vl, max(ldvl, 1),
                    ws.vr, max(ldvr, 1), ws.work, length(ws.work),
                    info, 1, 1)
                chklapackerror(info[])
                return ws.αr, ws.αi, ws.β, ws.vl, ws.vr
            end
        end
    end
end

"""
    ggev!(ws, jobvl, jobvr, A, B; resize=true) -> (ws.αr, [ws.αi,], ws.β, ws.vl, ws.vr)

Finds the generalized eigendecomposition of `A` and `B` usin a preallocated [`GeneralizedEigenWs`](@ref).
If the workspace is not appropriately sized and `resize == true`, it will automatically be
resized.
If `jobvl = N`, the left eigenvectors aren't computed. If `jobvr = N`, the right
eigenvectors aren't computed. If `jobvl = V` or `jobvr = V`, the
corresponding eigenvectors are computed. `ws.αi` is only returned in the `Real` case.
"""
ggev!(ws::GeneralizedEigenWs, jobvl::AbstractChar, jobvr::AbstractChar, A::AbstractMatrix,
    B::AbstractMatrix; resize = true)

using Random
using Test
using FastLapackInterface
using LinearAlgebra


function make_matrix(n)
    Random.seed!(123)
    A = randn(n, n)
    FA = eigen(A)
    k = findall(abs.(FA.values) .> 1.0)
    FA.values[k] .= 1.0
    B = real.(FA.vectors*diagm(FA.values)*inv(FA.vectors))
    FB = schur(B)
    return B, sum(abs.(FB.values) .> 1.0)
end

@testset "SchurWs" begin
    n = 10
    @testset "Real, square" begin
        A0 = randn(n, n)
        ws = SchurWs(copy(A0))

        A1, vs1, wr1 = LAPACK.gees!('V', copy(A0))
        A2, vs2, wr2 = LAPACK.gees!(ws, 'V', copy(A0))
        @test isapprox(A1, A2)
        @test isapprox(vs1, vs2)
        @test isapprox(wr1, wr2)
        # using Workspace, factorize!
        ws = Workspace(LAPACK.gees!, copy(A0))
        A2, vs2, wr2 = factorize!(ws, 'V', copy(A0))
        @test isapprox(A1, A2)
        @test isapprox(vs1, vs2)
        @test isapprox(wr1, wr2)
        show(devnull, "text/plain", ws)
        for div in (-1,1)
            @test_throws FastLapackInterface.WorkspaceSizeError factorize!(ws, 'V', randn(n+div, n+div); resize=false)
            factorize!(ws, 'V', randn(n+div, n+div))
            @test length(ws.wr) == n+div
        end
        
    end

    @testset "Real, square, select" begin
        A0 = [0.689816 0.173898 -0.489104
              -1.48437 1.06514 2.19973
              -0.239769 1.57603 0.330085]

        ws1 = SchurWs(copy(A0))
        A1, vs1, wr1 = LAPACK.gees!(ws1, 'V', copy(A0);
                                    select = (wr, wi) -> wi^2 + wr^2 >= 1)
        @test ws1.sdim[] == 2

        ws2 = SchurWs(copy(A0))
        A2, vs2, wr2 = LAPACK.gees!(ws2, 'V', copy(A0))
        @test wr1[1] == wr2[1]
        @test wr1[2] == wr2[3]
        @test wr1[3] == wr2[2]
    end
    @testset "Select keywords" begin
        n = 10
        A0, nunstable = make_matrix(n)
        ws = SchurWs(copy(A0))
        LAPACK.gees!(ws, 'V', copy(A0), select = FastLapackInterface.lp, criterium = -1e-6)
        @test count(real(ws.eigen_values) .< -1e-6) == ws.sdim[]
        LAPACK.gees!(ws, 'V', copy(A0), select = FastLapackInterface.rp, criterium = -1e-6)
        @test count(real(ws.eigen_values) .>= -1e-6) == ws.sdim[]
        LAPACK.gees!(ws, 'V', copy(A0), select = FastLapackInterface.id, criterium = 1 + 1e-6)
        @test count(abs.(ws.eigen_values) .< 1 + 1e-6) == ws.sdim[]
        LAPACK.gees!(ws, 'V', copy(A0), select = FastLapackInterface.ed, criterium = 1 + 1e-6)
        @test count(abs.(ws.eigen_values) .>= 1 + 1e-6) == ws.sdim[]
    end
end

@testset "GeneralizedSchurWs" begin
    n = 10
    @testset "Real, square" begin
        A0 = randn(n, n)
        B0 = randn(n, n)
        ws = GeneralizedSchurWs(copy(A0))

        A1, B1, α1, β1, vsl1, vsr1 = LAPACK.gges!('V', 'V', copy(A0), copy(B0))
        A2, B2, α2, β2, vsl2, vsr2 = LAPACK.gges!(ws, 'V', 'V', copy(A0), copy(B0))
        @test isapprox(A1, A2)
        @test isapprox(B1, B2)
        @test isapprox(α1, α2)
        @test isapprox(β1, β2)
        @test isapprox(vsl1, vsl2)
        @test isapprox(vsr1, vsr2)

        # Using Workspace, factorize!
        ws = Workspace(LAPACK.gges!, copy(A0))
        A2, B2, α2, β2, vsl2, vsr2 = factorize!(ws, 'V', 'V', copy(A0), copy(B0))
        @test isapprox(A1, A2)
        @test isapprox(B1, B2)
        @test isapprox(α1, α2)
        @test isapprox(β1, β2)
        @test isapprox(vsl1, vsl2)
        @test isapprox(vsr1, vsr2)
        @test isapprox(sort(abs.(eigen(A0, B0).values)), sort(abs.(ws.eigen_values)))

        show(devnull, "text/plain", ws)

        for div in (-1,1)
            @test_throws FastLapackInterface.WorkspaceSizeError factorize!(ws, 'V', 'V', randn(n+div, n+div), randn(n+div, n+div); resize=false)
            factorize!(ws, 'V', 'V', randn(n+div, n+div), randn(n+div, n+div))
            @test length(ws.αr) == n+div
        end
    end

    #TODO: This should be tested with something realistic
    @testset "Real, square, select" begin
        A0 = [-1.1189 -1.1333 -0.985796
              1.32901 0.628691 0.651912
              0.924541 0.287144 -1.09629]

        B0 = [-0.256655 -0.626563 -0.948712
              0.00727555 0.701693 -0.498145
              0.86268 -0.212549 -0.211994]
        ws = GeneralizedSchurWs(copy(A0))

        CRITERIUM = 1 + 1e-6
        
        A0, B0, α, β, vsl, vsr = LAPACK.gges!(ws, 'V', 'V', copy(A0),
                                                copy(B0);
                                                select = (ar, ai, b) -> ar^2 + ai^2 <
                                                                        CRITERIUM *
                                                                        b^2)
        A0, B0, α, β, vsl, vsr = LAPACK.gges!(ws, 'V', 'V', copy(A0),
                                              copy(B0);
                                              select = FastLapackInterface.id,
                                              criterium = CRITERIUM)
        @test ws.sdim[] == 1
        @test (real(α[1])/β[1])^2 < CRITERIUM 
        @test (real(α[2])/β[2])^2 > CRITERIUM 
        @test (real(α[3])/β[3])^2 > CRITERIUM
        @test isapprox(sort(abs.(eigen(A0, B0).values)), sort(abs.(ws.eigen_values)))
        show(devnull, "text/plain", ws)
    end

    @testset "Select keywords" begin
        n = 10
        A0, nunstable = make_matrix(n)
        ws = GeneralizedSchurWs(copy(A0))

        CRITERIUM = -1e-6
        LAPACK.gges!(ws, 'V', 'V', copy(A0), Matrix(1.0*I(n));
                     select = FastLapackInterface.lp,
                     criterium = CRITERIUM)
        @test count(real(ws.eigen_values) .< CRITERIUM) == ws.sdim[]
        LAPACK.gges!(ws, 'V', 'V', copy(A0), Matrix(1.0*I(n));
                     select = FastLapackInterface.rp,
                     criterium = CRITERIUM)
        CRITERIUM = 1 - 1e-6
        LAPACK.gges!(ws, 'V', 'V', copy(A0), Matrix(1.0*I(n));
                     select = FastLapackInterface.id,
                     criterium = CRITERIUM)
        @test count(abs.(ws.eigen_values) .< CRITERIUM) == ws.sdim[]
        LAPACK.gges!(ws, 'V', 'V', copy(A0), Matrix(1.0*I(n));
                     select = FastLapackInterface.ed,
                     criterium = CRITERIUM)
        @test count(abs.(ws.eigen_values) .>= CRITERIUM) == ws.sdim[]
    end
end

module BenchBunchKaufman
using BenchmarkTools
using FastLapackInterface
using LinearAlgebra, LinearAlgebra.LAPACK

const sizes = (3, 4, 5, 10, 50, 100)
const vector_length = 100

const suite = BenchmarkGroup()

#### BunchKaufman

suite["BunchKaufman"] = BenchmarkGroup()
suite["BunchKaufman"]["creation"] = BenchmarkGroup()

for n in sizes
    A = rand(n, n)
    suite["BunchKaufman"]["creation"]["$n"] = @benchmarkable BunchKaufmanWs($A)
end
suite["BunchKaufman"]["sytrf!"]              = BenchmarkGroup()
suite["BunchKaufman"]["sytrf!"]["workspace"] = BenchmarkGroup()
suite["BunchKaufman"]["sytrf!"]["LAPACK"]    = BenchmarkGroup()

function bench_sytrf!(As, ws)
    for A in As
        LAPACK.sytrf!(ws,'U', A)
    end
end
function bench_sytrf!(As)
    for A in As
        LAPACK.sytrf!('U', A)
    end
end

for n in sizes
    As = [rand(n, n) for i in 1:vector_length]
    ws = BunchKaufmanWs(As[1])
    suite["BunchKaufman"]["sytrf!"]["workspace"]["$n"] = @benchmarkable bench_sytrf!($As, $ws)
    suite["BunchKaufman"]["sytrf!"]["LAPACK"]["$n"] = @benchmarkable bench_sytrf!($As)
end

suite["BunchKaufman"]["sytrf_rook!"]              = BenchmarkGroup()
suite["BunchKaufman"]["sytrf_rook!"]["workspace"] = BenchmarkGroup()
suite["BunchKaufman"]["sytrf_rook!"]["LAPACK"]    = BenchmarkGroup()

function bench_sytrf_rook!(As, ws)
    for A in As
        LAPACK.sytrf_rook!(ws,'U', A)
    end
end
function bench_sytrf_rook!(As)
    for A in As
        LAPACK.sytrf_rook!('U', A)
    end
end

for n in sizes
    As = [rand(n, n) for i in 1:vector_length]
    ws = BunchKaufmanWs(As[1])
    suite["BunchKaufman"]["sytrf_rook!"]["workspace"]["$n"] = @benchmarkable bench_sytrf_rook!($As, $ws)
    suite["BunchKaufman"]["sytrf_rook!"]["LAPACK"]["$n"] = @benchmarkable bench_sytrf_rook!($As)
end

suite["BunchKaufman"]["hetrf!"]              = BenchmarkGroup()
suite["BunchKaufman"]["hetrf!"]["workspace"] = BenchmarkGroup()
suite["BunchKaufman"]["hetrf!"]["LAPACK"]    = BenchmarkGroup()

function bench_hetrf!(As, ws)
    for A in As
        LAPACK.hetrf!(ws,'U', A)
    end
end
function bench_hetrf!(As)
    for A in As
        LAPACK.hetrf!('U', A)
    end
end

for n in sizes
    As = [rand(ComplexF64, n, n) for i in 1:vector_length]
    ws = BunchKaufmanWs(As[1])
    suite["BunchKaufman"]["hetrf!"]["workspace"]["$n"] = @benchmarkable bench_hetrf!($As, $ws)
    suite["BunchKaufman"]["hetrf!"]["LAPACK"]["$n"] = @benchmarkable bench_hetrf!($As)
end

suite["BunchKaufman"]["hetrf_rook!"]              = BenchmarkGroup()
suite["BunchKaufman"]["hetrf_rook!"]["workspace"] = BenchmarkGroup()
suite["BunchKaufman"]["hetrf_rook!"]["LAPACK"]    = BenchmarkGroup()

function bench_hetrf_rook!(As, ws)
    for A in As
        LAPACK.hetrf_rook!(ws,'U', A)
    end
end
function bench_hetrf_rook!(As)
    for A in As
        LAPACK.hetrf_rook!('U', A)
    end
end

for n in sizes
    As = [rand(ComplexF64, n, n) for i in 1:vector_length]
    ws = BunchKaufmanWs(As[1])
    suite["BunchKaufman"]["hetrf_rook!"]["workspace"]["$n"] = @benchmarkable bench_hetrf_rook!($As, $ws)
    suite["BunchKaufman"]["hetrf_rook!"]["LAPACK"]["$n"] = @benchmarkable bench_hetrf_rook!($As)
end

end
BenchBunchKaufman.suite

using Test
using FastLapackInterface
using LinearAlgebra.LAPACK

@testset "CholeskyPivotedWs" begin
    for T in (Float32, Float64, ComplexF32, ComplexF64)
        @testset "$(T) pstrf!" begin
            A = T[1 0 0 0 0;0 3.1 0.1 0 0; 2.0 0.0 5.0 0 0; 0 0 0 1 0; 0 0 0 0 1]
            n = size(A, 1)
            A = (A .+ A') ./ 2
            ws = CholeskyPivotedWs(copy(A))
            
            A1, ipiv1, rank1, inf1 = LAPACK.pstrf!('U', copy(A), 1e-16) 
            A2, ipiv2, rank2, inf2 = LAPACK.pstrf!(ws, 'U', copy(A), 1e-16)
            @test A1 == A2
            @test ipiv1 == ipiv2
            @test rank1 == rank2

            ws = Workspace(LAPACK.pstrf!, copy(A))
            A1, ipiv1, rank1, inf1 = decompose!(ws, Hermitian(copy(A)), 1e-16)
            @test A1 == A2
            @test ipiv1 == ipiv2
            @test rank1 == rank2
            
            A1, ipiv1, rank1, inf1 = decompose!(ws, 'U', copy(A), 1e-16)
            @test A1 == A2
            @test ipiv1 == ipiv2
            @test rank1 == rank2

            A = T[1 0 0 0 0;0 3.1 0.1 0 0; 2.0 0.0 5.0 0 0; 0 0 0 1 0; 0 0 0 0 1]
            n = size(A, 1)
            A = (A .+ A') ./ 2
            decompose!(ws,'U', A, 1e-16)
            @test length(ws.piv) == n
        end
    end
end

# TODO: LinearAlgebra.qr! method that works with any workspace
import LinearAlgebra.LAPACK: geqrf!, ormqr!, geqrt!, geqp3!, orgqr!, orgql!

"""
    QRWs

Workspace for standard [`LinearAlgebra.QR`](https://docs.julialang.org/en/v1/stdlib/LinearAlgebra/#LinearAlgebra.QR)
factorization using the [`LAPACK.geqrf!`](@ref) function.

# Examples
```jldoctest
julia> A = [1.2 2.3
            6.2 3.3]
2×2 Matrix{Float64}:
 1.2  2.3
 6.2  3.3

julia> ws = QRWs(A)
QRWs{Float64}
  work: 64-element Vector{Float64}
  τ: 2-element Vector{Float64}

julia> t = QR(LAPACK.geqrf!(ws, A)...)
QR{Float64, Matrix{Float64}, Vector{Float64}}
Q factor: 2×2 LinearAlgebra.QRPackedQ{Float64, Matrix{Float64}, Vector{Float64}}
R factor:
2×2 Matrix{Float64}:
 -6.31506  -3.67692
  0.0      -1.63102

julia> Matrix(t)
2×2 Matrix{Float64}:
 1.2  2.3
 6.2  3.3
```
"""
struct QRWs{T <: Number} <: Workspace
    work::Vector{T}
    τ::Vector{T}
end

Base.length(ws::QRWs) = length(ws.τ)

for (geqrf, elty) in ((:dgeqrf_, :Float64),
    (:sgeqrf_, :Float32),
    (:zgeqrf_, :ComplexF64),
    (:cgeqrf_, :ComplexF32))
    @eval begin
        function Base.resize!(ws::QRWs, A::StridedMatrix{$elty}; work = true)
            m, n = size(A)
            minmn = min(m, n)
            lda = max(1, stride(A, 2))
            resize!(ws.τ, minmn)
            if work && minmn > 0
                info = Ref{BlasInt}()
                ccall((@blasfunc($geqrf), liblapack), Cvoid,
                    (Ref{BlasInt}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{BlasInt}),
                    m, n, A, lda, ws.τ, ws.work, -1, info)
                chklapackerror(info[])
                resize!(ws.work, BlasInt(real(ws.work[1])))
            end
            return ws
        end
        QRWs(A::StridedMatrix{$elty}) = resize!(
            QRWs(Vector{$elty}(undef, 1), Vector{$elty}(undef, 1)), A)

        function geqrf!(ws::QRWs, A::AbstractMatrix{$elty}; resize = true)
            require_one_based_indexing(A)
            chkstride1(A)
            m, n = size(A)
            nws = length(ws)
            minmn = min(m, n)
            if nws != minmn
                if resize
                    resize!(ws, A; work = minmn > nws)
                else
                    throw(WorkspaceSizeError(nws, minmn))
                end
            end
            lda = max(1, stride(A, 2))
            lwork = max(1, length(ws.work))
            info = Ref{BlasInt}() # This actually doesn't cause allocations
            if minmn > 0
                ccall((@blasfunc($geqrf), liblapack), Cvoid,
                    (Ref{BlasInt}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{BlasInt}),
                    m, n, A, lda, ws.τ, ws.work, lwork, info)
                chklapackerror(info[])
            end
            return A, ws.τ
        end
    end
end
"""
    geqrf!(ws, A; resize=true) -> (A, ws.τ)

Compute the `QR` factorization of `A`, `A = QR`, using previously allocated [`QRWs`](@ref) workspace `ws`.
`ws.τ` contains scalars which parameterize the elementary reflectors of the factorization.
`ws.τ` must have length greater than or equal to the smallest dimension of `A`.
If this is not the case, and `resize==true` the workspace will be automatically
resized to the appropriate size.

`A` and `ws.τ` modified in-place.
"""
geqrf!(ws::QRWs, A::AbstractMatrix; kwargs...)

"""
    QRWYWs

Workspace to be used with the [`LinearAlgebra.QRCompactWY`](https://docs.julialang.org/en/v1/stdlib/LinearAlgebra/#LinearAlgebra.QRCompactWY)
representation of the blocked QR factorization which uses the [`LAPACK.geqrt!`](@ref) function.
By default the blocksize for the algorithm is taken as `min(36, min(size(template)))`, this can be
overridden by using the `blocksize` keyword of the constructor.

# Examples
```jldoctest
julia> A = [1.2 2.3
            6.2 3.3]
2×2 Matrix{Float64}:
 1.2  2.3
 6.2  3.3

julia> ws = QRWYWs(A)
QRWYWs{Float64, Matrix{Float64}}
  work: 4-element Vector{Float64}
  T: 2×2 Matrix{Float64}

julia> t = LinearAlgebra.QRCompactWY(LAPACK.geqrt!(ws, A)...)
LinearAlgebra.QRCompactWY{Float64, Matrix{Float64}, Matrix{Float64}}
Q factor: 2×2 LinearAlgebra.QRCompactWYQ{Float64, Matrix{Float64}, Matrix{Float64}}
R factor:
2×2 Matrix{Float64}:
 -6.31506  -3.67692
  0.0      -1.63102

julia> Matrix(t)
2×2 Matrix{Float64}:
 1.2  2.3
 6.2  3.3
```
"""
mutable struct QRWYWs{R <: Number, MT <: StridedMatrix{R}} <: Workspace
    work::Vector{R}
    T::MT
end

function Base.resize!(ws::QRWYWs, A::StridedMatrix; blocksize = 36, work = true)
    require_one_based_indexing(A)
    chkstride1(A)
    m, n = BlasInt.(size(A))
    minmn = min(m, n)
    nb = min(minmn, blocksize)
    ws.T = similar(ws.T, nb, minmn)
    if work
        resize!(ws.work, nb * n)
    end
    return ws
end

function QRWYWs(A::StridedMatrix{T}; kwargs...) where {T <: LinearAlgebra.BlasFloat}
    resize!(QRWYWs(T[], Matrix{T}(undef, 0, 0)), A; kwargs...)
end

for (geqrt, elty) in ((:dgeqrt_, :Float64),
    (:sgeqrt_, :Float32),
    (:zgeqrt_, :ComplexF64),
    (:cgeqrt_, :ComplexF32))
    @eval function geqrt!(ws::QRWYWs, A::AbstractMatrix{$elty}; resize = true)
        require_one_based_indexing(A)
        chkstride1(A)
        m, n = size(A)
        minmn = min(m, n)
        nb = size(ws.T, 1)
        if nb != minmn
            if resize
                resize!(ws, A, work = nb < minmn)
            else
                throw(WorkspaceSizeError(nb, minmn))
            end
        end
        nb = size(ws.T, 1)

        lda = max(1, stride(A, 2))
        work = ws.work
        info = Ref{BlasInt}()
        if minmn > 0
            ccall((@blasfunc($geqrt), liblapack), Cvoid,
                (Ref{BlasInt}, Ref{BlasInt}, Ref{BlasInt}, Ptr{$elty},
                    Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                    Ptr{BlasInt}),
                m, n, nb, A,
                lda, ws.T, max(1, stride(ws.T, 2)), ws.work,
                info)
            chklapackerror(info[])
        end
        return A, ws.T
    end
end

"""
    geqrt!(ws, A; resize=true) -> (A, ws.T)

Compute the blocked `QR` factorization of `A`, `A = QR`, using a preallocated [`QRWYWs`](@ref) workspace `ws`. `ws.T` contains upper
triangular block reflectors which parameterize the elementary reflectors of
the factorization. The first dimension of `ws.T` sets the block size and it must
satisfy `1 <= size(ws.T, 1) <= min(size(A)...)`. The second dimension of `T` must equal the smallest
dimension of `A`, i.e. `size(ws.T, 2) == size(A, 2)`. If this is not the case and
`resize==true`, the workspace will automatically be resized to the appropriate dimensions.

`A` and `ws.T` are modified in-place.
"""
geqrt!(ws::QRWYWs, A::AbstractMatrix; kwargs...)

"""
    QRPivotedWs

Workspace to be used with the [`LinearAlgebra.QRPivoted`](https://docs.julialang.org/en/v1/stdlib/LinearAlgebra/#LinearAlgebra.QRPivoted)
representation of the QR factorization which uses the [`LAPACK.geqp3!`](@ref) function.

# Examples
```jldoctest
julia> A = [1.2 2.3
            6.2 3.3]
2×2 Matrix{Float64}:
 1.2  2.3
 6.2  3.3

julia> ws = QRPivotedWs(A)
QRPivotedWs{Float64, Float64}
  work: 100-element Vector{Float64}
  rwork: 0-element Vector{Float64}
  τ: 2-element Vector{Float64}
  jpvt: 2-element Vector{Int64}

julia> t = QRPivoted(LAPACK.geqp3!(ws, A)...)
QRPivoted{Float64, Matrix{Float64}, Vector{Float64}, Vector{Int64}}
Q factor: 2×2 LinearAlgebra.QRPackedQ{Float64, Matrix{Float64}, Vector{Float64}}
R factor:
2×2 Matrix{Float64}:
 -6.31506  -3.67692
  0.0      -1.63102
permutation:
2-element Vector{Int64}:
 1
 2

julia> Matrix(t)
2×2 Matrix{Float64}:
 1.2  2.3
 6.2  3.3
```
"""
struct QRPivotedWs{T <: Number, RT <: AbstractFloat} <: Workspace
    work::Vector{T}
    rwork::Vector{RT}
    τ::Vector{T}
    jpvt::Vector{BlasInt}
end

for (geqp3, elty, relty) in ((:dgeqp3_, :Float64, :Float64),
    (:sgeqp3_, :Float32, :Float32),
    (:zgeqp3_, :ComplexF64, :Float64),
    (:cgeqp3_, :ComplexF32, :Float32))
    @eval begin
        function Base.resize!(ws::QRPivotedWs, A::StridedMatrix{$elty}; work = true)
            require_one_based_indexing(A)
            chkstride1(A)
            m, n = size(A)
            minmn = min(m, n)
            RldA = max(1, stride(A, 2))
            resize!(ws.jpvt, n)
            resize!(ws.τ, min(m, n))
            if work && minmn > 0
                info = Ref{BlasInt}()
                if $elty <: Complex
                    resize!(ws.rwork, 2n)
                    ccall((@blasfunc($geqp3), liblapack), Cvoid,
                        (Ref{BlasInt}, Ref{BlasInt}, Ptr{$elty},
                            Ref{BlasInt}, Ptr{BlasInt},
                            Ptr{$elty}, Ptr{$elty}, Ref{BlasInt}, Ptr{$relty}, Ref{BlasInt}),
                        m, n, A, RldA, ws.jpvt, ws.τ, ws.work, -1, ws.rwork, info)
                else
                    ccall((@blasfunc($geqp3), liblapack), Cvoid,
                        (Ref{BlasInt}, Ref{BlasInt}, Ptr{$elty},
                            Ref{BlasInt}, Ptr{BlasInt},
                            Ptr{$elty}, Ptr{$elty}, Ref{BlasInt}, Ref{BlasInt}),
                        m, n, A, RldA, ws.jpvt, ws.τ, ws.work, -1, info)
                end
                chklapackerror(info[])
                resize!(ws.work, BlasInt(real(ws.work[1])))
            end
            return ws
        end
        QRPivotedWs(A::StridedMatrix{$elty}) = resize!(
            QRPivotedWs(Vector{$elty}(undef, 1), $relty[], $elty[], BlasInt[]), A)

        function geqp3!(ws::QRPivotedWs{$elty}, A::AbstractMatrix{$elty}; resize = true)
            m, n = size(A)
            nws = length(ws.jpvt)
            minmn = min(m, n)
            if nws != n || minmn != length(ws.τ)
                if resize
                    resize!(ws, A; work = n > nws)
                else
                    throw(WorkspaceSizeError(nws, minmn))
                end
            end
            lda = stride(A, 2)
            info = Ref{BlasInt}()
            if minmn > 0
                if $elty <: Complex
                    ccall((@blasfunc($geqp3), liblapack), Cvoid,
                        (Ref{BlasInt}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                            Ptr{BlasInt}, Ptr{$elty}, Ptr{$elty}, Ref{BlasInt}, Ptr{$relty},
                            Ptr{BlasInt}),
                        m, n, A, lda,
                        ws.jpvt, ws.τ, ws.work,
                        length(ws.work), ws.rwork, info)
                else
                    ccall((@blasfunc($geqp3), liblapack), Cvoid,
                        (Ref{BlasInt}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                            Ptr{BlasInt}, Ptr{$elty}, Ptr{$elty}, Ref{BlasInt},
                            Ptr{BlasInt}),
                        m, n, A, lda,
                        ws.jpvt, ws.τ, ws.work,
                        length(ws.work), info)
                end
                chklapackerror(info[])
            end
            return A, ws.τ, ws.jpvt
        end
    end
end

"""
    geqp3!(ws, A; resize=true) -> (A, ws.τ, ws.jpvt)

Compute the pivoted `QR` factorization of `A`, `AP = QR` using BLAS level 3,
using the preallocated [`QRPivotedWs`](@ref) workspace `ws`.
`P` is a pivoting matrix, represented by `ws.jpvt`. `ws.τ` stores the elementary
reflectors. `ws.jpvt` must have length greater
than or equal to `n` if `A` is an `(m x n)` matrix and `ws.τ` must have length
greater than or equal to the smallest dimension of `A`. If this is not the case
and `resize == true` the workspace will be appropriately resized.

`A`, `ws.jpvt`, and `ws.τ` are modified in-place.
"""
geqp3!(ws::QRPivotedWs, A::AbstractMatrix; kwargs...)

"""
    QROrmWs

Workspace to be used with the [`LinearAlgebra.LAPACK.ormqr!`](https://docs.julialang.org/en/v1/stdlib/LinearAlgebra/#LinearAlgebra.LAPACK.ormqr!)
function. It requires the workspace of a `QR` or a `QRPivoted` previous factorization

# Examples
```jldoctest
julia> A = [1.2 2.3
            6.2 3.3]
2×2 Matrix{Float64}:
 1.2  2.3
 6.2  3.3

julia> ws = QRPivotedWs(A)
QRPivotedWs{Float64, Float64}
  work: 100-element Vector{Float64}
  rwork: 0-element Vector{Float64}
  τ: 2-element Vector{Float64}
  jpvt: 2-element Vector{Int64}

julia> C=[1 0.5; 2 1]
2×2 Matrix{Float64}:
 1.0  0.5
 2.0  1.0

julia> ormws =  QROrmWs(ws, 'L', 'N', A, C)
QROrmWs{Float64}
  work: 4224-element Vector{Float64}
  τ: 2-element Vector{Float64}

"""
struct QROrmWs{T <: Number} <: Workspace
    work::Vector{T}
    τ::Vector{T}
end

"""
    QROrgWs

Workspace to be used with the [`LinearAlgebra.LAPACK.orgqr!`](https://docs.julialang.org/en/v1/stdlib/LinearAlgebra/#LinearAlgebra.LAPACK.orgqr!)
function. It requires the workspace of a `QR` or a `QRPivoted` previous factorization

# Examples
```jldoctest
julia> A = [1.2 2.3
            6.2 3.3]
2×2 Matrix{Float64}:
 1.2  2.3
 6.2  3.3

julia> ws = QRPivotedWs(A)
QRPivotedWs{Float64, Float64}
  work: 100-element Vector{Float64}
  rwork: 0-element Vector{Float64}
  τ: 2-element Vector{Float64}
  jpvt: 2-element Vector{Int64}

julia> C=[1 0.5; 2 1]
2×2 Matrix{Float64}:
 1.0  0.5
 2.0  1.0

julia> orgws =  QROrgWs(ws, 'L', 'N', A, C)
QROrgWs{Float64}
  work: 4224-element Vector{Float64}
  τ: 2-element Vector{Float64}

"""
struct QROrgWs{T <: Number} <: Workspace
    work::Vector{T}
    τ::Vector{T}
end

for (ormqr, orgqr, elty) in ((:dormqr_, :dorgqr_, :Float64),
    (:sormqr_, :sorgqr_, :Float32),
    (:zunmqr_, :zungqr_, :ComplexF64),
    (:cunmqr_, :cungqr_, :ComplexF32))
    @eval begin
        function Base.resize!(ormws::QROrmWs, side::AbstractChar, trans::AbstractChar,
                A::AbstractMatrix{$elty},
                C::AbstractVecOrMat{$elty};
                work = true)
            require_one_based_indexing(A, C)
            chktrans(trans)
            chkside(side)
            chkstride1(A, C)
            m, n = ndims(C) == 2 ? size(C) : (size(C, 1), 1)
            mA, nA = size(A)
            minmn = min(mA, nA)
            k = length(ormws.τ)
            if side == 'L' && m != mA
                throw(DimensionMismatch("for a left-sided multiplication, the first dimension of C, $m, must equal the first dimension of A, $mA"))
            end
            if side == 'R' && n != mA
                throw(DimensionMismatch("for a right-sided multiplication, the second dimension of C, $n, must equal the first dimension of A, $mA"))
            end
            if side == 'L' && k > m
                throw(DimensionMismatch("invalid number of reflectors: k = $k should be <= m = $m"))
            end
            if side == 'R' && k > n
                throw(DimensionMismatch("invalid number of reflectors: k = $k should be <= n = $n"))
            end
            if work && minmn > 0
                info = Ref{BlasInt}()
                ccall((@blasfunc($ormqr), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt},
                        Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                        Ref{BlasInt}, Clong, Clong),
                    side, trans, m, n,
                    k, A, max(1, stride(A, 2)), ormws.τ,
                    C, max(1, stride(C, 2)), ormws.work, -1,
                    info, 1, 1)
                chklapackerror(info[])
                resize!(ormws.work, BlasInt(real(ormws.work[1])))
            end
            return ormws
        end

        QROrmWs(ws::Union{QRWs, QRPivotedWs}, side::AbstractChar, trans::AbstractChar,
        A::AbstractMatrix{$elty},
        C::AbstractVecOrMat{$elty}) = resize!(
            QROrmWs(Vector{$elty}(undef, 1), ws.τ), side, trans,
            A, C)
        function Base.resize!(
                orgws::QROrgWs, A::AbstractMatrix{$elty}; k::Integer = size(A, 2))
            require_one_based_indexing(A, ws.τ)
            chkstride1(A, ws.τ)
            m, n = size(A)
            minmn = min(m, n)
            if minmn > 0
                if k > minmn
                    throw(DimensionMismatch("invalid number of reflectors: k = $k should be <= n = $minmn"))
                end
                info = Ref{BlasInt}()
                ccall((@blasfunc($orgqr), liblapack), Cvoid,
                    (Ref{BlasInt}, Ref{BlasInt}, Ref{BlasInt}, Ptr{$elty},
                        Ref{BlasInt}, Ptr{$elty}, Ptr{$elty}, Ref{BlasInt}, Ptr{BlasInt}),
                    m, n, k, A,
                    max(1, stride(A, 2)), ws.τ, ws.work, -1,
                    info)
                chklapackerror(info[])
                resize!(orgws.work, BlasInt(real(orgws.work[1])))
            end
            return orgws
        end

        QROrgWs(ws::Union{QRWs, QRPivotedWs}, A::AbstractMatrix{$elty}; k::Integer = size(A, 2)) = resize!(
            QROrgWs(Vector{$elty}(undef, 1), ws.τ), A, k)

        function ormqr!(ws::QROrmWs{$elty}, side::AbstractChar, trans::AbstractChar,
                A::AbstractMatrix{$elty},
                C::AbstractVecOrMat{$elty})
            require_one_based_indexing(A, C)
            chktrans(trans)
            chkside(side)
            chkstride1(A, C)
            m, n = ndims(C) == 2 ? size(C) : (size(C, 1), 1)
            mA, nA = size(A)
            minmn = min(mA, nA)
            k = length(ws.τ)
            if side == 'L' && m != mA
                throw(DimensionMismatch("for a left-sided multiplication, the first dimension of C, $m, must equal the first dimension of A, $mA"))
            end
            if side == 'R' && n != mA
                throw(DimensionMismatch("for a right-sided multiplication, the second dimension of C, $n, must equal the first dimension of A, $mA"))
            end
            if side == 'L' && k > m
                throw(DimensionMismatch("invalid number of reflectors: k = $k should be <= m = $m"))
            end
            if side == 'R' && k > n
                throw(DimensionMismatch("invalid number of reflectors: k = $k should be <= n = $n"))
            end
            info = Ref{BlasInt}()
            if minmn > 0
                ccall((@blasfunc($ormqr), liblapack), Cvoid,
                    (Ref{UInt8}, Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt},
                        Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                        Ref{BlasInt}, Clong, Clong),
                    side, trans, m, n,
                    k, A, max(1, stride(A, 2)), ws.τ,
                    C, max(1, stride(C, 2)), ws.work, length(ws.work),
                    info, 1, 1)
                chklapackerror(info[])
            end
            return C
        end
    end

    for elty2 in (eval(:(Transpose{$elty, <:StridedMatrix{$elty}})),
        eval(:(Adjoint{$elty, <:StridedMatrix{$elty}})))
        @eval function ormqr!(ws::QROrmWs, side::AbstractChar, trans::AbstractChar,
                A::$elty2,
                C::StridedMatrix{$elty})
            chktrans(trans)
            chkside(side)
            trans = trans == 'T' ? 'N' : 'T'
            return LAPACK.ormqr!(ws, side, trans, A.parent, C)
        end
    end

    @eval function orgqr!(ws::Union{QRWs{$elty}, QRPivotedWs{$elty}},
            A::AbstractMatrix{$elty}, k::Integer = size(A, 2))
        require_one_based_indexing(A, ws.τ)
        chkstride1(A, ws.τ)
        m, n = size(A)
        minmn = min(m, n)
        if minmn > 0
            if k > minmn
                throw(DimensionMismatch("invalid number of reflectors: k = $k should be <= n = $minmn"))
            end
            info = Ref{BlasInt}()
            ccall((@blasfunc($orgqr), liblapack), Cvoid,
                (Ref{BlasInt}, Ref{BlasInt}, Ref{BlasInt}, Ptr{$elty},
                    Ref{BlasInt}, Ptr{$elty}, Ptr{$elty}, Ref{BlasInt}, Ptr{BlasInt}),
                m, n, k, A,
                max(1, stride(A, 2)), ws.τ, ws.work, length(ws.work),
                info)
            chklapackerror(info[])
        end
        if minmn < size(A, 2)
            return A[:, 1:minmn]
        else
            return A
        end
    end
end

"""
    ormqr!(ws, side, trans, A, C) -> C

Computes `Q * C` (`trans = N`), `transpose(Q) * C` (`trans = T`), `adjoint(Q) * C`
(`trans = C`) for `side = L` or the equivalent right-sided multiplication
for `side = R` using `Q` from a `QR` factorization of `A`.
Uses preallocated workspace `ws::QROrmWs` and the factors are assumed to be stored in `ws.τ`.
`C` is overwritten.
"""
ormqr!(ws::QROrmWs, side::AbstractChar, trans::AbstractChar, A::AbstractMatrix,
    C::AbstractVecOrMat)

"""
    orgqr!(ws, A, k = length(tau))

Explicitly finds the matrix `Q` of a `QR` factorization using the
factors stored in `ws.τ`, that were generated from calling 
[`geqrf!`](@ref) if `ws` is a [`QRWs`](@ref) or [`geqp3!`](@ref) if `ws` is a [`QRPivotedWs`](@ref).
`A` is overwritten by `Q`.
"""
orgqr!(ws::Union{QRWs, QRPivotedWs}, A::AbstractMatrix, k::Integer = size(A, 2))

module BenchCholesky
using BenchmarkTools
using FastLapackInterface
using LinearAlgebra, LinearAlgebra.LAPACK

const sizes = (3, 4, 5, 10, 50, 100)
const vector_length = 100

const suite = BenchmarkGroup()

#### Cholesky

suite["Cholesky"] = BenchmarkGroup()
suite["Cholesky"]["creation"] = BenchmarkGroup()

for n in sizes
    A = rand(n, n)
    suite["Cholesky"]["creation"]["$n"] = @benchmarkable CholeskyPivotedWs($A)
end
suite["Cholesky"]["pstrf!"] = BenchmarkGroup()
suite["Cholesky"]["pstrf!"]["workspace"] = BenchmarkGroup()
suite["Cholesky"]["pstrf!"]["LAPACK"] = BenchmarkGroup()

function bench_pstrf!(As, ws)
    for A in As
        LAPACK.pstrf!(ws, 'U', A, 1e-6)
    end
end
function bench_pstrf!(As)
    for A in As
        LAPACK.pstrf!('U', A, 1e-6)
    end
end

for n in sizes
    As = [rand(n, n) for i in 1:vector_length]
    ws = CholeskyPivotedWs(As[1])
    suite["Cholesky"]["pstrf!"]["workspace"]["$n"] = @benchmarkable bench_pstrf!($As, $ws)
    suite["Cholesky"]["pstrf!"]["LAPACK"]["$n"] = @benchmarkable bench_pstrf!($As)
end

end
BenchCholesky.suite

# Based on documentation of DFControl and DFTK
using LibGit2: LibGit2
using Pkg: Pkg

# To manually generate the docs:
# Run "julia make.jl" to generate the docs

# Set to true to disable some checks and cleanup
DEBUG = false

# Where to get files from and where to build them
SRCPATH = joinpath(@__DIR__, "src")
BUILDPATH = joinpath(@__DIR__, "build")
ROOTPATH = joinpath(@__DIR__, "..")
CONTINUOUS_INTEGRATION = get(ENV, "CI", nothing) == "true"

JLDEPS = [Pkg.PackageSpec(;
    url = "https://github.com/DynareJulia/FastLapackInterface.jl.git",
    rev = LibGit2.head(ROOTPATH))]

# Setup julia dependencies for docs generation if not yet done
Pkg.activate(@__DIR__)
Pkg.develop(Pkg.PackageSpec(; path = ROOTPATH))
Pkg.instantiate()

# Import packages for docs generation
using FastLapackInterface
using LinearAlgebra
using LinearAlgebra: LAPACK
using Documenter

DocMeta.setdocmeta!(FastLapackInterface, :DocTestSetup,
    quote
        using FastLapackInterface, LinearAlgebra
    end)

# Generate the docs in BUILDPATH
makedocs(; modules = [FastLapackInterface],
    format = Documenter.HTML(;
        prettyurls = CONTINUOUS_INTEGRATION,
        canonical = "https://dynarejulia.github.io/FastLapackInterface.jl/stable/",
        assets = ["assets/favicon.ico"]),
    sitename = "FastLapackInterface.jl", authors = "Louis Ponet, Michel Juillard",
    linkcheck_ignore = [
    # Ignore links that point to GitHub's edit pages, as they redirect to the
    # login screen and cause a warning:
        r"https://github.com/([A-Za-z0-9_.-]+)/([A-Za-z0-9_.-]+)/edit(.*)"],
    pages = ["Home" => "index.md",
        "Work Spaces" => "workspaces.md",
        "LAPACK" => "LAPACK.md"])

# Deploy docs to gh-pages branch
deploydocs(; repo = "github.com/DynareJulia/FastLapackInterface.jl.git", devbranch = "main")

if !CONTINUOUS_INTEGRATION
    println("\nDocs generated, try $(joinpath(BUILDPATH, "index.html"))")
end

module BenchEigen
using BenchmarkTools
using FastLapackInterface
using LinearAlgebra, LinearAlgebra.LAPACK

const sizes = (3, 4, 5, 10, 50, 100)
const vector_length = 100

const suite = BenchmarkGroup()

suite["EigenWs"] = BenchmarkGroup()
suite["EigenWs"]["creation"] = BenchmarkGroup()
for n in sizes
    A = rand(n, n)
    suite["EigenWs"]["creation"]["$n"] = @benchmarkable EigenWs($A)
end

suite["EigenWs"]["geevx!"]              = BenchmarkGroup()
suite["EigenWs"]["geevx!"]["workspace"] = BenchmarkGroup()
suite["EigenWs"]["geevx!"]["LAPACK"]    = BenchmarkGroup()

function bench_geevx!(As, ws)
    for A in As
        LAPACK.geevx!(ws, 'N', 'V', 'V', 'V', A)
    end
end
function bench_geevx!(As)
    for A in As
        LAPACK.geevx!('N', 'V', 'V', 'V', A)
    end
end
for n in sizes
    As = [rand(n, n) for i in 1:vector_length]
    ws = EigenWs(As[1]; sense = true)
    suite["EigenWs"]["geevx!"]["workspace"]["$n"] = @benchmarkable bench_geevx!($As, $ws)
    suite["EigenWs"]["geevx!"]["LAPACK"]["$n"] = @benchmarkable bench_geevx!($As)
end

suite["HermitianEigenWs"] = BenchmarkGroup()
suite["HermitianEigenWs"]["creation"] = BenchmarkGroup()
for n in sizes
    A = rand(n, n)
    suite["HermitianEigenWs"]["creation"]["$n"] = @benchmarkable HermitianEigenWs($A)
end

suite["HermitianEigenWs"]["syevr!"]              = BenchmarkGroup()
suite["HermitianEigenWs"]["syevr!"]["workspace"] = BenchmarkGroup()
suite["HermitianEigenWs"]["syevr!"]["LAPACK"]    = BenchmarkGroup()

function bench_syevr!(As, ws)
    for A in As
        LAPACK.syevr!(ws, 'V', 'A', 'U', A, 0.0, 0.0, 0, 0, 1e-6)
    end
end
function bench_syevr!(As)
    for A in As
        LAPACK.syevr!('V', 'A', 'U', A, 0.0, 0.0, 0, 0, 1e-6)
    end
end
for n in sizes
    As = [rand(ComplexF64, n, n) for i in 1:vector_length]
    As .= (As .+ adjoint.(As)) ./ 2

    ws = HermitianEigenWs(As[1]; vecs = true)
    suite["HermitianEigenWs"]["syevr!"]["workspace"]["$n"] = @benchmarkable bench_syevr!($As,
                                                                                         $ws)
    suite["HermitianEigenWs"]["syevr!"]["LAPACK"]["$n"] = @benchmarkable bench_syevr!($As)
end

end
BenchEigen.suite

import LinearAlgebra.LAPACK: getrf!, getrs!, chktrans
"""
    LUWs

Workspace to be used with the [`LinearAlgebra.LU`](https://docs.julialang.org/en/v1/stdlib/LinearAlgebra/#LinearAlgebra.LU)
representation of the LU factorization which uses the [`LAPACK.getrf!`](@ref) function.

# Examples
```jldoctest
julia> A = [1.2 2.3
            6.2 3.3]
2×2 Matrix{Float64}:
 1.2  2.3
 6.2  3.3

julia> ws = LUWs(A)
LUWs
  ipiv: 2-element Vector{Int64}

julia> t = LU(LAPACK.getrf!(ws, A)...)
LU{Float64, Matrix{Float64}, Vector{Int64}}
L factor:
2×2 Matrix{Float64}:
 1.0       0.0
 0.193548  1.0
U factor:
2×2 Matrix{Float64}:
 6.2  3.3
 0.0  1.66129
```
"""
struct LUWs <: Workspace
    ipiv::Vector{BlasInt}
end
LUWs(n::Int) = LUWs(zeros(BlasInt, n))
LUWs(a::AbstractMatrix) = LUWs(min(size(a)...))
function Base.resize!(ws::LUWs, A::AbstractMatrix)
    resize!(ws.ipiv, min(size(A)...))
    return ws
end

for (getrf, getrs, elty) in ((:dgetrf_, :dgetrs_, :Float64),
    (:sgetrf_, :sgetrs_, :Float32),
    (:zgetrf_, :zgetrs_, :ComplexF64),
    (:cgetrf_, :cgetrs_, :ComplexF32))
    @eval begin
        function getrf!(ws::LUWs, A::AbstractMatrix{$elty}; resize = true)
            nws = length(ws.ipiv)
            n = min(size(A)...)
            if n != nws
                if resize
                    resize!(ws, A)
                else
                    throw(WorkspaceSizeError(nws, n))
                end
            end
            require_one_based_indexing(A)
            chkstride1(A)
            m, n = size(A)
            lda = max(1, stride(A, 2))
            info = Ref{BlasInt}()
            ccall((@blasfunc($getrf), liblapack), Cvoid,
                (Ref{BlasInt}, Ref{BlasInt}, Ptr{$elty},
                    Ref{BlasInt}, Ptr{BlasInt}, Ptr{BlasInt}),
                m, n, A, lda, ws.ipiv, info)
            chkargsok(info[])
            return A, ws.ipiv, info[] #Error code is stored in LU factorization type
        end

        function getrs!(ws::LUWs, trans::AbstractChar,
                A::AbstractMatrix{$elty}, B::AbstractVecOrMat{$elty})
            require_one_based_indexing(A, B)
            chktrans(trans)
            chkstride1(A, B)
            n = checksquare(A)
            @assert n==length(ws.ipiv) WorkspaceSizeError(length(ws.ipiv), n)
            if n != size(B, 1)
                throw(DimensionMismatch("B has leading dimension $(size(B,1)), but needs $n"))
            end
            nrhs = size(B, 2)
            info = Ref{BlasInt}()
            ccall((@blasfunc($getrs), liblapack), Cvoid,
                (Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                    Ptr{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{BlasInt}, Clong),
                trans, n, size(B, 2), A, max(1, stride(A, 2)),
                ws.ipiv, B, max(1, stride(B, 2)), info, 1)
            chklapackerror(info[])
            B
        end
    end
end

"""
    getrf!(ws, A; resize=true) -> (A, ws.ipiv, info)

Compute the pivoted `LU` factorization of `A`, `A = LU`, using the preallocated [`LUWs`](@ref) workspace `ws`. If the workspace is too small and `resize==true` it will be resized
appropriately for `A`.

Returns `A`, modified in-place, `ws.ipiv`, the pivoting information, and the `ws.info`
code which indicates success (`info = 0`), a singular value in `U`
(`info = i`, in which case `U[i,i]` is singular), or an error code (`info < 0`).
"""
getrf!(ws::LUWs, A::AbstractMatrix; kwargs...)

"""
    getrs!(ws, trans, A, B)

Solves the linear equation `A * X = B`, `transpose(A) * X = B`, or `adjoint(A) * X = B` for
square `A`. Modifies the matrix/vector `B` in place with the solution. `A`
is the `LU` factorization from `getrf!` with the pivoting
information stored in ws.ipiv. `trans` may be one of `N` (no modification), `T` (transpose),
or `C` (conjugate transpose).
"""
getrs!(ws::LUWs, trans::AbstractChar, A::AbstractMatrix, B::AbstractVecOrMat)

using FastLapackInterface
using LinearAlgebra
using Test

function test_FastLapackInterface()
    include("lse_test.jl")
    include("lu_test.jl")
    include("schur_test.jl")
    include("qr_test.jl")
    include("eigen_test.jl")
    include("bunch_kaufman_test.jl")
    include("cholesky_test.jl")
    include("svd_test.jl")
end

test_FastLapackInterface()
if Sys.islinux() || Sys.iswindows()
    using MKL
    test_FastLapackInterface()
elseif Sys.isapple()
    using AppleAccelerate
    test_FastLapackInterface()
end

using Test
using FastLapackInterface
using LinearAlgebra.LAPACK

function test_sdd(m, n, numbertype)
    A1 = randn(numbertype, m, n)
    A2 = copy(A1)

    # default: job = 'A'
    ws = SVDsddWs(A2)

    U1, S1, VT1 = LAPACK.gesdd!('A', A1)
    U2, S2, VT2 = LAPACK.gesdd!(ws, 'A', A2)

    @test isapprox(U1, U2)
    @test isapprox(S1, S2)
    @test isapprox(VT1, VT2)

    # all possible jobs
    for j in ('A', 'S', 'O', 'N')
        A1 = randn(numbertype, m, n)
        A2 = copy(A1)

        ws = SVDsddWs(A2, job = j)

        U1, S1, VT1 = LAPACK.gesdd!(j, A1)
        U2, S2, VT2 = LAPACK.gesdd!(ws, j, A2)

        @test isapprox(U1, U2)
        @test isapprox(S1, S2)
        @test isapprox(VT1, VT2)
        if j == 'O'
            # A is overwritten with U
            @test isapprox(A1, A2)
            if m >= n
                @test isapprox(U2, A2)
            else
                @test isapprox(VT2, A2)
            end
        end
    end
end

function test_svd(m, n, numbertype)
    A1 = randn(numbertype, m, n)
    A2 = copy(A1)

    # default: jobu = jobvt = 'A'
    ws = SVDsvdWs(A2)

    U1, S1, VT1 = LAPACK.gesvd!('A', 'A', A1)
    U2, S2, VT2 = LAPACK.gesvd!(ws, 'A', 'A', A2)

    @test isapprox(U1, U2)
    @test isapprox(S1, S2)
    @test isapprox(VT1, VT2)

    # all possible jobs
    for j1 in ('A', 'S', 'O', 'N'), j2 in ('A', 'S', 'O', 'N')
        # j1 = j2 = 'O' can not happen
        j1 == 'O' && j2 == 'O' && continue
        A1 = randn(numbertype, m, n)
        A2 = copy(A1)

        ws = SVDsvdWs(A2, jobu = j1, jobvt = j2)

        U1, S1, VT1 = LAPACK.gesvd!(j1, j2, A1)
        U2, S2, VT2 = LAPACK.gesvd!(ws, j1, j2, A2)

        @test isapprox(U1, U2)
        @test isapprox(S1, S2)
        @test isapprox(VT1, VT2)
        if j1 == 'O'
            # A is overwritten with U
            @test isapprox(A1, A2)
            @test isapprox(U2, A2)
        elseif j2 == 'O'
            @test isapprox(A1, A2)
            @test isapprox(VT2, A2)
        end
    end
end

function test_generalizedsvd(m, n, numbertype)
    A1 = randn(numbertype, m, n)
    B1 = randn(numbertype, m, n)
    A2 = copy(A1)
    B2 = copy(B1)

    # default: jobu = 'U', jobv = 'V', jobq = 'Q'
    ws = GeneralizedSVDWs(A2, B2)

    U1, V1, Q1, alpha1, beta1, k1, l1, R1 = LAPACK.ggsvd3!('U', 'V', 'Q', A1, B1)
    U2, V2, Q2, alpha2, beta2, k2, l2, R2 = LAPACK.ggsvd3!(ws, 'U', 'V', 'Q', A2, B2)

    @test isapprox(U1, U2)
    @test isapprox(V1, V2)
    @test isapprox(Q1, Q2)
    @test isapprox(alpha1, alpha2)
    @test isapprox(beta1, beta2)
    @test k1 == k2
    @test l1 == l2
    @test isapprox(R1, R2)

    # all possible jobs
    for j1 in ('U', 'N'), j2 in ('V', 'N'), j3 in ('Q', 'N')
        A1 = randn(numbertype, m, n)
        A2 = copy(A1)
        B1 = randn(numbertype, m, n)
        B2 = copy(B1)

        ws = GeneralizedSVDWs(A2, B2, jobu = j1, jobv = j2, jobq = j3)

        U1, V1, Q1, alpha1, beta1, k1, l1, R1 = LAPACK.ggsvd3!(j1, j2, j3, A1, B1)
        U2, V2, Q2, alpha2, beta2, k2, l2, R2 = LAPACK.ggsvd3!(ws, j1, j2, j3, A2, B2)

        j1 == 'U' && (@test isapprox(U1, U2))
        j2 == 'V' && (@test isapprox(V1, V2))
        j3 == 'Q' && (@test isapprox(Q1, Q2))
        @test isapprox(alpha1, alpha2)
        @test isapprox(beta1, beta2)
        @test k1 == k2
        @test l1 == l2
        @test isapprox(R1, R2)
    end
end

@testset "SVDsddWs" begin
    @testset "Real, square" test_sdd(10, 10, Float64)
    @testset "Real, nrows < ncols" test_sdd(5, 10, Float64)
    @testset "Real, nrows > ncols" test_sdd(10, 5, Float64)
    @testset "Complex, square" test_sdd(10, 10, ComplexF64)
    @testset "Complex, nrows < ncols" test_sdd(5, 10, ComplexF64)
    @testset "Complex, nrows > ncols" test_sdd(10, 5, ComplexF64)
end
@testset "SVDsvdWs" begin
    @testset "Real, square" test_svd(10, 10, Float64)
    @testset "Real, nrows < ncols" test_svd(5, 10, Float64)
    @testset "Real, nrows > ncols" test_svd(10, 5, Float64)
    @testset "Complex, square" test_svd(10, 10, ComplexF64)
    @testset "Complex, nrows < ncols" test_svd(5, 10, ComplexF64)
    @testset "Complex, nrows > ncols" test_svd(10, 5, ComplexF64)
end
@testset "GeneralizedSVDWs" begin
    @testset "Real, square" test_generalizedsvd(10, 10, Float64)
    @testset "Real, nrows < ncols" test_generalizedsvd(5, 10, Float64)
    @testset "Real, nrows > ncols" test_generalizedsvd(10, 5, Float64)
    @testset "Complex, square" test_generalizedsvd(10, 10, ComplexF64)
    @testset "Complex, nrows < ncols" test_generalizedsvd(5, 10, ComplexF64)
    @testset "Complex, nrows > ncols" test_generalizedsvd(10, 5, ComplexF64)
end

using Test
using FastLapackInterface
using LinearAlgebra.LAPACK

@testset "QRWs" begin
    n = 6
    m = 12
    for T in (Float32, Float64, ComplexF32, ComplexF64)
        @testset "$T" begin
            A0 = randn(T, n, n)
            ws = QRWs(A0)
            @testset "geqrf!" begin
                A = copy(A0)
                qr1 = QR(LAPACK.geqrf!(ws, A)...)

                qr2 = QR(LAPACK.geqrf!(copy(A0), randn(T, n))...)
                @test isapprox(Matrix(qr1), Matrix(qr2))
                # using Workspace, factorize!
                ws = Workspace(LAPACK.geqrf!, copy(A0))
                qr2 = QR(factorize!(ws, copy(A0))...)

                @test isapprox(Matrix(qr1), Matrix(qr2))
                for div in (-1, 1)
                    @test_throws FastLapackInterface.WorkspaceSizeError factorize!(
                        ws, rand(T, n + div, n + div); resize = false)
                    factorize!(ws, rand(T, n + div, n + div))
                    @test size(ws.τ, 1) == n + div
                end
            end

            @testset "ormqr!" begin
                AA = copy(A0)
                ws = Workspace(LAPACK.geqrf!, AA)
                C = randn(T, n, m)
                tau = randn(T, n)
                ws.τ .= tau
                ormws = QROrmWs(ws, 'L', 'N', AA, copy(C))
                Cout = LAPACK.ormqr!('L', 'N', AA, tau, copy(C))
                Cout2 = LAPACK.ormqr!(ormws, 'L', 'N', AA, copy(C))
                @test isapprox(Cout, Cout2)

                trans = T <: Complex ? 'C' : 'T'
                ormws = QROrmWs(ws, 'L', trans, AA, copy(C))
                Cout = LAPACK.ormqr!('L', trans, AA, tau, copy(C))
                Cout2 = LAPACK.ormqr!(ormws, 'L', trans, AA, copy(C))
                @test isapprox(Cout, Cout2)

                C = randn(T, m, n)
                ormws = QROrmWs(ws, 'R', 'N', AA, copy(C))
                Cout = LAPACK.ormqr!('R', 'N', AA, tau, copy(C))
                Cout2 = LAPACK.ormqr!(ormws, 'R', 'N', AA, copy(C))
                @test isapprox(Cout, Cout2)

                trans = T <: Complex ? 'C' : 'T'
                ormws = QROrmWs(ws, 'R', trans, AA, copy(C))
                Cout = LAPACK.ormqr!('R', trans, AA, tau, copy(C))
                Cout2 = LAPACK.ormqr!(ormws, 'R', trans, AA, copy(C))
                @test isapprox(Cout, Cout2)
            end
            @testset "orgqr!" begin
                ws = Workspace(LAPACK.geqrf!, copy(A0))
                C = randn(T, n, n)
                tau = randn(T, n)
                ws.τ .= tau
                Cout = LAPACK.orgqr!(copy(A0), tau)
                Cout2 = LAPACK.orgqr!(ws, copy(A0))
                @test isapprox(Cout, Cout2)
            end
            @testset "zero matrix" begin
                for d in [(4, 0), (0, 4), (0, 0)]
                    A0 = randn(T, d)
                    ws = QRWs(copy(A0))
                    @test size(ws.work) == (1,)
                    @test length(ws.τ) == 0

                    F = LAPACK.geqrf!(ws, copy(A0))
                    @test size(ws.work) == (1,)
                    @test length(ws.τ) == 0

                    C0 = rand(T, d[1], d[1])
                    ormws = QROrmWs(ws, 'L', 'N', copy(A0), copy(C0))
                    @test size(ormws.work) == (1,)
                    @test length(ormws.τ) == 0

                    LAPACK.ormqr!(ormws, 'L', 'N', copy(A0), copy(C0))
                    @test size(ormws.work) == (1,)
                    @test length(ormws.τ) == 0

                    LAPACK.orgqr!(ws, copy(A0))
                    @test size(ws.work) == (1,)
                    @test length(ws.τ) == 0
                end
            end
            show(devnull, "text/plain", ws)
        end
    end
end

@testset "QRWYWs" begin
    n = 3
    for T in (Float32, Float64, ComplexF32, ComplexF64)
        @testset "$T" begin
            A0 = randn(T, n, n)

            @testset "geqrt!" begin
                A = copy(A0)
                ws = QRWYWs(A)

                qr1 = LinearAlgebra.QRCompactWY(LAPACK.geqrt!(ws, copy(A))...)
                qr2 = LinearAlgebra.QRCompactWY(LAPACK.geqrt!(
                    copy(A0), zeros(T, size(ws.T)))...)
                @test isapprox(Matrix(qr1), Matrix(qr2))
                # using Workspace, factorize!
                ws = Workspace(LAPACK.geqrt!, copy(A))
                qr1 = LinearAlgebra.QRCompactWY(factorize!(ws, A)...)
                @test isapprox(Matrix(qr1), Matrix(qr2))
                show(devnull, "text/plain", ws)
                for div in (-1, 1)
                    @test_throws FastLapackInterface.WorkspaceSizeError factorize!(
                        ws, rand(T, n + div, n + div); resize = false)
                    factorize!(ws, rand(T, n + div, n + div))
                    @test size(ws.T, 1) == n + div
                end
            end

            @testset "zero matrix" begin
                for d in [(4, 0), (0, 4), (0, 0)]
                    A0 = randn(T, d)
                    ws = QRWYWs(copy(A0))
                    @test size(ws.work) == (0,)

                    LAPACK.geqrt!(ws, copy(A0))
                    @test size(ws.work) == (0,)
                end
            end
        end
    end
end

@testset "QRPivotedWs" begin
    n = 10
    for T in (Float32, Float64, ComplexF32, ComplexF64)
        @testset "$T" begin
            A0 = randn(T, n, n)

            @testset "geqp3!" begin
                A = copy(A0)
                ws = QRPivotedWs(A)
                q1 = QRPivoted(LAPACK.geqp3!(ws, copy(A))...)

                q2 = QRPivoted(LAPACK.geqp3!(copy(A0), zeros(Int, length(ws.jpvt)),
                    zeros(T, size(ws.τ)))...)
                @test isapprox(Matrix(q1), Matrix(q2))

                # using Workspace, factorize!
                ws = Workspace(LAPACK.geqp3!, copy(A))
                q1 = QRPivoted(factorize!(ws, copy(A))...)
                @test isapprox(Matrix(q1), Matrix(q2))

                for div in (-1, 1)
                    @test_throws FastLapackInterface.WorkspaceSizeError factorize!(
                        ws, rand(T, n + div, n + div); resize = false)
                    factorize!(ws, rand(T, n + div, n + div))
                    @test size(ws.τ, 1) == n + div
                end
                show(devnull, "text/plain", ws)
            end
            @testset "orgqr!" begin
                ws = Workspace(LAPACK.geqrf!, copy(A0))
                C = randn(T, n, n)
                tau = randn(T, n)
                ws.τ .= tau
                Cout = LAPACK.orgqr!(copy(A0), tau)
                Cout2 = LAPACK.orgqr!(ws, copy(A0))
                @test isapprox(Cout, Cout2)
            end
            @testset "zero matrix" begin
                for d in [(4, 0), (0, 4), (0, 0)]
                    A0 = randn(T, d)
                    ws = QRPivotedWs(copy(A0))
                    @test size(ws.work) == (1,)
                    @test length(ws.τ) == 0

                    LAPACK.geqp3!(ws, copy(A0))
                    @test size(ws.work) == (1,)
                    @test length(ws.τ) == 0

                    LAPACK.orgqr!(ws, copy(A0))
                    @test size(ws.work) == (1,)
                    @test length(ws.τ) == 0
                end
            end
        end
    end
end

module BenchLU
using BenchmarkTools
using FastLapackInterface
using LinearAlgebra, LinearAlgebra.LAPACK

const sizes = (3, 4, 5, 10, 50, 100)
const vector_length = 100

const suite = BenchmarkGroup()

#### LUWs

suite["LUWs"] = BenchmarkGroup()
suite["LUWs"]["creation"] = BenchmarkGroup()

for n in sizes
    A = rand(n, n)
    suite["LUWs"]["creation"]["$n"] = @benchmarkable LUWs($A)
end
suite["LUWs"]["getrf!"] = BenchmarkGroup()
suite["LUWs"]["getrf!"]["workspace"] = BenchmarkGroup()
suite["LUWs"]["getrf!"]["LAPACK"] = BenchmarkGroup()

function bench_getrf!(As, ws)
    for A in As
        LAPACK.getrf!(ws, A)
    end
end
function bench_getrf!(As)
    for A in As
        LAPACK.getrf!(A)
    end
end

for n in sizes
    As = [rand(n, n) for i in 1:vector_length]
    ws = LUWs(As[1])
    suite["LUWs"]["getrf!"]["workspace"]["$n"] = @benchmarkable bench_getrf!($As, $ws)
    suite["LUWs"]["getrf!"]["LAPACK"]["$n"] = @benchmarkable bench_getrf!($As)
end

end
BenchLU.suite

using BenchmarkTools

using LinearAlgebra
LinearAlgebra.BLAS.set_num_threads(1)

const SUITE = BenchmarkGroup()
for file in sort(readdir(@__DIR__))
    if startswith(file, "bench_cholesky") && endswith(file, ".jl")
        SUITE[chop(file; head = length("bench_"), tail = length(".jl"))] = include(file)
    end
end

import LinearAlgebra.LAPACK: pstrf!
"""
    CholeskyPivotedWs

Workspace for [`LinearAlgebra.CholeskyPivoted`](https://docs.julialang.org/en/v1/stdlib/LinearAlgebra/#LinearAlgebra.CholeskyPivoted) factorization using the [`LAPACK.pstrf!`](@ref) function.
The standard [`LinearAlgebra.Cholesky`](https://docs.julialang.org/en/v1/stdlib/LinearAlgebra/#LinearAlgebra.Cholesky) uses [`LAPACK.potrf!`](https://docs.julialang.org/en/v1/stdlib/LinearAlgebra/#LinearAlgebra.LAPACK.potrf!) which is non-allocating and does not require a separate [`Workspace`](@ref).

# Examples
```jldoctest
julia> A = [1.2 7.8
            7.8 3.3]
2×2 Matrix{Float64}:
 1.2  7.8
 7.8  3.3

julia> ws = CholeskyPivotedWs(A)
CholeskyPivotedWs{Float64}
  work: 4-element Vector{Float64}
  piv: 2-element Vector{Int64}


julia> AA, piv, rank, info = LAPACK.pstrf!(ws, 'U', A, 1e-6)
([1.816590212458495 4.293758683992806; 7.8 -17.236363636363635], [2, 1], 1, 1)

julia> CholeskyPivoted(AA, 'U', piv, rank, 1e-6, info)
CholeskyPivoted{Float64, Matrix{Float64}, Vector{Int64}}
U factor with rank 1:
2×2 UpperTriangular{Float64, Matrix{Float64}}:
 1.81659    4.29376
  ⋅       -17.2364
permutation:
2-element Vector{Int64}:
 2
 1
``` 
"""
struct CholeskyPivotedWs{T} <: Workspace
    work::Vector{T}
    piv::Vector{BlasInt}
end

for (pstrf, elty, rtyp) in ((:dpstrf_, :Float64, :Float64),
    (:spstrf_, :Float32, :Float32),
    (:zpstrf_, :ComplexF64, :Float64),
    (:cpstrf_, :ComplexF32, :Float32))
    @eval begin
        function Base.resize!(ws::CholeskyPivotedWs, A::AbstractMatrix{$elty}; work = true)
            n = checksquare(A)
            resize!(ws.piv, n)
            if work
                resize!(ws.work, 2n)
            end
            return ws
        end
        function CholeskyPivotedWs(A::AbstractMatrix{$elty})
            return resize!(CholeskyPivotedWs($rtyp[], BlasInt[]), A)
        end

        function pstrf!(ws::CholeskyPivotedWs, uplo::AbstractChar,
                A::AbstractMatrix{$elty}, tol::Real; resize = true)
            chkstride1(A)
            n = checksquare(A)
            chkuplo(uplo)
            rank = Ref{BlasInt}()
            info = Ref{BlasInt}()
            nws = length(ws.piv)
            if nws != n
                if resize
                    resize!(ws, A; work = nws < n)
                else
                    throw(WorkspaceSizeError(nws, n))
                end
            end

            ccall((@blasfunc($pstrf), liblapack), Cvoid,
                (Ref{UInt8}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{BlasInt},
                    Ptr{BlasInt}, Ref{$rtyp}, Ptr{$rtyp}, Ptr{BlasInt}, Clong),
                uplo, n, A, max(1, stride(A, 2)), ws.piv, rank, tol, ws.work, info, 1)
            chkargsok(info[])
            A, ws.piv, rank[], info[]
        end
    end
end

"""
    pstrf!(ws, uplo, A, tol; resize=true) -> (A, ws.piv, rank, info)

Computes the (upper if `uplo = U`, lower if `uplo = L`) pivoted Cholesky
decomposition of positive-definite matrix `A` with a user-set tolerance
`tol`, using a preallocated [`CholeskyPivotedWs`](@ref).
If the workspace was too small and `resize==true` it will be automatically resized.
`A` is overwritten by its Cholesky decomposition.

Returns `A`, the pivots `piv`, the rank of `A`, and an `info` code. If `info = 0`,
the factorization succeeded. If `info = i > 0 `, then `A` is indefinite or
rank-deficient.
"""
pstrf!(ws::CholeskyPivotedWs, uplo::AbstractChar, A::AbstractMatrix, tol::Real; kwargs...)

function Base.show(io::IO, mime::MIME{Symbol("text/plain")}, ws::T) where {T <: Workspace}
    summary(io, ws)
    println(io)
    for f in fieldnames(T)
        print(io, "  $f: ")
        summary(io, getfield(ws, f))
        println(io)
    end
end

"""
    Workspace(lapack_function, A)

Will create the correct [`Workspace`](@ref WorkSpaces) for the target `lapack_function` and matrix `A`.

# Examples
```jldoctest
julia> A = [1.2 2.3
            6.2 3.3]
2×2 Matrix{Float64}:
 1.2  2.3
 6.2  3.3

julia> ws = Workspace(LAPACK.geqrt!, A)
QRWYWs{Float64, Matrix{Float64}}
  work: 4-element Vector{Float64}
  T: 2×2 Matrix{Float64}


julia> LinearAlgebra.QRCompactWY(factorize!(ws, A)...)
LinearAlgebra.QRCompactWY{Float64, Matrix{Float64}, Matrix{Float64}}
Q factor: 2×2 LinearAlgebra.QRCompactWYQ{Float64, Matrix{Float64}, Matrix{Float64}}
R factor:
2×2 Matrix{Float64}:
 -6.31506  -3.67692
  0.0      -1.63102
```
"""
Workspace(::typeof(LAPACK.getrf!), A::AbstractMatrix) = LUWs(A)

Workspace(::typeof(LAPACK.geqrf!), A::AbstractMatrix) = QRWs(A)
Workspace(::typeof(LAPACK.geqrt!), A::AbstractMatrix) = QRWYWs(A)
Workspace(::typeof(LAPACK.geqp3!), A::AbstractMatrix) = QRPivotedWs(A)
function Workspace(::typeof(LAPACK.ormqr!), ws::Union{QRWs, QRPivotedWs},
        side::AbstractChar, trans::AbstractChar,
        A::AbstractMatrix, C::AbstractVecOrMat)
    QROrmWs(ws, side, trans, A, C)
end
function Workspace(::typeof(LAPACK.orgqr!), ws::Union{QRWs, QRPivotedWs},
        A::AbstractMatrix; k::Integer = size(A, 2))
    QROrgWs(ws, A, k)
end

Workspace(::typeof(LAPACK.gees!), A::AbstractMatrix) = SchurWs(A)
Workspace(::typeof(LAPACK.gges!), A::AbstractMatrix) = GeneralizedSchurWs(A)

Workspace(::typeof(LAPACK.geevx!), A::AbstractMatrix; kwargs...) = EigenWs(A; kwargs...)
function Workspace(::typeof(LAPACK.syevr!), A::AbstractMatrix; kwargs...)
    HermitianEigenWs(A; kwargs...)
end
function Workspace(::typeof(LAPACK.ggev!), A::AbstractMatrix; kwargs...)
    GeneralizedEigenWs(A; kwargs...)
end

Workspace(::typeof(LAPACK.sytrf!), A::AbstractMatrix) = BunchKaufmanWs(A)
Workspace(::typeof(LAPACK.sytrf_rook!), A::AbstractMatrix) = BunchKaufmanWs(A)
Workspace(::typeof(LAPACK.hetrf!), A::AbstractMatrix) = BunchKaufmanWs(A)
Workspace(::typeof(LAPACK.hetrf_rook!), A::AbstractMatrix) = BunchKaufmanWs(A)

Workspace(::typeof(LAPACK.pstrf!), A::AbstractMatrix) = CholeskyPivotedWs(A)

Workspace(::typeof(LAPACK.gglse!), A::AbstractMatrix) = LSEWs(A)

Workspace(::typeof(LAPACK.gesdd!), A::AbstractMatrix; kwargs...) = SVDsddWs(A; kwargs...)
Workspace(::typeof(LAPACK.gesvd!), A::AbstractMatrix; kwargs...) = SVDsvdWs(A; kwargs...)
function Workspace(
        ::typeof(LAPACK.ggsvd3!), A::AbstractMatrix, B::AbstractMatrix; kwargs...)
    GeneralizedSVDWs(A, B; kwargs...)
end

"""
    decompose!(ws, args...)

Will use the previously created [`Workspace`](@ref WorkSpaces) `ws` to dispatch to the correct LAPACK call.  
"""
decompose!(ws::LUWs, args...; kwargs...) = LAPACK.getrf!(ws, args...; kwargs...)

decompose!(ws::QRWs, args...; kwargs...) = LAPACK.geqrf!(ws, args...; kwargs...)
decompose!(ws::QRWYWs, args...; kwargs...) = LAPACK.geqrt!(ws, args...; kwargs...)
decompose!(ws::QRPivotedWs, args...; kwargs...) = LAPACK.geqp3!(ws, args...; kwargs...)
decompose!(ws::QROrmWs, args...; kwargs...) = LAPACK.ormqr!(ws, args...; kwargs...)

decompose!(ws::SchurWs, args...; kwargs...) = LAPACK.gees!(ws, args...; kwargs...)
function decompose!(ws::GeneralizedSchurWs, args...; kwargs...)
    LAPACK.gges!(ws, args...; kwargs...)
end

decompose!(ws::EigenWs, args...; kwargs...) = LAPACK.geevx!(ws, args...; kwargs...)
decompose!(ws::HermitianEigenWs, args...; kwargs...) = LAPACK.syevr!(ws, args...; kwargs...)
function decompose!(ws::GeneralizedEigenWs, args...; kwargs...)
    LAPACK.ggev!(ws, args...; kwargs...)
end

function decompose!(
        ws::BunchKaufmanWs, uplo::AbstractChar, A::AbstractMatrix; rook = false, kwargs...)
    if issymmetric(A)
        return rook ? LAPACK.sytrf_rook!(ws, uplo, A; kwargs...) :
               LAPACK.sytrf!(ws, uplo, A; kwargs...)
    else
        return rook ? LAPACK.hetrf_rook!(ws, uplo, A; kwargs...) :
               LAPACK.hetrf!(ws, uplo, A; kwargs...)
    end
end

function decompose!(ws::BunchKaufmanWs, A::Hermitian; rook = false, kwargs...)
    return rook ? LAPACK.hetrf_rook!(ws, A.uplo, A.data; kwargs...) :
           LAPACK.hetrf!(ws, A.uplo, A.data; kwargs...)
end
function decompose!(ws::BunchKaufmanWs, A::Symmetric; rook = false, kwargs...)
    return rook ? LAPACK.sytrf_rook!(ws, A.uplo, A.data; kwargs...) :
           LAPACK.sytrf!(ws, A.uplo, A.data; kwargs...)
end

function decompose!(ws::CholeskyPivotedWs, uplo::AbstractChar,
        A::AbstractMatrix, tol = 1e-16; kwargs...)
    return LAPACK.pstrf!(ws, uplo, A, tol; kwargs...)
end

function decompose!(
        ws::CholeskyPivotedWs, A::Union{Hermitian, Symmetric}, tol = 1e-16; kwargs...)
    return LAPACK.pstrf!(ws, A.uplo, A.data, tol; kwargs...)
end

decompose!(ws::LSEWs, args...; kwargs...) = LAPACK.gglse!(ws, args...; kwargs...)

decompose!(ws::SVDsddWs, A::AbstractMatrix; job = 'A') = LAPACK.gesdd!(ws, job, A)
function decompose!(ws::SVDsvdWs, A::AbstractMatrix; jobu = 'A', jobvt = 'A')
    LAPACK.gesdd!(ws, jobu, jobvt, A)
end
function decompose!(ws::GeneralizedSVDWs, A::AbstractMatrix,
        B::AbstractMatrix; jobu = 'U', jobv = 'V', jobq = 'Q')
    LAPACK.ggsvd3!(ws, jobu, jobv, jobq, A, B)
end

"""
    factorize!(ws, args...)

Alias for [`decompose!`](@ref).
"""
const factorize! = decompose!

"""
    resize!(ws, A; kwargs...)

Resizes the `ws` to be appropriate for use with matrix `A`. The `kwargs` can be used to
communicate which features should be supported by the [`Workspace`](@ref), such as
left and right eigenvectors while using [`EigenWs`](@ref).
This function is mainly used for automatic resizing inside [`LAPACK functions`](@ref LAPACK).
"""
Base.resize!(ws::Workspace, A::AbstractMatrix; kwargs...)

using LinearAlgebra
using LinearAlgebra.LAPACK
n = 10
m = 8

@testset "LU" begin
    for elty in (Float32, Float64, ComplexF32, ComplexF64)
        @testset "$elty" begin
            A0 = randn(elty, n, n)
            B0 = randn(elty, n, m)
            B1 = randn(elty, n, m)

            A = copy(A0)

            # Full matrix
            linws = LUWs(n)

            res = LU(LAPACK.getrf!(linws, copy(A))...)
            F = lu(A0)
            @test F.U ≈ res.U
            @test UpperTriangular(reshape(res.U, n, n)) ≈ F.U
            # Using Workspace, factorize!
            linws = Workspace(LAPACK.getrf!, copy(A))

            res = LU(factorize!(linws, copy(A))...)
            F = lu(A0)
            @test F.U ≈ res.U
            @test UpperTriangular(reshape(res.U, n, n)) ≈ F.U

            @test LAPACK.getrs!('N', res.factors, linws.ipiv, copy(B0)) ==
                  LAPACK.getrs!(linws, 'N', res.factors, copy(B0))

            show(devnull, "text/plain", linws)
            for div in (-1, 1)
                @test_throws FastLapackInterface.WorkspaceSizeError factorize!(
                    linws, rand(elty, n + div, n + div); resize = false)
                factorize!(linws, rand(elty, n + div, n + div))
                @test length(linws.ipiv) == n + div
            end

            # res = LU(LAPACK.getrf!(collect(copy(A)'), linws)...)
            # @test UpperTriangular(reshape(res.U, n, n)) ≈ F.U

            # B = copy(B0)
            # FastLapackInterface.linsolve_core!(A, B, linws)
            # @test A == A0
            # @test B ≈ A \ B0

            # copy!(B, B1)
            # FastLapackInterface.linsolve_core_no_lu!(A, B, linws)
            # @test A == A0
            # @test B ≈ A \ B1

            # copy!(B, B0)
            # FastLapackInterface.linsolve_core!(A', B, linws)
            # @test B ≈ A' \ B0

            # copy!(B, B1)
            # FastLapackInterface.linsolve_core_no_lu!(A', B, linws)
            # @test A == A0
            # @test B ≈ A' \ B1

            # # view of a matrix in upper left corner
            # linws1 = FastLapackInterface.LUWs{elty,Int64}(n - 1)
            # C = view(A, 1:n-1, 1:n-1)
            # D = view(B, 1:n-1, 1:m-1)
            # D0 = copy(D)
            # D1 = copy(D)
            # FastLapackInterface.linsolve_core!(C, D, linws1)
            # @test C == view(A, 1:n-1, 1:n-1)
            # @test D ≈ C \ D0

            # D = copy(D1)
            # FastLapackInterface.linsolve_core_no_lu!(C, D, linws1)
            # @test C == view(A, 1:n-1, 1:n-1)
            # @test D ≈ C \ D1

            # D = copy(D0)
            # FastLapackInterface.linsolve_core!(C', D, linws1)
            # @test C == view(A, 1:n-1, 1:n-1)
            # @test D ≈ C' \ D0

            # D = copy(D1)
            # FastLapackInterface.linsolve_core_no_lu!(C', D, linws1)
            # @test C == view(A, 1:n-1, 1:n-1)
            # @test D ≈ C' \ D1

            # # view of a matrix in lower left corner
            # linws1 = FastLapackInterface.LUWs{elty,Int64}(n - 1)
            # C = view(A, 2:n, 1:n-1)
            # C1 = copy(C)
            # FastLapackInterface.lu!(C1, linws1)
            # F = LinearAlgebra.lu!(C)
            # @test triu(reshape(linws1.lu, n - 1, n - 1)) ≈ F.U
            # @test tril(reshape(linws1.lu, n - 1, n - 1), -1) ≈ tril(F.L, -1)

            # D0 = view(B0, 2:n, 1:m-1)
            # D1 = view(B1, 2:n, 1:m-1)
            # D = copy(D0)
            # FastLapackInterface.linsolve_core!(C, D, linws1)
            # @test C == view(A, 2:n, 1:n-1)
            # @test D ≈ C \ D0

            # D = copy(D1)
            # FastLapackInterface.linsolve_core_no_lu!(C, D, linws1)
            # @test C == view(A, 2:n, 1:n-1)
            # @test D ≈ C \ D1

            # D = copy(D0)
            # FastLapackInterface.linsolve_core!(C', D, linws1)
            # @test C == view(A, 2:n, 1:n-1)
            # @test D ≈ C' \ D0

            # D = copy(D1)
            # FastLapackInterface.linsolve_core_no_lu!(C', D, linws1)
            # @test C == view(A, 2:n, 1:n-1)
            # @test D ≈ C' \ D1

            # # using too big a work space
            # linws1 = FastLapackInterface.LUWs{elty,Int64}(n)
            # C = view(A, 2:n, 1:n-1)
            # C1 = copy(C)
            # FastLapackInterface.lu!(C1, linws1)
            # F = LinearAlgebra.lu!(C)
            # @test triu(reshape(linws1.lu[1:(n-1)^2], n - 1, n - 1)) ≈ F.U
            # @test tril(reshape(linws1.lu[1:(n-1)^2], n - 1, n - 1), -1) ≈ tril(F.L, -1)

            # D0 = view(B0, 2:n, 1:m-1)
            # D1 = view(B1, 2:n, 1:m-1)
            # D = copy(D0)
            # FastLapackInterface.linsolve_core!(C, D, linws1)
            # @test C == view(A, 2:n, 1:n-1)
            # @test D ≈ C \ D0

            # D = copy(D1)
            # FastLapackInterface.linsolve_core_no_lu!(C, D, linws1)
            # @test C == view(A, 2:n, 1:n-1)
            # @test D ≈ C \ D1

            # D = copy(D0)
            # FastLapackInterface.linsolve_core!(C', D, linws1)
            # @test C == view(A, 2:n, 1:n-1)
            # @test D ≈ C' \ D0

            # D = copy(D1)
            # FastLapackInterface.linsolve_core_no_lu!(C', D, linws1)
            # @test C == view(A, 2:n, 1:n-1)
            # @test D ≈ C' \ D1
        end
    end
end

using Test
using FastLapackInterface
using LinearAlgebra.LAPACK

@testset "LSEWs" begin
    n = 16
    m = 8
    p = 10
    for T in (Float32, Float64, ComplexF32, ComplexF64)
        @testset "$T" begin
            A0 = rand(T, m, n)
            B0 = rand(T, p, n)
            c0 = rand(T, m)
            d0 = rand(T, p)
            ws = LSEWs(A0, B0)
            @testset "gglse!" begin
                A = copy(A0)
                B = copy(B0)
                c = copy(c0)
                d = copy(d0)
                X1, err1 = LAPACK.gglse!(copy(A0), copy(c0), copy(B0), copy(d0))
                X2, err2 = LAPACK.gglse!(ws, copy(A0), copy(c0), copy(B0), copy(d0))

                @test isapprox(X1, X2)
                @test isapprox(err1, err2)
                # using Workspace, factorize!
                ws = Workspace(LAPACK.gglse!, copy(A0))
                X2, err2 = factorize!(ws, copy(A0), copy(c0), copy(B0), copy(d0))

                @test isapprox(X1, X2)
                for div in (-1, 1)
                    @test_throws FastLapackInterface.WorkspaceSizeError factorize!(
                        ws, rand(T, m, n + div), copy(c0),
                        rand(T, p + div, n + div), rand(T, p + div); resize = false)
                    factorize!(ws, rand(T, m, n + div), copy(c0),
                        rand(T, p + div, n + div), rand(T, p + div))
                    @test size(ws.X, 1) == n + div
                    @test size(ws.work, 1) >=
                          p + div + min(m, n + div) + max(m, n + div) * 32
                end
            end
        end
    end
end

module BenchSchur
using BenchmarkTools
using FastLapackInterface
using LinearAlgebra, LinearAlgebra.LAPACK

const sizes = (3, 4, 5, 10, 50, 100)
const vector_length = 100

const suite = BenchmarkGroup()

#### SchurWs

suite["SchurWs"] = BenchmarkGroup()
suite["SchurWs"]["creation"] = BenchmarkGroup()

for n in sizes
    A = rand(n, n)
    suite["SchurWs"]["creation"]["$n"] = @benchmarkable SchurWs($A)
end

suite["SchurWs"]["gees!"] = BenchmarkGroup()
suite["SchurWs"]["gees!"]["workspace"] = BenchmarkGroup()
suite["SchurWs"]["gees!"]["workspace_select"] = BenchmarkGroup()
suite["SchurWs"]["gees!"]["LAPACK"] = BenchmarkGroup()

function bench_gees!(As, ws)
    for A in As
        LAPACK.gees!(ws, 'V', A)
    end
end
function bench_gees!(sel_func, As, ws)
    for A in As
        LAPACK.gees!('V', A, ws; select = sel_func)
    end
end
function bench_gees!(As)
    for A in As
        LAPACK.gees!('V', A)
    end
end

for n in sizes
    As = [rand(n, n) for i in 1:vector_length]
    ws = SchurWs(As[1])
    suite["SchurWs"]["gees!"]["workspace"]["$n"] = @benchmarkable bench_gees!($As, $ws)
    sel_func = FastLapackInterface.gees_default_select()
    suite["SchurWs"]["gees!"]["workspace_select"]["$n"] = @benchmarkable bench_gees!(
        $sel_func,
        $As,
        $ws)
    suite["SchurWs"]["gees!"]["LAPACK"]["$n"] = @benchmarkable bench_gees!($As)
end

#### GeneralizedSchurWs

suite["GeneralizedSchurWs"] = BenchmarkGroup()
suite["GeneralizedSchurWs"]["creation"] = BenchmarkGroup()

for n in sizes
    A = rand(n, n)
    suite["GeneralizedSchurWs"]["creation"]["$n"] = @benchmarkable GeneralizedSchurWs($A)
end

suite["GeneralizedSchurWs"]["gges!"] = BenchmarkGroup()
suite["GeneralizedSchurWs"]["gges!"]["workspace"] = BenchmarkGroup()
suite["GeneralizedSchurWs"]["gges!"]["workspace_select"] = BenchmarkGroup()
suite["GeneralizedSchurWs"]["gges!"]["LAPACK"] = BenchmarkGroup()

function bench_gges!(As, ws)
    for A in As
        LAPACK.gges!(ws, 'V', 'V', A, A)
    end
end
function bench_gges!(sel_func, As, ws)
    for A in As
        LAPACK.gges!(ws, 'V', 'V', A, A; select = sel_func)
    end
end
function bench_gges!(As)
    for A in As
        LAPACK.gges!('V', 'V', A, A)
    end
end

for n in sizes
    As = [rand(n, n) for i in 1:vector_length]
    ws = GeneralizedSchurWs(As[1])
    suite["GeneralizedSchurWs"]["gges!"]["workspace"]["$n"] = @benchmarkable bench_gges!(
        $As,
        $ws)
    sel_func = FastLapackInterface.gges_default_select()
    suite["GeneralizedSchurWs"]["gges!"]["workspace_select"]["$n"] = @benchmarkable bench_gges!(
        $sel_func,
        $As,
        $ws)
    suite["GeneralizedSchurWs"]["gges!"]["LAPACK"]["$n"] = @benchmarkable bench_gges!($As)
end

end
BenchSchur.suite

module BenchQR
using BenchmarkTools
using FastLapackInterface
using LinearAlgebra, LinearAlgebra.LAPACK

const sizes = (3, 4, 5, 10, 50, 100)
const vector_length = 100

const suite = BenchmarkGroup()

suite["QRWs"] = BenchmarkGroup()
suite["QRWs"]["creation"] = BenchmarkGroup()
for n in sizes
    A = rand(n, n)
    suite["QRWs"]["creation"]["$n"] = @benchmarkable QRWs($A)
end
suite["QRWs"]["geqrf!"] = BenchmarkGroup()
suite["QRWs"]["geqrf!"]["workspace"] = BenchmarkGroup()
suite["QRWs"]["geqrf!"]["LAPACK"] = BenchmarkGroup()

function bench_geqrf!(As, ws)
    for A in As
        LAPACK.geqrf!(ws, A)
    end
end
function bench_geqrf!(As)
    for A in As
        LAPACK.geqrf!(A)
    end
end

for n in sizes
    As = [rand(n, n) for i in 1:vector_length]
    ws = QRWs(As[1])
    suite["QRWs"]["geqrf!"]["workspace"]["$n"] = @benchmarkable bench_geqrf!($As, $ws)
    suite["QRWs"]["geqrf!"]["LAPACK"]["$n"] = @benchmarkable bench_geqrf!($As)
end
suite["QRWs"]["ormqr!"] = BenchmarkGroup()
suite["QRWs"]["ormqr!"]["workspace"] = BenchmarkGroup()
suite["QRWs"]["ormqr!"]["LAPACK"] = BenchmarkGroup()
function bench_ormqr!(As, ws::QRWs)
    for A in As
        LAPACK.ormqr!(ws, 'L', 'N', A, A)
    end
end
function bench_ormqr!(As, τ::Vector)
    for A in As
        LAPACK.ormqr!('L', 'N', A, τ, A)
    end
end

for n in sizes
    As = [rand(n, n) for i in 1:vector_length]
    ws = QRWs(As[1])
    LAPACK.geqrf!(ws, As[1])
    τ = copy(ws.τ)
    suite["QRWs"]["ormqr!"]["workspace"]["$n"] = @benchmarkable bench_ormqr!($As, $ws)
    suite["QRWs"]["ormqr!"]["LAPACK"]["$n"] = @benchmarkable bench_ormqr!($As, $τ)
end

####### QRWYWs

suite["QRWYWs"] = BenchmarkGroup()
suite["QRWYWs"]["creation"] = BenchmarkGroup()
for n in sizes
    suite["QRWYWs"]["creation"]["$n"] = @benchmarkable QRWYWs(A) setup=(A = rand($n, $n))
end

suite["QRWYWs"]["geqrt!"] = BenchmarkGroup()
suite["QRWYWs"]["geqrt!"]["workspace"] = BenchmarkGroup()
suite["QRWYWs"]["geqrt!"]["LAPACK"] = BenchmarkGroup()

function bench_geqrt!(As, ws)
    for A in As
        LAPACK.geqrt!(ws, A)
    end
end
function bench_geqrt!(As, T::Matrix)
    for A in As
        LAPACK.geqrt!(A, T)
    end
end

for n in sizes
    As = [rand(n, n) for i in 1:vector_length]
    T = rand(n, n)
    ws = QRWYWs(As[1])

    suite["QRWYWs"]["geqrt!"]["workspace"]["$n"] = @benchmarkable bench_geqrt!($As, $ws)
    suite["QRWYWs"]["geqrt!"]["LAPACK"]["$n"] = @benchmarkable bench_geqrt!($As, $T)
end

###### QRPivotedWs

suite["QRPivotedWs"] = BenchmarkGroup()
suite["QRPivotedWs"]["creation"] = BenchmarkGroup()
for n in sizes
    suite["QRPivotedWs"]["creation"]["$n"] = @benchmarkable QRWYWs(A) setup=(A = rand(
        $n, $n))
end

for n in sizes
    suite["QRPivotedWs"]["creation"]["$n"] = @benchmarkable QRWYWs(A) setup=(A = rand(
        $n, $n))
end

suite["QRPivotedWs"]["geqp3!"] = BenchmarkGroup()
suite["QRPivotedWs"]["geqp3!"]["workspace"] = BenchmarkGroup()
suite["QRPivotedWs"]["geqp3!"]["LAPACK"] = BenchmarkGroup()

function bench_geqp3!(As, ws)
    for A in As
        LAPACK.geqp3!(ws, A)
    end
end
function bench_geqp3!(As, lpvt, τ)
    for A in As
        LAPACK.geqp3!(A, lpvt, τ)
    end
end

for n in sizes
    As = [rand(n, n) for i in 1:vector_length]
    τ = zeros(n)
    lpvt = zeros(Int, n)
    ws = QRPivotedWs(As[1])

    suite["QRPivotedWs"]["geqp3!"]["workspace"]["$n"] = @benchmarkable bench_geqp3!(
        $As, $ws)
    suite["QRPivotedWs"]["geqp3!"]["LAPACK"]["$n"] = @benchmarkable bench_geqp3!(
        $As, $lpvt, $τ)
end

end
BenchQR.suite

module FastLapackInterface

import Base.strides

using Base: require_one_based_indexing
using LinearAlgebra
using LinearAlgebra: BlasInt, BlasFloat, checksquare, chkstride1
using LinearAlgebra.BLAS: @blasfunc
using LinearAlgebra.LAPACK: chklapackerror, chkargsok, chkstride1, chktrans, chkside
using LinearAlgebra.LAPACK

@static if VERSION < v"1.7"
    using LinearAlgebra.LAPACK: liblapack
elseif VERSION < v"1.9"
    const liblapack = "libblastrampoline"
else
    const liblapack = LinearAlgebra.libblastrampoline
end

abstract type Workspace end
include("exceptions.jl")
include("lu.jl")
export LUWs
include("qr.jl")
export QRWs, QRWYWs, QRPivotedWs, QROrmWs, QROrgWs
include("schur.jl")
export SchurWs, GeneralizedSchurWs
include("eigen.jl")
export EigenWs, HermitianEigenWs, GeneralizedEigenWs
include("bunch_kaufman.jl")
export BunchKaufmanWs
include("cholesky.jl")
export CholeskyPivotedWs
include("lse.jl")
export LSEWs
include("svd.jl")
export SVDsddWs, SVDsvdWs, GeneralizedSVDWs

# Uniform interface
include("workspace.jl")
export Workspace
export decompose!, factorize!

end #module

# [Fast Lapack Interface](@id man-fastlapack)
The goal of `FastLapackInterface` is to eliminate any temporary allocations when using certain [`LAPACK functions`](@ref LAPACK) compared to Base julia. This is achieved by providing some [`Workspaces`](@ref WorkSpaces) that can then be used during the computation of [`LAPACK functions`](@ref LAPACK).
Eliminating most of the allocations not only improves the computation time of the functions, but dramatically improves `GC` impact when performing multithreaded workloads.

```@meta
DocTestSetup = quote
    using LinearAlgebra, FastLapackInterface
    using LinearAlgebra: LAPACK
end
```

# [Workspaces](@id WorkSpaces)
`Workspaces` represent the buffers and temporary storage that are used during the computations of [`LAPACK functions`](@ref LAPACK).
Upon initialization with a template matrix, work buffers will be allocated that are appropriate to be used during the factorization of matrices similar to the template, e.g. both `Float64` and `Float32` Matrices work, but also `Complex` numbers are allowed when appropriate.

## Workspace
The following convenience function is supplied in order to construct the correct `Workspace` for a given [`LAPACK function`](@ref LAPACK).
This can then be used to perform the decompositions without extra allocations.
```@docs
Workspace
```
Each [`Workspace`](@ref) also has a function to [`resize!`](@ref) to allow for its use with larger matrices or with more features (e.g. the computation of left eigenvectors and right eigenvectors using [`EigenWs`](@ref)).
```@docs
resize!(::Workspace, ::AbstractMatrix; kwargs...)
```

## [BunchKaufman](@id BunchKaufman-id)
```@docs
BunchKaufmanWs
```

## [Cholesky](@id Cholesky-id)
```@docs
CholeskyPivotedWs
```

## [Eigen](@id Eigen-id)
```@docs
EigenWs
HermitianEigenWs
GeneralizedEigenWs
```

## [LSE](@id LSE-id)
```@docs
LSEWs
```

## [LU](@id LU-id)
```@docs
LUWs
```

## [QR](@id QR-id)
```@docs
QRWs
QRWYWs
QRPivotedWs
QROrmWs
QROrgWs
```

## [Schur](@id Schur-id)
```@docs
SchurWs
GeneralizedSchurWs
```

## [SVD](@id SVD-id)
```@docs
SVDsddWs
SVDsddWs(::AbstractMatrix; job::AbstractChar)
SVDsvdWs
SVDsvdWs(::AbstractMatrix; jobu::AbstractChar, jobv::AbstractChar)
GeneralizedSVDWs
GeneralizedSVDWs(::AbstractMatrix; job::AbstractChar, jobv::AbstractChar, jobq::AbstractChar)
```

# [LAPACK](@id LAPACK)
This section details the [`LAPACK
functions`](https://docs.julialang.org/en/v1/stdlib/LinearAlgebra/#LinearAlgebra.LAPACK)
that are supported for use with various [`Workspaces`](@ref
WorkSpaces). Each function has a `resize` keyword argument that is
`true` by default, allowing for automatic resizing of the workspaces
to accomodate larger or smaller Matrices or different features than they were
originally constructed for. This is provided as a convenience but
involves an efficiency cost. When working with matrices of different sizes,
the best strategy is to successively apply a function to all matrices of the same
size and to minimize triggering the resizing mechanism.

## Unified Interface
After having created the [`Workspace`](@ref WorkSpaces) that corresponds to the targeted factorization or decomposition,
one of the following two _aliases_ can be used to dispatch the call to the correct LAPACK function.

```@docs
decompose!
factorize!
```

## BunchKaufman
```@docs
LinearAlgebra.LAPACK.sytrf!(::BunchKaufmanWs, ::AbstractChar, ::AbstractMatrix)
LinearAlgebra.LAPACK.sytrf_rook!(::BunchKaufmanWs, ::AbstractChar, ::AbstractMatrix)
LinearAlgebra.LAPACK.hetrf!(::BunchKaufmanWs, ::AbstractChar, ::AbstractMatrix)
LinearAlgebra.LAPACK.hetrf_rook!(::BunchKaufmanWs, ::AbstractChar, ::AbstractMatrix)
```

## Cholesky
```@docs
LinearAlgebra.LAPACK.pstrf!(::CholeskyPivotedWs, ::AbstractChar, ::AbstractMatrix, ::Real)
```

## Eigen
```@docs
LinearAlgebra.LAPACK.geevx!(::EigenWs, ::AbstractChar, ::AbstractChar, ::AbstractChar, ::AbstractChar, ::AbstractMatrix)
LinearAlgebra.LAPACK.syevr!(::HermitianEigenWs, ::AbstractChar, ::AbstractChar,
       ::AbstractChar, ::AbstractMatrix, ::AbstractFloat, ::AbstractFloat, ::Integer, ::Integer,
       ::AbstractFloat)
LinearAlgebra.LAPACK.ggev!(::GeneralizedEigenWs, ::AbstractChar, ::AbstractChar, ::AbstractMatrix,
      ::AbstractMatrix)
```

## LSE
```@docs
LinearAlgebra.LAPACK.gglse!(::LSEWs, ::AbstractMatrix, ::AbstractVector, ::AbstractMatrix, ::AbstractVector)
```

## LU
```@docs
LinearAlgebra.LAPACK.getrf!(::LUWs, ::AbstractMatrix)
LinearAlgebra.LAPACK.getrs!(::LUWs, ::AbstractChar, ::AbstractMatrix, ::AbstractMatrix)
```

## QR
```@docs
LinearAlgebra.LAPACK.geqrf!(::QRWs, ::AbstractMatrix)
LinearAlgebra.LAPACK.geqrt!(::QRWYWs, ::AbstractMatrix)
LinearAlgebra.LAPACK.geqp3!(::QRPivotedWs, ::AbstractMatrix)
LinearAlgebra.LAPACK.ormqr!(::QROrmWs, ::AbstractChar, ::AbstractChar, ::AbstractMatrix, ::AbstractVecOrMat)
LinearAlgebra.LAPACK.orgqr!(::QRWs, ::AbstractMatrix, ::Integer)
```

## Schur
```@docs
LinearAlgebra.LAPACK.gees!(::SchurWs, ::AbstractChar, ::AbstractMatrix)
LinearAlgebra.LAPACK.gges!(::GeneralizedSchurWs, ::AbstractChar, ::AbstractChar, ::AbstractMatrix, ::AbstractMatrix)
FastLapackInterface.SCHURORDER
```

## SVD
```@docs
LinearAlgebra.LAPACK.gesdd!(::SVDsddWs, ::AbstractChar, ::AbstractMatrix)
LinearAlgebra.LAPACK.gesvd!(::SVDsvdWs, ::AbstractChar, ::AbstractChar, ::AbstractMatrix)
LinearAlgebra.LAPACK.ggsvd3!(::GeneralizedSVDWs, ::AbstractChar, ::AbstractChar, ::AbstractChar, ::AbstractMatrix, ::AbstractMatrix)
```
